using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;
using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;

namespace ProgramDB
{
    public partial class CeleWyjazdPojazdPrywat : Form, InterfaceClass.ITakeDataWithID
    {
        public CeleWyjazdPojazdPrywat()
        {
            InitializeComponent();

            this.listView1.DrawSubItem += new System.Windows.Forms.DrawListViewSubItemEventHandler(MethodsClass.ownListViewDrawSubItem);
            this.listView1.DrawColumnHeader += new System.Windows.Forms.DrawListViewColumnHeaderEventHandler(MethodsClass.ownListViewDrawColumnHeader);
        }

        public int PobierzIDInt()
        { // return ID  
            int id = 0;                                         
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = "uspGetCeleWyjazdID";
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.AddWithValue("CelWyjazdPojPryw", listView1.SelectedItems[0].SubItems[0].Text);
                conn.Open();
                id = Convert.ToInt32(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return id;
        }

        public int PobierzLpInt()
        { // return ID  
            int id = 0;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = "uspGetCeleWyjazdLp";
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.AddWithValue("CelWyjazdPojPryw", listView1.SelectedItems[0].SubItems[0].Text);
                conn.Open();
                id = Convert.ToInt32(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return id;
        }
       
        public void EdytujOK(params object[] text)
        { // zapisujemy zmiany w edytowanym Celu Wyjazdow Pojazdw Prywatnych
            listView1.SelectedItems[0].SubItems[0].Text = text[1].ToString();
            //---
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = "uspUpdateCeleWyjazdPojPrywTabela";
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.Add("CelWyjazdPojPryw", SqlDbType.NVarChar, 50).Value = text[1];
                command.Parameters.Add("CeleWyjazdID", SqlDbType.Int).Value = text[0];
                conn.Open();
                command.ExecuteNonQuery();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
        }

        public void Dodaj(params object[] text)
        {  // Dodajemy jednej cel wyjazdow
            listView1.Items.Add(new ListViewItem(new string[] { text[0].ToString() }));
            //---
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = "uspInsertRowInCeleWyjazdPojPrywTabela";
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.Add("CeleWyjazdPojPryw", SqlDbType.NVarChar, 50).Value = text[0];
                conn.Open();
                command.ExecuteNonQuery();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
        }

        private void CeleWyjazdPojazdPrywat_Load(object sender, EventArgs e)
        {  // create table cel wyjazdow if does not exist
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Dana firma nie istnieje", "Bd");
                return;
            }

            if (!MethodsClass.DbTableExists("CeleWyjazdPojPrywTabela", MethodsClass.sConnectionString))
            {
                SqlConnection conn=null;
                try
                {
                    FileInfo file = new FileInfo("../../../SqlServerProject/CreateTableCeleWyjazdPojPryw.sql");
                    string script = file.OpenText().ReadToEnd();
                    conn = new SqlConnection(MethodsClass.sConnectionString);
                    Server server = new Server(new ServerConnection(conn));
                    server.ConnectionContext.ExecuteNonQuery(script);
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MethodsClass.SqlExceptionFunction(ex);
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
                finally
                {
                    MethodsClass.FinallyExceptionFunction(conn);
                }
            }
            listView1.Items.Clear();
            
            MethodsClass.ExeReaderListViewString(listView1, "SELECT CelWyjazdPojPryw FROM CeleWyjazdPojPrywTabela");
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NowyCel nowyCel = new NowyCel(this, true); // set false when we clicked Nowy button
            if (nowyCel.ShowDialog() == DialogResult.OK)
                nowyCel.Close();
        }

        private void Edytuj_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyWybranaPozycja(listView1))
            {
                NowyCel edytujCel = new NowyCel(this, false); // set false when we clicked Edytuj button
                edytujCel.Text = "Edycja celu";
                edytujCel.Edytuj(listView1.SelectedItems[0].SubItems[0].Text);
                if (edytujCel.ShowDialog() == DialogResult.OK)
                    edytujCel.Close();
            }
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyWybranaPozycja(listView1) && MethodsClass.CzyUsunac())
            {
                string query = "DELETE FROM CeleWyjazdPojPrywTabela WHERE CeleWyjazdID='" + PobierzIDInt() + "'";
                MethodsClass.UsunPozycje(query, listView1);
            }             
        }

        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            int pozycja = PobierzLpInt() - 1;
            listView1.Items[pozycja].ForeColor = Color.Blue;
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                if (i != pozycja)
                listView1.Items[i].ForeColor = Color.Black;
            }
            Edytuj_Click(sender, e);            
        }

        private void listView1_MouseClick(object sender, MouseEventArgs e)
        {
            int pozycja = PobierzLpInt() - 1;
            listView1.Items[pozycja].ForeColor = Color.Blue;
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                if (i != pozycja)
                    listView1.Items[i].ForeColor = Color.Black;
            }
        }
    }
}