using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Drawing.Printing;

namespace ProgramDB
{
    public partial class DowodyWewnetrzne : Form, InterfaceClass.ITakeData
    {
        private DataGridViewPrinter MyDataGridViewPrinter;
        private string[] sqlData ={ "Nr dowodu", "Data dowodu", "Uwagi", "Nazwa towaru", 
            "Ilo", "Jednostka miary", "Cena jednostkowa", "Warto" };
        public DowodyWewnetrzne()
        {
            InitializeComponent();
        }

        private int WybranyWiersz
        {
            get
            {
                return ownDataGridView1.SelectedRows[0].Index; // return selected row
            }
        }
        
        public int SelectRowIDFromDatabase()
        {
            return MethodsClass.ExeStoredProcedureRetInt("uspGetDowodyWewnetrzneID",
new string[] { "NrDowodu", "DataDowodu", "Uwagi", "NazwaTowaru", "Ilosc", "JednostkaMiary", "CenaJednostkowa", "Wartosc" },
new object[] { ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[4]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[7]].Value });
        }

        public void EdytujOK(params object[] text)
        { // Zapisujemy zmiany w edytowym dowodzie wewnetrznym 
            int i = 0;
            int ww = WybranyWiersz;
            for (; i < sqlData.Length - 1; i++)
            {
                ownDataGridView1.Rows[ww].Cells[sqlData[i]].Value = text[i];
            }
            ownDataGridView1.Rows[ww].Cells[sqlData[i]].Value = text[i];   
        }

        public void Dodaj(params object[] text)
        {  // Dodajemy jeden dowd wewnetrzny 
            DataRow myDataRow = dataSet1.Tables["DowodyWewnetrzneTabela"].NewRow();
            int i = 0;
            for (; i < sqlData.Length; i++)
            {
                if (i != 0)
                    myDataRow[sqlData[i]] = text[i];
                else
                    myDataRow[sqlData[i]] = (text[i] == null) ? null : text[i];
            }
            myDataRow["zaksiegowane"] = 0;
            dataSet1.Tables["DowodyWewnetrzneTabela"].Rows.Add(myDataRow);
            ownDataGridView1.Rows[ownDataGridView1.Rows.Count-2].Cells["Zaksigowane"].Value = "Nie";
        }

        private void DowodyWewnetrzne_Load(object sender, EventArgs e)
        { // create table DowodyWewnetrzne if does not exist
            if (!MethodsClass.DbTableExists("DowodyWewnetrzneTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE DowodyWewnetrzneTabela (DowodyWewnetrzneID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY," + "NrDowodu INT NULL, DataDowodu DATETIME NOT NULL, Uwagi NVARCHAR(50) NULL, " +
"NazwaTowaru NVARCHAR(50) NULL, Ilosc DECIMAL(10, 2) NULL, JednostkaMiary NVARCHAR(50) NULL, CenaJednostkowa MONEY NULL, Wartosc MONEY NULL )";
                MethodsClass.ExeNonQuery(sCreateTable);
            }

            this.sqlDataAdapter1.Fill(this.dataSet1, "DowodyWewnetrzneTabela");
            ownDataGridView1.DataSource = dataSet1.Tables["DowodyWewnetrzneTabela"];
            ownDataGridView1.Columns[0].Visible = false;
            ownDataGridView1.Columns["zaksiegowane"].Visible = false;
            ownDataGridView1.Columns["Uwagi"].DisplayIndex = 7;
            ownDataGridView1.Columns.Add("Zaksigowane", "Zaksigowane");
            for (int i = 0; i < ownDataGridView1.Rows.Count - 1; i++)
                ownDataGridView1.Rows[i].Cells["Zaksigowane"].Value = (Convert.ToInt32(ownDataGridView1.Rows[i].Cells["zaksiegowane"].Value)==1) ? "Tak" : "Nie"; 

            MethodsClass.SetDateFormatDataGridView(ownDataGridView1, sqlData[1]);
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, sqlData[4]);
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, sqlData[6]);
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, sqlData[7]);

            ownDataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            ownDataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            ownDataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            ownDataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            ownDataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            ownDataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            ownDataGridView1.GridColor = SystemColors.ControlDarkDark;
            ownDataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);

            ownDataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NowyDowodWewnetrzny nowyDowodWewnetrzny = new NowyDowodWewnetrzny(this, true); // set false when we clicked Nowy button
            if (nowyDowodWewnetrzny.ShowDialog()==DialogResult.OK)
                nowyDowodWewnetrzny.Close();
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(ownDataGridView1))
                {
                    if (ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        ownDataGridView1.Rows.Remove(ownDataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }
            }
        }

        private void DowodyWewnetrzne_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.F2:
                    Nowy_Click(null, null);
                    break;
                case Keys.F3:
                    Ksieguj_Click(null, null);
                    break;
                case Keys.F4:
                    drukuj_Click(null, null);
                    break;
                case Keys.F8:
                    Usun_Click(null, null);
                    break;
                case Keys.F10:
                    Wyjscie_Click(null, null);
                    Close();
                    break;
                default:
                    break;
            }
        }

        private void Wyjscie_Click(object sender, EventArgs e)
        { // save changed 
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
                sqlDataAdapter1.Update(dataSet1, "DowodyWewnetrzneTabela");
        }

        private void ownDataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(ownDataGridView1))
            {
                if (ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    NowyDowodWewnetrzny edytujDowodWewnetrzny = new NowyDowodWewnetrzny(this, false); // set false when we clicked Edytuj button
                    edytujDowodWewnetrzny.Text = "Edycja dowodu ksigowego";
                    edytujDowodWewnetrzny.Edytuj(ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[4]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[7]].Value);
                    if (edytujDowodWewnetrzny.ShowDialog() == DialogResult.OK)
                        edytujDowodWewnetrzny.Close();
                }
            } 
        }

        private void Ksieguj_Click(object sender, EventArgs e)
        {
            if (ownDataGridView1.Rows[WybranyWiersz].Cells["Zaksigowane"].Value.ToString() == "Tak")
            {
                MethodsClass.MesBoxShowInformation("Wybrana pozycja bya ju zaksigowana", "Informacja");
            }
            else
                if (MethodsClass.ifSelectedRow(ownDataGridView1))
                {
                    if (ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        Wyjscie_Click(sender, e);

                        NowyWprowadzanyDokument nowyWprowDokum = new NowyWprowadzanyDokument(new WprowadzanieDokumentow(), 2, Convert.ToDecimal(ownDataGridView1.Rows[WybranyWiersz].Cells["Warto"].Value), SelectRowIDFromDatabase()); 
                        // first value is object from which we call form; second value if equal: 0 - call NowyWprowadzanyDokument previously entered data, 
                        // 1 - call empty NowyWprowadzanyDokument Form, 2 - call NowyWprowadzanyDokument from DowodyWewnetrzne form, 3 - call NowyWprowadzanyDokument from EwidencjaSprzeday form, 
                        //4 - call NowyWprowadzanyDokument from EwidencjaWyposazenia form; third value set sum of value; four value set selected row

                        if (nowyWprowDokum.ShowDialog() == DialogResult.OK)
                            nowyWprowDokum.Close();

                        if (MethodsClass.ifPressOKButtonInNowyWprowDokum)
                        {
                            ownDataGridView1.Rows[WybranyWiersz].Cells["Zaksigowane"].Value = "Tak";

                            ownDataGridView1.Refresh();

                            MethodsClass.ExeUspUpdateBooked("uspUpdateBookedCellInDowodyWewnetrzne", "id", ownDataGridView1.Rows[WybranyWiersz].Cells["DowodyWewnetrzneID"].Value, "boolValue", true);
                        }
                    }
                    else
                    {
                        MethodsClass.MesBoxShowError("Wybierz jeden z powyszych wierszy", "Bd");
                    }
                }
                else
                {
                    MethodsClass.MesBoxShowError("Wybierz jeden wiersz", "Bd");
                }
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = printDocument1;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private void drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            printDocument1.DocumentName = "PrintDocument";
            printDocument1.PrinterSettings = MyPrintDialog.PrinterSettings;
            printDocument1.DefaultPageSettings = MyPrintDialog.PrinterSettings.DefaultPageSettings;
            printDocument1.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, printDocument1, true, true, "Dowody wewntrzne", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, printDocument1, false, true, "Dowody wewntrzne", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);

            return true;
        }
    }
}