using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Drawing.Printing;

namespace ProgramDB
{
    public partial class EwidencjaKosztowPojazdow : Form
    {
        private DataGridViewPrinter MyDataGridViewPrinter;
        public EwidencjaKosztowPojazdow()
        {
            InitializeComponent();

            sqlCommand1.Parameters.Add("@monthCheck", SqlDbType.Bit);
            sqlCommand1.Parameters.Add("@month", SqlDbType.Int);
            sqlCommand1.Parameters.Add("@vehicleCheck", SqlDbType.Bit);
            sqlCommand1.Parameters.Add("@vehicle", SqlDbType.VarChar);
        }

        public void FiltrEwidenKosztPojazd(params object[] text)
        {
            dataSet1.Clear();

            sqlCommand1.Parameters["@monthCheck"].Value = text[0];
            sqlCommand1.Parameters["@month"].Value = MethodsClass.DictionaryMonthStringToInt(text[1].ToString()); // set number of month
            sqlCommand1.Parameters["@vehicleCheck"].Value = text[2];

            if (text[3].ToString() != "")
                sqlCommand1.Parameters["@vehicle"].Value = MethodsClass.GetTwoCellInFromOneWithSign(text[3], '-')[1]; // set NrRejestracyjny
            else
                sqlCommand1.Parameters["@vehicle"].Value = -1;
            SqlDataAdapter adapter = new SqlDataAdapter(sqlCommand1); 
            adapter.Fill(dataSet1, "KosztyPojazdowView");
            ownDataGridView1.DataSource = dataSet1.Tables["KosztyPojazdowView"];
            
            ownDataGridView1.Columns[0].Visible = false;
            ownDataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void EwidencjaKosztowPojazdow_Load(object sender, EventArgs e)
        {
            this.sqlDataAdapter1.Fill(this.dataSet1, "KosztyPojazdowView");
            ownDataGridView1.DataSource = dataSet1;
            ownDataGridView1.DataMember = "KosztyPojazdowView";

            MethodsClass.SetDateFormatDataGridView(ownDataGridView1, "Dzie ksigowania");
            MethodsClass.SetDateFormatDataGridView(ownDataGridView1, "Data dokumentu");
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, "Warto");
            ownDataGridView1.Columns[0].Visible = false;
            // Setting the style of the DataGridView control
            
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            ownDataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            ownDataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            ownDataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            ownDataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            ownDataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            ownDataGridView1.GridColor = SystemColors.ControlDarkDark;
            ownDataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);

            ownDataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void Filtry_Click(object sender, EventArgs e)
        {
            WybierzFiltrEwidenPojazdow wybierzFiltrPrzebieg = new WybierzFiltrEwidenPojazdow((object)this);
            wybierzFiltrPrzebieg.Text = "Wybierz pojazd oraz miesic";
            if (wybierzFiltrPrzebieg.ShowDialog() == DialogResult.OK)
                wybierzFiltrPrzebieg.Close();
        }

        private void drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                MyPrintDocument.Print();
        }

        private void MyPrintDocument_PrintPage(object sender, PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = MyPrintDocument;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            MyPrintDocument.DocumentName = "PrintDocument";
            MyPrintDocument.PrinterSettings = MyPrintDialog.PrinterSettings;
            MyPrintDocument.DefaultPageSettings =MyPrintDialog.PrinterSettings.DefaultPageSettings;
            MyPrintDocument.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, MyPrintDocument, true, true, "Ewidencja kosztw pojazdw", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, MyPrintDocument, false, true, "Ewidencja kosztw pojazdw", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            
            return true;
        }
    }
}