using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Drawing.Printing;

namespace ProgramDB
{
    public partial class EwidencjaPrzebieguPojazdow : Form, InterfaceClass.ITakeData
    {
        #region Fields
        private DataGridViewPrinter MyDataGridViewPrinter;
        private string comboBoxPojazd;
        private string comboBoxCelWyjazdu;
        private string comboBoxOpisTrasy;
        private string[] sqlData ={ "EwidencjaPrzebieguPojazdowID", "DataWyjazdu", "PojazdyPrywatneID", "CeleWyjazdID", "OpisTrasWyjazdID", "Wartosc", "Uwagi" };
        private string[] sqlDataFiltr ={ "EwidencjaPrzebieguPojazdowID", "Data wyjazdu", "PojazdyPrywatneID", "CeleWyjazdID", "OpisTrasWyjazdID", "Warto", "Uwagi" };
        private bool filtrWlaczony;
        #endregion

        #region Constructors
        public EwidencjaPrzebieguPojazdow()
        {
            InitializeComponent();
            sqlCommand1.Parameters.Add("@monthCheck", SqlDbType.Bit);
            sqlCommand1.Parameters.Add("@month", SqlDbType.Int);
            sqlCommand1.Parameters.Add("@vehicleCheck", SqlDbType.Bit);
            sqlCommand1.Parameters.Add("@vehicle", SqlDbType.VarChar);
        }
        #endregion

        #region Properties
        private int WybranyWiersz
        {
            get
            {
                return dataGridView1.SelectedRows[0].Index; // return selected row
            }
        }

        public DataTable GetTablePojazdyPrywatneTabela()
        {
            return dataSet1.Tables["PojazdyPrywatneTabela"];
        }

        public DataTable GetTableCeleWyjazdPojPrywTabela()
        {
            return dataSet1.Tables["CeleWyjazdPojPrywTabela"];
        }

        public DataTable GetTableOpisTrasWyjazdTabela()
        {
            return dataSet1.Tables["OpisTrasWyjazdTabela"];
        }

        public string ComboBoxPojazd
        {
            get
            {
                return comboBoxPojazd;
            }
        }

        public string ComboBoxCelWyjazdu    
        {
            get
            {
                return comboBoxCelWyjazdu;
            }
        }

        public string ComboBoxOpisTrasy
        {
            get
            {
                return comboBoxOpisTrasy;
            }
        }

        public DataSet GetDataSet
        {
            get
            {
                return dataSet1;
            }
        }
        #endregion

        #region Methods
        public void FiltrEwidenPrzebiegPojazd(params object[] text)
        {
            sdaPojazdyPrywatne.Fill(this.dataSet1, "PojazdyPrywatneTabela");
            sdaCeleWyjazdPojPryw.Fill(this.dataSet1, "CeleWyjazdPojPrywTabela");
            sdaOpisTrasWyjazd.Fill(this.dataSet1, "OpisTrasWyjazdTabela");
            
            filtrWlaczony = true;
            dataSet1.Clear();
            dataGridView1.Columns.Clear();

            sqlCommand1.Parameters["@monthCheck"].Value = text[0];
            sqlCommand1.Parameters["@month"].Value = MethodsClass.DictionaryMonthStringToInt(text[1].ToString()); // set number of month
            sqlCommand1.Parameters["@vehicleCheck"].Value = text[2];

            if (text[3].ToString() != "")
                sqlCommand1.Parameters["@vehicle"].Value = MethodsClass.GetTwoCellInFromOneWithSign(text[3], '-')[1]; // set NrRejestracyjny
            else
                sqlCommand1.Parameters["@vehicle"].Value = -1;
            SqlDataAdapter adapter = new SqlDataAdapter(sqlCommand1);
            adapter.MissingSchemaAction = MissingSchemaAction.AddWithKey;
            DataSet dataSet2 = new DataSet();
            adapter.Fill(dataSet2, "EwidencjaPrzebieguPojazdowTabela");
            dataGridView1.DataSource = dataSet2.Tables["EwidencjaPrzebieguPojazdowTabela"];

            dataGridView1.Columns["EwidencjaPrzebieguPojazdowID"].Visible = false;
            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void AddToGrid()
        {
            dataGridView1.DataSource = dataSet1;
            dataGridView1.DataMember = "EwidencjaPrzebieguPojazdowTabela";
            for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
            {
                dataGridView1.Rows[i].Cells["Lp"].Value = i+1;
                DataColumn[] keys = new DataColumn[2];
                keys[0] = dataSet1.Tables["PojazdyPrywatneTabela"].Columns["PojazdyPrywatneID"];
                dataSet1.Tables["PojazdyPrywatneTabela"].PrimaryKey = keys;
                keys[0] = dataSet1.Tables["CeleWyjazdPojPrywTabela"].Columns["CeleWyjazdID"];
                dataSet1.Tables["CeleWyjazdPojPrywTabela"].PrimaryKey = keys;
                keys[0] = dataSet1.Tables["OpisTrasWyjazdTabela"].Columns["OpisTrasWyjazdID"];
                dataSet1.Tables["OpisTrasWyjazdTabela"].PrimaryKey = keys;

                DataRow findMyRow = dataSet1.Tables["PojazdyPrywatneTabela"].Rows.Find(dataGridView1.Rows[i].Cells[sqlData[2]].Value);
                dataGridView1.Rows[i].Cells["Pojazd"].Value = findMyRow[2];
                findMyRow = dataSet1.Tables["CeleWyjazdPojPrywTabela"].Rows.Find(dataGridView1.Rows[i].Cells[sqlData[3]].Value);
                dataGridView1.Rows[i].Cells["Cel wyjazdu"].Value = findMyRow[1];                
                findMyRow = dataSet1.Tables["OpisTrasWyjazdTabela"].Rows.Find(dataGridView1.Rows[i].Cells[sqlData[4]].Value);
                dataGridView1.Rows[i].Cells["Opis trasy wyjazdu"].Value = findMyRow[1];
                dataGridView1.Rows[i].Cells["Liczba faktycznie przejechanych km"].Value = findMyRow[2];
            }
            dataGridView1.Columns["Lp"].DisplayIndex = 0;
            dataGridView1.Columns[sqlData[1]].DisplayIndex =1;
            dataGridView1.Columns["Pojazd"].DisplayIndex = 2;
            dataGridView1.Columns["Cel wyjazdu"].DisplayIndex = 3;
            dataGridView1.Columns["Opis trasy wyjazdu"].DisplayIndex = 4;
            dataGridView1.Columns["Liczba faktycznie przejechanych km"].DisplayIndex = 5;
            dataGridView1.Columns[sqlData[5]].DisplayIndex = 6;
            dataGridView1.Columns[sqlData[6]].DisplayIndex = 7;

            dataGridView1.Columns[sqlData[0]].Visible = false;
            dataGridView1.Columns[sqlData[2]].Visible = false;
            dataGridView1.Columns[sqlData[3]].Visible = false;
            dataGridView1.Columns[sqlData[4]].Visible = false;

            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[1]);
            MethodsClass.SetMoneyFormatDataGridView(dataGridView1, sqlData[5]);

            dataGridView1.Columns[sqlData[1]].HeaderText = "Data wyjazdu";
            dataGridView1.Columns[sqlData[5]].HeaderText = "Warto";

            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment= DataGridViewContentAlignment.MiddleCenter;
        }

        public void EdytujOK(params object[] text)
        { // Zapisujemy zmiany w edytowanej EwidencjiPrzebieguPojazdu
            DataColumn[] keys = new DataColumn[2];
            keys[0] = dataSet1.Tables["PojazdyPrywatneTabela"].Columns["NazwaPojazdu"];
            dataSet1.Tables["PojazdyPrywatneTabela"].PrimaryKey = keys;
            keys[0] = dataSet1.Tables["CeleWyjazdPojPrywTabela"].Columns["CelWyjazdPojPryw"];
            dataSet1.Tables["CeleWyjazdPojPrywTabela"].PrimaryKey = keys;
            keys[0] = dataSet1.Tables["OpisTrasWyjazdTabela"].Columns["OpisTrasWyjazd"];
            dataSet1.Tables["OpisTrasWyjazdTabela"].PrimaryKey = keys;
            DataRow findMyRow;

            int wybranyWiersz=Convert.ToInt32(text[sqlData.Length - 1]);
            int i = 0;
            for (; i < sqlData.Length - 1; i++)
            {
                if ((i != 1) && (i != 2) && (i != 3))
                    dataGridView1.Rows[wybranyWiersz].Cells[sqlData[i + 1]].Value = text[i];
                else if (i == 1)
                {
                    findMyRow = dataSet1.Tables["PojazdyPrywatneTabela"].Rows.Find(text[1].ToString().Substring(0, text[1].ToString().LastIndexOf("-") - 1));
                    dataGridView1.Rows[wybranyWiersz].Cells[sqlData[i + 1]].Value = findMyRow[0];
                }
                else if (i == 2)
                {
                    findMyRow = dataSet1.Tables["CeleWyjazdPojPrywTabela"].Rows.Find(text[2]);
                    dataGridView1.Rows[wybranyWiersz].Cells[sqlData[i + 1]].Value = findMyRow[0];
                }
                else if (i == 3)
                {
                    findMyRow = dataSet1.Tables["OpisTrasWyjazdTabela"].Rows.Find(text[3]);
                    dataGridView1.Rows[wybranyWiersz].Cells[sqlData[i + 1]].Value = findMyRow[0];
                }
            }

            AddToGrid();
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            printDocument1.DocumentName = "PrintDocument";
            printDocument1.PrinterSettings = MyPrintDialog.PrinterSettings;
            printDocument1.DefaultPageSettings = MyPrintDialog.PrinterSettings.DefaultPageSettings;
            printDocument1.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(dataGridView1, printDocument1, true, true, "Ewidencja przebiegu pojazdw", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(dataGridView1, printDocument1, false, true, "Ewidencja przebiegu pojazdw", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);

            return true;
        }

        public void ExportToExcel(DataGridView grid)
        {
            Microsoft.Office.Interop.Excel.ApplicationClass excelSheet = new Microsoft.Office.Interop.Excel.ApplicationClass();
            excelSheet.Application.Workbooks.Add(true);
            int columnIndex = 0;
            //Columns Heading of Datagridview     
            foreach (DataGridViewColumn column in grid.Columns)
            {
                columnIndex++;
                if ((!column.HeaderText.Equals("EwidencjaPrzebieguPojazdowID")) && (!column.HeaderText.Equals("PojazdyPrywatneID")) && (!column.HeaderText.Equals("CeleWyjazdID")) && (!column.HeaderText.Equals("OpisTrasWyjazdID"))) // write column which I don't want to see in the excel 
                    excelSheet.Cells[1, columnIndex] = column.HeaderText;
                else
                    columnIndex--;
            }
            int rowIndex = 0;
            //get all rows by column wise 
            foreach (DataGridViewRow row in grid.Rows)
            {
                rowIndex++;
                columnIndex = 0;
                foreach (DataGridViewColumn column in grid.Columns)
                {
                    columnIndex++;
                    if ((!column.HeaderText.Equals("EwidencjaPrzebieguPojazdowID")) && (!column.HeaderText.Equals("PojazdyPrywatneID")) && (!column.HeaderText.Equals("CeleWyjazdID")) && (!column.HeaderText.Equals("OpisTrasWyjazdID"))) // write column which I don't want to see in the excel 
                        excelSheet.Cells[rowIndex + 1, columnIndex] = row.Cells[column.Name].FormattedValue;
                    else
                        columnIndex--;
                }
            }
            excelSheet.Visible = true;
            Microsoft.Office.Interop.Excel.Worksheet workSheet = (Microsoft.Office.Interop.Excel.Worksheet)excelSheet.ActiveSheet;
        }

        public void Dodaj(params object[] text)
        {  // Dodajemy jeden wyjazd 
            dataGridView1.DataSource = null;

            DataColumn[] keys = new DataColumn[2];
            keys[0] = dataSet1.Tables["PojazdyPrywatneTabela"].Columns["NazwaPojazdu"];
            dataSet1.Tables["PojazdyPrywatneTabela"].PrimaryKey = keys;
            keys[0] = dataSet1.Tables["CeleWyjazdPojPrywTabela"].Columns["CelWyjazdPojPryw"];
            dataSet1.Tables["CeleWyjazdPojPrywTabela"].PrimaryKey = keys;
            keys[0] = dataSet1.Tables["OpisTrasWyjazdTabela"].Columns["OpisTrasWyjazd"];
            dataSet1.Tables["OpisTrasWyjazdTabela"].PrimaryKey = keys;
            DataRow findMyRow;
 
            DataRow myDataRow = dataSet1.Tables["EwidencjaPrzebieguPojazdowTabela"].NewRow();
            int i = 0;
            for (; i < sqlData.Length-1; i++)
            {
                if ((i != 1) && (i != 2) && (i != 3))
                    myDataRow[sqlData[i + 1]] = text[i];
                else if (i == 1)
                {
                    findMyRow = dataSet1.Tables["PojazdyPrywatneTabela"].Rows.Find(text[1].ToString().Substring(0, text[1].ToString().LastIndexOf("-") - 1));
                    myDataRow[sqlData[i + 1]] = findMyRow[0];
                }
                else if (i == 2)
                {
                    findMyRow = dataSet1.Tables["CeleWyjazdPojPrywTabela"].Rows.Find(text[2]);
                    myDataRow[sqlData[i + 1]] = findMyRow[0];
                }
                else if (i == 3)
                {
                    findMyRow = dataSet1.Tables["OpisTrasWyjazdTabela"].Rows.Find(text[3]);
                    myDataRow[sqlData[i + 1]] = findMyRow[0];
                }
            }
            dataSet1.Tables["EwidencjaPrzebieguPojazdowTabela"].Rows.Add(myDataRow);

            AddToGrid();
        }

        private void EwidencjaPrzebieguPojazdow_Load(object sender, EventArgs e)
        {
            // create table EwidencjaPrzebieguPojazdow if does not exist
            if (!MethodsClass.DbTableExists("EwidencjaPrzebieguPojazdowTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE EwidencjaPrzebieguPojazdowTabela (EwidencjaPrzebieguPojazdowID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY," +
"DataWyjazdu DATETIME NULL, PojazdyPrywatneID INT NOT NULL REFERENCES PojazdyPrywatneTabela (PojazdyPrywatneID), CeleWyjazdID INT NOT NULL REFERENCES CeleWyjazdPojPrywTabela (CeleWyjazdID), OpisTrasWyjazdID INT NOT NULL REFERENCES OpisTrasWyjazdTabela (OpisTrasWyjazdID), Wartosc MONEY NULL, Uwagi NVARCHAR(50) NULL" + ")";
                MethodsClass.ExeNonQuery(sCreateTable);
            }
               
            sdaPojazdyPrywatne.Fill(this.dataSet1, "PojazdyPrywatneTabela");
            sdaCeleWyjazdPojPryw.Fill(this.dataSet1, "CeleWyjazdPojPrywTabela");
            sdaOpisTrasWyjazd.Fill(this.dataSet1, "OpisTrasWyjazdTabela");
            sdaEwidencjaPrzebieguPojazdow.Fill(this.dataSet1, "EwidencjaPrzebieguPojazdowTabela");
            dataSet1.Relations.Add("Ewidencja_Pojazdy", dataSet1.Tables["PojazdyPrywatneTabela"].Columns["PojazdyPrywatneID"],
dataSet1.Tables["EwidencjaPrzebieguPojazdowTabela"].Columns["PojazdyPrywatneID"], false);
            dataSet1.Relations.Add("Ewidencja_Cel", dataSet1.Tables["CeleWyjazdPojPrywTabela"].Columns["CeleWyjazdID"],
dataSet1.Tables["EwidencjaPrzebieguPojazdowTabela"].Columns["CeleWyjazdID"], false);
            dataSet1.Relations.Add("Ewidencja_Opis", dataSet1.Tables["OpisTrasWyjazdTabela"].Columns["OpisTrasWyjazdID"],
dataSet1.Tables["EwidencjaPrzebieguPojazdowTabela"].Columns["OpisTrasWyjazdID"], false);

            dataGridView1.Columns.Add("Lp", "Lp");
            dataGridView1.Columns.Add("Pojazd", "Pojazd");
            dataGridView1.Columns.Add("Cel wyjazdu", "Cel wyjazdu");
            dataGridView1.Columns.Add("Opis trasy wyjazdu", "Opis trasy wyjazdu");
            dataGridView1.Columns.Add("Liczba faktycznie przejechanych km", "Liczba faktycznie przejechanych km");
            dataGridView1.Refresh();

            dataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            dataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            dataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            dataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            dataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            dataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            dataGridView1.GridColor = SystemColors.ControlDarkDark;
            dataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells); 
            
            AddToGrid();
        }
        #endregion

        #region EventHandlers

        private void Nowy_Click(object sender, EventArgs e)
        {
            NowyWyjazd nowyWyjazd = new NowyWyjazd(this, true); // set false when we clicked Nowy button
            if (nowyWyjazd.ShowDialog() == DialogResult.OK)
                nowyWyjazd.Close();
        }

        private void Podglad_Click(object sender, EventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (!filtrWlaczony && dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    NowyWyjazd podgladWyjazd = new NowyWyjazd(this, false); // set false when we clicked Edytuj button
                    podgladWyjazd.Text = "Podgld wprowadzonego wyjazdu";
                    podgladWyjazd.panel1.Enabled = false;
                    comboBoxPojazd = dataGridView1.Rows[WybranyWiersz].Cells["Pojazd"].Value.ToString();
                    comboBoxCelWyjazdu = dataGridView1.Rows[WybranyWiersz].Cells["Cel wyjazdu"].Value.ToString();
                    comboBoxOpisTrasy = dataGridView1.Rows[WybranyWiersz].Cells["Opis trasy wyjazdu"].Value.ToString();
                    podgladWyjazd.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells["Liczba faktycznie przejechanych km"].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value, WybranyWiersz);
                    if (podgladWyjazd.ShowDialog() == DialogResult.OK)
                        podgladWyjazd.Close();
                }
            }
        }

        private void Suma_Click(object sender, EventArgs e)
        {
            SumaEwidenPrzebiegPojazdow sumaEwidenPojazdow = new SumaEwidenPrzebiegPojazdow();
            if (sumaEwidenPojazdow.ShowDialog() == DialogResult.OK)
                sumaEwidenPojazdow.Close();
        }

        private void Filtry_Click(object sender, EventArgs e)
        {
            WybierzFiltrEwidenPojazdow wybierzFiltrPrzebieg = new WybierzFiltrEwidenPojazdow((object)this);
            if (wybierzFiltrPrzebieg.ShowDialog() == DialogResult.OK)
                wybierzFiltrPrzebieg.Close();
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(dataGridView1))
                {
                    if (dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        dataGridView1.Rows.Remove(dataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }
            }
        }
        
        private void Wyjscie_Click(object sender, EventArgs e)
        {
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
                sdaEwidencjaPrzebieguPojazdow.Update(dataSet1);
        }

        private void dataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (!filtrWlaczony && dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].ToString() != "") // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    NowyWyjazd edytujWyjazd = new NowyWyjazd(this, false); // set false when we clicked Edytuj button
                    edytujWyjazd.Text = "Edycja wprowadzonego wyjazdu";
                    comboBoxPojazd = dataGridView1.Rows[WybranyWiersz].Cells["Pojazd"].Value.ToString();
                    comboBoxCelWyjazdu = dataGridView1.Rows[WybranyWiersz].Cells["Cel wyjazdu"].Value.ToString();
                    comboBoxOpisTrasy = dataGridView1.Rows[WybranyWiersz].Cells["Opis trasy wyjazdu"].Value.ToString();
                    edytujWyjazd.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells["Liczba faktycznie przejechanych km"].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value, WybranyWiersz);
                    if (edytujWyjazd.ShowDialog() == DialogResult.OK)
                        edytujWyjazd.Close();
                }            
            }
            else
            {
                MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
            }
        }

        private void drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = printDocument1;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private void eksport_Click(object sender, EventArgs e)
        {
            ExportToExcel(dataGridView1);
        }
        #endregion
    }
}