using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Drawing.Printing;

namespace ProgramDB
{
    public partial class EwidencjaSprzedazy : Form, InterfaceClass.ITakeData
    {
        private DataGridViewPrinter MyDataGridViewPrinter;
        private string[] sqlData ={ "NrEwidencji", "Data", "KwotaPrzychoduNieUdokumen", "KwotaPrzychoduUdokumen", "Suma", "Uwagi" };
        public EwidencjaSprzedazy()
        {
            InitializeComponent();
        }

        private int WybranyWiersz
        {
            get
            {
                return ownDataGridView1.SelectedRows[0].Index; // return selected row
            }
        }

        public int SelectRowIDFromDatabase()
        {
            return MethodsClass.ExeStoredProcedureRetInt("uspGetEwidencjaSprzedazyID",
new string[] { sqlData[0], sqlData[1], sqlData[2], sqlData[3], sqlData[5] },
new object[] { ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value });
        }

        public void EdytujOK(params object[] text)
        { // Zapisujemy zmiany w edytowanej ewidencji sprzedazy
            int i = 0;
            for (; i < sqlData.Length - 2; i++)
            {
                ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = text[i];
            }
            ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = Convert.ToDecimal((Convert.ToDecimal(text[i-1]) + Convert.ToDecimal(text[i-2])));
            ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[i+1]].Value = (text[i].ToString() == "") ? null : text[i];
        }

        public void Dodaj(params object[] text)
        {  // Dodajemy jedna sprzedaz 
            DataRow myDataRow = dataSet1.Tables["EwidencjaSprzedazyTabela"].NewRow();
            int i = 0;
            for (; i < sqlData.Length - 2; i++)
            {
                myDataRow[sqlData[i]] = text[i];
            }
            myDataRow[sqlData[i]] = Convert.ToDecimal(Convert.ToDecimal(text[i - 1]) + Convert.ToDecimal(text[i - 2]));
            myDataRow[sqlData[i+1]] = (text[i].ToString() == "") ? null : text[i].ToString();
            dataSet1.Tables["EwidencjaSprzedazyTabela"].Rows.Add(myDataRow);
        }

        private void EwidencjaSprzedazy_Load(object sender, EventArgs e)
        {  // create table EwidencjaPrzebieguPojazdow if does not exist
            if (!MethodsClass.DbTableExists("EwidencjaSprzedazyTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE EwidencjaSprzedazyTabela (EwidencjaSprzedazyID INT IDENTITY(1,1) NOT NULL PRIMARY KEY," +
"NrEwidencji INT NOT NULL, Data DATETIME NOT NULL, KwotaPrzychoduNieUdokumen SMALLMONEY NOT NULL, " + "KwotaPrzychoduUdokumen SMALLMONEY NOT NULL, Uwagi NVARCHAR(50) NULL" + ")"; 
                MethodsClass.ExeNonQuery(sCreateTable);
            }

            this.sqlDataAdapter1.Fill(this.dataSet1, "EwidencjaSprzedazyTabela");
            ownDataGridView1.DataSource = dataSet1.Tables["EwidencjaSprzedazyTabela"];

            ownDataGridView1.Columns[0].Visible = false;
            MethodsClass.SetDateFormatDataGridView(ownDataGridView1, "Data");
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, "KwotaPrzychoduNieUdokumen");
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, "KwotaPrzychoduUdokumen");
            MethodsClass.SetMoneyFormatDataGridView(ownDataGridView1, "Suma");
            ownDataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            ownDataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            ownDataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            ownDataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            ownDataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            ownDataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            ownDataGridView1.GridColor = SystemColors.ControlDarkDark;
            ownDataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);

            ownDataGridView1.Columns["NrEwidencji"].HeaderText = "Nr Ewidencji";
            ownDataGridView1.Columns["KwotaPrzychoduNieUdokumen"].HeaderText = "Kwota przychodu nieudokumentowanego";
            ownDataGridView1.Columns["KwotaPrzychoduUdokumen"].HeaderText = "Kwota przychodu udokumentowanego";
            ownDataGridView1.Columns["KwotaPrzychoduNieUdokumen"].Width+=20;
            ownDataGridView1.Columns["KwotaPrzychoduUdokumen"].Width+=20;
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            WprowadzanieNowejSprzedazy wprowNowejSprzed = new WprowadzanieNowejSprzedazy(this, true); // set false when we clicked Nowy button
            if (wprowNowejSprzed.ShowDialog()==DialogResult.OK)
                wprowNowejSprzed.Close();
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(ownDataGridView1))
                {
                    if (ownDataGridView1.Rows[WybranyWiersz].Cells["Data"].Value != null) // check if cell Data isn' t equal null (this is the last row in the DataGridView)
                    {
                        ownDataGridView1.Rows.Remove(ownDataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }
            }
        }

        private void Wyjscie_Click(object sender, EventArgs e)
        {
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
                sqlDataAdapter1.Update(dataSet1, "EwidencjaSprzedazyTabela");   
        }

        private void ownDataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(ownDataGridView1))
            {
                if (ownDataGridView1.Rows[WybranyWiersz].Cells["Data"].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    WprowadzanieNowejSprzedazy edytujNowejSprzed = new WprowadzanieNowejSprzedazy(this, false); // set false when we clicked Edytuj button
                    edytujNowejSprzed.Text = "Edycja wprowadzonej sprzeday";
                    edytujNowejSprzed.Edytuj(ownDataGridView1.Rows[WybranyWiersz].Cells["NrEwidencji"].Value, ownDataGridView1.Rows[WybranyWiersz].Cells["Data"].Value, ownDataGridView1.Rows[WybranyWiersz].Cells["KwotaPrzychoduNieUdokumen"].Value, ownDataGridView1.Rows[WybranyWiersz].Cells["KwotaPrzychoduUdokumen"].Value, ownDataGridView1.Rows[WybranyWiersz].Cells["Uwagi"].Value);
                    if (edytujNowejSprzed.ShowDialog() == DialogResult.OK)
                        edytujNowejSprzed.Close();
                }
            }
        }

        private void ksieguj_Click(object sender, EventArgs e)
        {
            if (MethodsClass.ifSelectedRow(ownDataGridView1))
            {
                if (ownDataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    Wyjscie_Click(sender, e);
                    NowyWprowadzanyDokument nowyWprowDokum = new NowyWprowadzanyDokument(new WprowadzanieDokumentow(), 3, Convert.ToDecimal(ownDataGridView1.Rows[WybranyWiersz].Cells["Suma"].Value), SelectRowIDFromDatabase()); 
                    // first value is object from which we call form; second value if equal: 0 - call NowyWprowadzanyDokument previously entered data, 
                    // 1 - call empty NowyWprowadzanyDokument Form, 2 - call NowyWprowadzanyDokument from DowodyWewnetrzne form, 3 - call NowyWprowadzanyDokument from EwidencjaSprzeday form, 
                    //4 - call NowyWprowadzanyDokument from EwidencjaWyposazenia form; third value set sum of value; four value set selected row

                    if (nowyWprowDokum.ShowDialog() == DialogResult.OK)
                        nowyWprowDokum.Close();
                }
            }
        }

        private void ownDataGridView1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.RowIndex % 2 == 1)   // odd rows have blue background   
                e.CellStyle.BackColor = Color.Lavender;
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = printDocument1;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private void drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                printDocument1.Print();
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            printDocument1.DocumentName = "PrintDocument";
            printDocument1.PrinterSettings = MyPrintDialog.PrinterSettings;
            printDocument1.DefaultPageSettings = MyPrintDialog.PrinterSettings.DefaultPageSettings;
            printDocument1.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, printDocument1, true, true, "Ewidencja sprzeday", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, printDocument1, false, true, "Ewidencja sprzeday", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);

            return true;
        }
    }
}