using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Drawing.Printing;

namespace ProgramDB
{
    public partial class EwidencjaWyposazenia : Form, InterfaceClass.ITakeData
    {
        private DataGridViewPrinter MyDataGridViewPrinter;
        private string[] sqlData ={ "DataNabycia", "NrDokumentu", "NazwaWyposazenia", "WartoscPoczatkowa", "DataLikwidacji", "PrzyczynaLikwidacji" };
        private int[] positionSqlDataInDataGridView={ 0, 1, 2, 3 };
        public EwidencjaWyposazenia()
        {
            InitializeComponent(); 
        }

        private int WybranyWiersz
        {
            get
            {
                return dataGridView1.SelectedRows[0].Index; // return selected row
            }
        }

        public int SelectRowIDFromDatabase()
        {
            return MethodsClass.ExeStoredProcedureRetInt("uspGetEwidencjaWyposazeniaID", sqlData , 
new object[] { dataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[4]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value });
        }

        public void EdytujOK(params object[] text)
        { // Zapisujemy zmiany w edytowanej EwidencjaWyposazenia 
            int i = 0;
            for (; i < positionSqlDataInDataGridView.Length-1; i++)
            {
                dataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value=text[i];
            }
            dataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = (text[i].ToString() == "") ? null : text[i];
        }

        public void Dodaj(params object[] text)
        {  // Dodajemy jedna ewidencje wyposazenia 
            DataRow myDataRow = dataSet1.Tables["EwidencjaWyposazeniaTabela"].NewRow();
            int i = 0;
            for (; i < positionSqlDataInDataGridView.Length - 1; i++)
            {
                myDataRow[sqlData[i]] = text[i];
            }
            myDataRow[sqlData[positionSqlDataInDataGridView.Length - 1]] = (text[i] == null) ? null : text[i];
            dataSet1.Tables["EwidencjaWyposazeniaTabela"].Rows.Add(myDataRow);
        }

        public void Likwidacja(DateTime text1, string text2)
        {
            int ww = WybranyWiersz;
            dataSet1.Tables["EwidencjaWyposazeniaTabela"].Rows[ww][sqlData[sqlData.Length - 2]] = text1; // This DataSet and DataSet below are for the rows in the DataGridView. If we don't have it this rows will not be update in the database.
            dataSet1.Tables["EwidencjaWyposazeniaTabela"].Rows[ww][sqlData[sqlData.Length - 1]] = text2;
            dataGridView1.Rows[ww].Cells[sqlData[sqlData.Length - 2]].Value = text1;
            dataGridView1.Rows[ww].Cells[sqlData[sqlData.Length - 1]].Value = text2;    
        }

        private void EwidencjaWyposazenia_Load(object sender, EventArgs e)
        {  // create table EwidencjaWyposazenia if does not exist
            if (!MethodsClass.DbTableExists("EwidencjaWyposazeniaTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE EwidencjaWyposazeniaTabela  " + "(EwidencjaWyposazeniaID INT IDENTITY(1,1) NOT NULL PRIMARY KEY," +
"DataNabycia SMALLDATETIME NOT NULL, NrDokumentu NVARCHAR(50) NULL, NazwaWyposazenia NVARCHAR(50) NULL, " +
"WartoscPoczatkowa MONEY NULL, DataLikwidacji SMALLDATETIME NULL, PrzyczynaLikwidacji NVARCHAR(50) NULL" + ")";
                MethodsClass.ExeNonQuery(sCreateTable);
            }
            this.sqlDataAdapter1.Fill(this.dataSet1, "EwidencjaWyposazeniaTabela");
            dataGridView1.DataSource = dataSet1.Tables["EwidencjaWyposazeniaTabela"];
            dataGridView1.Columns[0].Visible = false;
            MethodsClass.SetDateFormatDataGridView(dataGridView1, "DataNabycia");
            MethodsClass.SetDateFormatDataGridView(dataGridView1, "DataLikwidacji");
            MethodsClass.SetMoneyFormatDataGridView(dataGridView1, "WartoscPoczatkowa");
            dataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            dataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            dataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            dataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            dataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            dataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            dataGridView1.GridColor = SystemColors.ControlDarkDark;
            dataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);
            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;

            dataGridView1.Columns["DataNabycia"].HeaderText = "Data nabycia";
            dataGridView1.Columns["NrDokumentu"].HeaderText = "Nr dokumentu";
            dataGridView1.Columns["NazwaWyposazenia"].HeaderText = "Nazwa wyposaenia";
            dataGridView1.Columns["WartoscPoczatkowa"].HeaderText = "Warto pocztkowa";
            dataGridView1.Columns["DataLikwidacji"].HeaderText = "Data likwidacji";
            dataGridView1.Columns["PrzyczynaLikwidacji"].HeaderText = "Przyczyna likwidacji";
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            WprowadzanieNowegoWyposazenia wprowNowegoWypos = new WprowadzanieNowegoWyposazenia(this, true); // set false when we clicked Nowy button
            if (wprowNowegoWypos.ShowDialog() == DialogResult.OK)
                wprowNowegoWypos.Close();
        }

        private void Likwiduj_Click(object sender, EventArgs e)
        {
            LikwidacjaWyposazenia likwidacjaWyposazenia = new LikwidacjaWyposazenia(this);
            if (likwidacjaWyposazenia.ShowDialog() == DialogResult.OK)
                likwidacjaWyposazenia.Close(); 
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(dataGridView1))
                {
                    if (dataGridView1.Rows[WybranyWiersz].Cells["DataNabycia"].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        dataGridView1.Rows.Remove(dataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }                
            }
        }

        private void Wyjscie_Click(object sender, EventArgs e)
        { // save changed 
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
                sqlDataAdapter1.Update(dataSet1);
        }

        private void dataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (dataGridView1.Rows[WybranyWiersz].Cells["DataNabycia"].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    WprowadzanieNowegoWyposazenia wprowNowegoWypos = new WprowadzanieNowegoWyposazenia(this, false); // set false when we clicked Edytuj button
                    wprowNowegoWypos.Text = "Korekta wprowadzonego wyposaenia";
                    wprowNowegoWypos.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells["DataNabycia"].Value, dataGridView1.Rows[WybranyWiersz].Cells["NrDokumentu"].Value, dataGridView1.Rows[WybranyWiersz].Cells["NazwaWyposazenia"].Value, dataGridView1.Rows[WybranyWiersz].Cells["WartoscPoczatkowa"].Value);
                    if (wprowNowegoWypos.ShowDialog() == DialogResult.OK)
                        wprowNowegoWypos.Close();
                }
                else
                {
                    MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                }
            }
            else
            {
                MethodsClass.MesBoxShowError("Wybierz jeden wiersz", "Bd");
            }     
        }

        private void ksieguj_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.ifSelectedRow(dataGridView1))
            {
                MethodsClass.MesBoxShowError("Wybierz jeden wiersz", "Bd");
            }     
            else
                if (dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    Wyjscie_Click(sender, e);
                    MethodsClass.NrDokumenWyposazenia = dataGridView1.Rows[WybranyWiersz].Cells["NrDokumentu"].Value.ToString();
                    MethodsClass.NazwaWyposazenia = dataGridView1.Rows[WybranyWiersz].Cells["NazwaWyposazenia"].Value.ToString(); 
                    NowyWprowadzanyDokument nowyWprowDokum = new NowyWprowadzanyDokument(new WprowadzanieDokumentow(), 4, Convert.ToDecimal(dataGridView1.Rows[WybranyWiersz].Cells["WartoscPoczatkowa"].Value), SelectRowIDFromDatabase()); // set 2 when we enter a new document; deliver sum of value; deliver ID of select row  
                    // first value is object from which we call form; second value if equal: 0 - call NowyWprowadzanyDokument previously entered data, 
                    // 1 - call empty NowyWprowadzanyDokument Form, 2 - call NowyWprowadzanyDokument from DowodyWewnetrzne form, 3 - call NowyWprowadzanyDokument from EwidencjaSprzeday form, 
                    //4 - call NowyWprowadzanyDokument from EwidencjaWyposazenia form; third value set sum of value; four value set selected row

                    if (nowyWprowDokum.ShowDialog() == DialogResult.OK)
                        nowyWprowDokum.Close();
                }
                else
                {
                    MethodsClass.MesBoxShowError("Wybierz jeden z powyszych wierszy", "Bd");
                }
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = printDocument1;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private void drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                printDocument1.Print();
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            printDocument1.DocumentName = "PrintDocument";
            printDocument1.PrinterSettings = MyPrintDialog.PrinterSettings;
            printDocument1.DefaultPageSettings = MyPrintDialog.PrinterSettings.DefaultPageSettings;
            printDocument1.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(dataGridView1, printDocument1, true, true, "Ewidencja wyposaenia", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(dataGridView1, printDocument1, false, true, "Ewidencja wyposaenia", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);

            return true;
        }
    }
}