﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ProgramDB
{
    public partial class KontaKsięgowe : Form, InterfaceClass.ITakeData
    {
        private string[] sqlData ={ "Konto księgowe", "Nazwa", "Opis", "Kolumna książki", "Rodzaj rejestru", "Nr rejestracyjny" };
        private string[] sqlDataRycz ={ "Konto księgowe", "Nazwa", "Opis", "Stawka ryczałtu", "Rodzaj rejestru", "Nr rejestracyjny" };
        public KontaKsięgowe()
        {
            InitializeComponent();
        }
        
        private int WybranyWiersz
        {
            get
            {
                return dataGridView1.SelectedRows[0].Index; // return selected row
            }
        }

        public void EdytujOK(params object[] text)
        {  // Zapisuje zmiany w edytowanym koncie księgowym
            int ww = WybranyWiersz;
            dataGridView1.Rows[ww].Cells[sqlData[0]].Value = (text[0].ToString() == "") ? null : text[0];
            dataGridView1.Rows[ww].Cells[sqlData[1]].Value = text[1];
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                dataGridView1.Rows[ww].Cells[sqlData[2]].Value = text[2];
                dataGridView1.Rows[ww].Cells[sqlData[3]].Value = MethodsClass.ColumnBookStringToDigit(text[3]);
                dataGridView1.Rows[ww].Cells[sqlData[4]].Value = MethodsClass.KindRegisterStringToDigit(text[4]);
                dataGridView1.Rows[ww].Cells[sqlData[5]].Value = (text[5] == null) ? null : text[5];
            }
            else
            {
                dataGridView1.Rows[ww].Cells[sqlDataRycz[2]].Value = text[2];
                dataGridView1.Rows[ww].Cells[sqlDataRycz[3]].Value = MethodsClass.LumpSumStringToPercent(text[3]);
                dataGridView1.Rows[ww].Cells[sqlDataRycz[4]].Value = MethodsClass.KindRegisterStringToDigit(text[4]);
                dataGridView1.Rows[ww].Cells[sqlDataRycz[5]].Value = (text[5] == null) ? null : text[5];
            }
        }

        public void Dodaj(params object[] text)
        {  // add new accounting account
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                DataRow myDataRow = dataSet1.Tables["KontoKsiegoweTabela"].NewRow();
                myDataRow[sqlData[0]] = (text[0] == null) ? null : text[0];
                myDataRow[sqlData[1]] = text[1];
                myDataRow[sqlData[2]] = text[2];
                myDataRow[sqlData[3]] = MethodsClass.ColumnBookStringToDigit(text[3]);
                myDataRow[sqlData[4]] = MethodsClass.KindRegisterStringToDigit(text[4]);
                myDataRow[sqlData[5]] = (text[5] == null) ? null : text[5];

                dataSet1.Tables["KontoKsiegoweTabela"].Rows.Add(myDataRow);
            }
            else
            {
                DataRow myDataRow = dataSet1.Tables["KontoKsiegoweRyczaltTabela"].NewRow();
                myDataRow[sqlDataRycz[0]] = (text[0] == null) ? null : text[0];
                myDataRow[sqlDataRycz[1]] = text[1];
                myDataRow[sqlDataRycz[2]] = text[2];
                myDataRow[sqlDataRycz[3]] = MethodsClass.LumpSumStringToPercent(text[3]);

                myDataRow[sqlDataRycz[4]] = MethodsClass.KindRegisterStringToDigit(text[4]);
                myDataRow[sqlDataRycz[5]] = (text[5] == null) ? null : text[5];

                dataSet1.Tables["KontoKsiegoweRyczaltTabela"].Rows.Add(myDataRow);
            }
        }

        private void KontaKsięgowe_Load(object sender, EventArgs e)
        {  // create table KontoKsiegoweTabela if not exist 
            if (!MethodsClass.DbTableExists("KontoKsiegoweTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE KontoKsiegoweTabela (KontoKsiegoweID INT IDENTITY(0, 1) NOT NULL PRIMARY KEY," +
"KontoKsiegowe INT NULL, Nazwa NVARCHAR(50) NULL, Opis NVARCHAR(50) NULL, " +
"KolumnaKsiazki NVARCHAR(50) NULL, RodzajRejestru INT NULL, NrRejestracyjny NVARCHAR(50) NULL "
+ ", CONSTRAINT conKontoKsiegowe CHECK (KontoKsiegowe > 0) " + ")";
                MethodsClass.ExeNonQuery(sCreateTable);
            }

            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                this.sqlDataAdapter1.Fill(this.dataSet1, "KontoKsiegoweTabela");
                dataGridView1.DataSource = dataSet1.Tables["KontoKsiegoweTabela"];
            }
            else
            {
                this.sqlDataAdapter2.Fill(this.dataSet1, "KontoKsiegoweRyczaltTabela");
                dataGridView1.DataSource = dataSet1.Tables["KontoKsiegoweRyczaltTabela"];
            }

            dataGridView1.Columns[0].Visible = false;
            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NoweKontoKsięgowe noweKontoKsiegowe = new NoweKontoKsięgowe(this, true); // set false when we clicked Nowy button
            if (noweKontoKsiegowe.ShowDialog() == DialogResult.OK)
                noweKontoKsiegowe.Close();
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (dataGridView1.Rows[WybranyWiersz].Cells["Konto księgowe"].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
            {
                if (MethodsClass.CzyUsunac())
                    dataGridView1.Rows.Remove(dataGridView1.SelectedRows[0]);
            }
            else
            {
                MethodsClass.MesBoxShowInformation("Wybierz jeden z powyższych wierszy", "Nieprawidłowy wiersz");
            }
        }

        private void KontaKsięgowe_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.F2:
                    Nowy_Click(null, null);
                    break;
                case Keys.F8:
                    Usun_Click(null, null);
                    break;
                case Keys.F10:
                    Wyjscie_Click(null, null);
                    Close();
                    break;
            }
        }

        private void Wyjscie_Click(object sender, EventArgs e)
        {
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
            {
                try
                {
                    if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
                        sqlDataAdapter1.Update(dataSet1, "KontoKsiegoweTabela");
                    else
                        sqlDataAdapter2.Update(dataSet1, "KontoKsiegoweRyczaltTabela");
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MessageBox.Show(ex.Message.ToString());
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
            }
        }

        private void dataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (dataGridView1.Rows[WybranyWiersz].Cells["Konto księgowe"].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    NoweKontoKsięgowe edytujKontoKsiegowe = new NoweKontoKsięgowe(this, false); // set false when we clicked Nowy button
                    edytujKontoKsiegowe.Text = "Edycja konta księgowego";
                    if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
                        edytujKontoKsiegowe.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[4]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value);
                    else
                        edytujKontoKsiegowe.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells[sqlDataRycz[0]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlDataRycz[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlDataRycz[2]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlDataRycz[3]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlDataRycz[4]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlDataRycz[5]].Value);
                    if (edytujKontoKsiegowe.ShowDialog() == DialogResult.OK)
                        edytujKontoKsiegowe.Close();
                }
            }   
        }

        private void dataGridView1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.RowIndex % 2 == 1)   // odd rows have blue background   
                e.CellStyle.BackColor = Color.Lavender;
        }
    }
}