using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ProgramDB
{
    public partial class Kontrahenci : Form, InterfaceClass.ITakeDataDictionary
    {
        private string[] sqlData ={ "NazwaSkrocona", "NazwaPelna", "Adres", "Kod1", "Kod2", "Miejscowosc", "Kraj", "Nazwa", "Adress", "Kod11", "Kod22", "Miejscowosc2", "Kraj2",
"NIP", "REGON", "PESEL", "Telefon", "Email", "Bank", "Konto", "InnyAdresDoKores"};
        private int[] positionSqlDataInListView ={ 0, 2, 5, 13, 16, 17 };
        public Kontrahenci()
        {
            InitializeComponent();
        }

        private Dictionary<int, object> ExeReaderEdytuj(string query)
        {
            Dictionary<int, object> editionSelectedListView = new Dictionary<int, object>();
            SqlConnection conn = new SqlConnection();
            try
            {
                if (MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))  // if table exist
                {
                    conn.ConnectionString = MethodsClass.sConnectionString;
                    SqlCommand com = conn.CreateCommand();
                    com.CommandType = CommandType.Text;
                    com.CommandText = query;
                    conn.Open();
                    int i = 0;
                    using (SqlDataReader reader = com.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            for (; i < sqlData.Length; i++)
                            {
                                editionSelectedListView.Add(i, reader[i].ToString());
                            }
                        }
                    }
                    conn.Close();
                }
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return editionSelectedListView;
        }

        public int PobierzIDInt()
        { // return ID
            string query = "SELECT KontrahenciID FROM KontrahenciTabela WHERE ";
            int i = 0;
            for (; i < positionSqlDataInListView.Length - 1; i++)
            {
                query += sqlData[positionSqlDataInListView[i]];
                query += " ='";
                query += listView1.SelectedItems[0].SubItems[i].Text;
                query += "' AND  ";
            }
            query += sqlData[positionSqlDataInListView[i]];
            query += " ='";
            query += listView1.SelectedItems[0].SubItems[i].Text;
            query += "'";
            return MethodsClass.ExeScalarInt(query);
        }

        public void EdytujOK(int id, Dictionary<int, object> textTable)
        { // save changes to the edited listview on the form Kontrahenci         
            for (int i = 0; i < positionSqlDataInListView.Length; i++)
            {
                listView1.SelectedItems[0].SubItems[i].Text = textTable[positionSqlDataInListView[i]].ToString();
            }
            //---
            string query = "UPDATE KontrahenciTabela SET ";
            int j = 0;
            for (; j < sqlData.Length - 1; j++)
            {
                query += sqlData[j];
                query += " ='";
                if ((j == 3) || (j == 4) || (j == 9) || (j == 10))
                    query += (textTable[j].ToString() == "") ? null : textTable[j];
                else
                    query += textTable[j];
                query += "' , ";
            }
            query += sqlData[j];
            query += " ='";
            query += textTable[j];
            query += "' ";
            query += "WHERE ";
            query += "KontrahenciID";
            query += " ='";
            query += id;
            query += "' ";
            MethodsClass.ExeNonQuery(query);
        }

        public void Dodaj(Dictionary<int, object> textTable)
        {  // add new contractor 
            string[] textListView = new string[positionSqlDataInListView.Length];
            for (int i = 0; i < positionSqlDataInListView.Length; i++)
            {
                textListView[i] = textTable[positionSqlDataInListView[i]].ToString();
            }
            listView1.Items.Add(new ListViewItem(textListView));
            //---
            string query = "INSERT INTO KontrahenciTabela VALUES('";
            int j = 0;
            for (; j < textTable.Count - 1; j++)
            {
                if ((j == 3) || (j == 4) || (j == 9) || (j == 10))
                    query += (textTable[j].ToString() == "") ? null : textTable[j];
                else
                    query += textTable[j];
                query += "', '";
            }
            query += textTable[textTable.Count - 1];
            query += "')";
            MethodsClass.ExeNonQuery(query);
        }

        private void Kontrahenci_Load(object sender, EventArgs e)
        { // create table if it does not exist
            if (!MethodsClass.DbTableExists("KontrahenciTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE KontrahenciTabela (KontrahenciID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY ";
                for (int i = 0; i < sqlData.Length; i++)
                {
                    sCreateTable += ", ";
                    sCreateTable += sqlData[i];
                    if ((i == 3) || (i == 4) || (i == 9) || (i == 10))
                        sCreateTable += " INT NULL ";
                    else
                        sCreateTable += " NVARCHAR(50) NULL";
                }
                sCreateTable += ")";
                MethodsClass.ExeNonQuery(sCreateTable);
            }
            else if (MethodsClass.IsNotEmptyTable("KontrahenciTabela"))
            {
                string comtext = "SELECT ";
                int j = 0;
                for (; j < positionSqlDataInListView.Length - 1; j++)
                {
                    comtext += sqlData[positionSqlDataInListView[j]];
                    comtext += ", ";
                }
                comtext += sqlData[positionSqlDataInListView[j]];
                comtext += " FROM KontrahenciTabela";
                MethodsClass.ExeReaderListViewString(listView1, comtext);
            }
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NowyKontrahent nowyKontrahent = new NowyKontrahent(this, true); // set false when we clicked Nowy button
            if (nowyKontrahent.ShowDialog() == DialogResult.OK)
                nowyKontrahent.Close();
        }

        private void Edytuj_Click(object sender, EventArgs e)
        { // edition contractor
            if (MethodsClass.CzyWybranaPozycja(listView1))
            {
                NowyKontrahent edycjaKontrahent = new NowyKontrahent(this, false); // set false when we clicked Edytuj button
                edycjaKontrahent.Text = "Edycja kontrahenta";

                string query = "SELECT ";
                int j = 0;
                for (; j < sqlData.Length - 1; j++)
                {
                    query += sqlData[j];
                    query += ", ";
                }
                query += sqlData[j];
                query += " FROM  KontrahenciTabela WHERE KontrahenciID='" + PobierzIDInt() + "'";
                edycjaKontrahent.Edytuj(ExeReaderEdytuj(query));
                if (edycjaKontrahent.ShowDialog() == DialogResult.OK)
                    edycjaKontrahent.Close();
            }
        }

        private void Usun_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyWybranaPozycja(listView1) && MethodsClass.CzyUsunac())
            {
                string query = "DELETE FROM KontrahenciTabela WHERE KontrahenciID='" + PobierzIDInt() + "'";
                MethodsClass.UsunPozycje(query, listView1);
            }
        }

        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            Edytuj_Click(sender, e);
        }
    }
}