using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Diagnostics; // Process.Start()

namespace ProgramDB
{
    public partial class MainForm : Form
    {
        public StatusBar statusBar;
        public MainForm()
        {
            InitializeComponent();
        }
        
        private void myToolStripMenuItem_MouseLeave(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Gotowe";
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            EkranPowitalny SplashScreen = new EkranPowitalny();
            SplashScreen.Show();
            SplashScreen.TopMost = true;

            this.WindowState = FormWindowState.Maximized;
            timer1.Start();
            // Add the StatusBar to the form.
            statusBar = MethodsClass.CreateMyStatusBar();
            this.Controls.Add(statusBar);

            ToolTip toolStrip = new ToolTip();
            toolStrip.SetToolTip(this.toolStrip1, "");

            if ((MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database)) && (MethodsClass.DbTableExists("ZabezpieczenieProgramu", MethodsClass.sConnectionString)))
            {
                string sOldPassword = "";
                string sql = "SELECT Haslo FROM ZabezpieczenieProgramu";
                //SqlConnection conn = MethodsClass.SqlConnect();
                SqlConnection conn = new SqlConnection(MethodsClass.sConnectionString);
                SqlCommand cmd = new SqlCommand(sql, conn);
                try
                {
                    conn.Open();
                    sOldPassword = (string)cmd.ExecuteScalar();
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MethodsClass.SqlExceptionFunction(ex);
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
                finally
                {
                    MethodsClass.FinallyExceptionFunction(conn);
                }
                //---
                if (sOldPassword != "")
                {
                    PodanieHasla podanieHasla = new PodanieHasla(conn);
                    podanieHasla.ShowDialog();
                }
            }
            // add event to the ToolStripMenuItem
            this.nowaToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.definiowanieKontKsigowychToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.usuFirmToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.wprowadzanieDokumentwToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.dokumZaksiegToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.dowodyWewntrzneToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.ewidencjaPrzychodwToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.ewidencjaPojazdwToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.ewidencjaSprzedayToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.ewidencjaWyposaeniaToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.NotyKorygujceToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);
            this.podatkowaKsigaPrzychodwIRozchodwToolStripMenuItem.MouseLeave += new System.EventHandler(this.myToolStripMenuItem_MouseLeave);

            SplashScreen.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            statusBar.Panels[1].Text = DateTime.Now.ToLongDateString() +"   " + DateTime.Now.ToShortTimeString();
        }

        private void nowaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.DbTableNotExistsOrIsEmpty("DaneFirmy"))
            {
                MethodsClass.MesBoxShowWarning("Firma zostaa ju utworzona.", "Niepowodzenie");
                return;
            }
            NowaFirma nf = new NowaFirma();
            if (nf.ShowDialog() == DialogResult.OK)
            {
                this.Text = "Ksigowo dla firmy " + NowaFirma.IdenFirmy;
                nf.Close(); 
            }
        }

        private void usuFirmToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("adna firma nie istnieje, wic nie moesz jej usun.", "Bd");
                return;
            }

            if (MethodsClass.CzyUsunac())
            {
                System.Data.SqlClient.SqlConnection sqlConn = new SqlConnection("Data Source= " + MethodsClass.Server + "; Initial Catalog= master; Integrated Security=SSPI");
                SqlCommand sqlComm = new SqlCommand("USE master", sqlConn);

                try
                {
                    sqlConn.Open();
                    sqlComm.ExecuteNonQuery();
                    SqlConnection.ClearAllPools(); // Empties the connection pool
                    sqlComm = new SqlCommand("DROP DATABASE BazaDanychFileStream", sqlConn);
                    sqlComm.ExecuteNonQuery();
                    this.Text = "Program Ksigowo";
                    //MessageBox.Show("Database has been dropped successfully!\nDrop Database");
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MethodsClass.SqlExceptionFunction(ex);
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
                finally
                {
                    MethodsClass.FinallyExceptionFunction(sqlConn);
                }
            }
        }

        private void oProgramieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            oProgramie op=new oProgramie();
            if (op.ShowDialog()==DialogResult.OK)
                op.Close();
        }

        private void daneTechniczneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string informacje = "Informacje o systemie:"
            + "\n\nWersja systemu: " + MethodsClass.GetMachineOS() + " " + Environment.OSVersion.ServicePack   // Environment.OSVersion
            + "\n\nPami operacyjna: " + Convert.ToDouble(MethodsClass.GetInformations("Capacity", "Win32_PhysicalMemory"))/(1024*1024) + " MB RAM "
            + "\n\nProcesor: " + MethodsClass.GetInformations("Name", "Win32_Processor")
            + "\n\nLiczba procesorw: " + Environment.ProcessorCount
            + "\n\nWersja Microsoft .NET Framework: " + Environment.Version
            + "\n\nNazwa komputera: " + Environment.MachineName
            + "\n\nKatalog systemowy: " + Environment.SystemDirectory
            + "\n\n";
            MessageBox.Show(informacje, "Dane techniczne");
        }

        private void kalkulatorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Process.Start("calc.exe");
        }

        private void pomocProgramuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Process.Start("help.pdf");    
        }

        private void definiowanieKontKsigowychToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Nie istnieje jeszcze adna firma", "Bd");
                return;
            }
            KontaKsigowe dkk = new KontaKsigowe();
            if (dkk.ShowDialog()==DialogResult.OK)
                dkk.Close();
        }

        private void daneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Nie istnieje jeszcze adna firma", "Bd");
                return;
            }
            NowaFirma enf = new NowaFirma();
            if (enf.ShowDialog()==DialogResult.OK)
                enf.Close();
        }

        private void miesicKsigowyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))  // Jeeli nie istnieje baza danych zwraca true
            {
                MethodsClass.MesBoxShowError("Nie zostaa jeszcze utworzona adna firma.", "Bd");
                return;
            }
            ZmianaMiesiacaKsiegowego zmianaMiesKsieg = new ZmianaMiesiacaKsiegowego();
            if (zmianaMiesKsieg.ShowDialog()==DialogResult.OK)
                zmianaMiesKsieg.Close();
        }

        private void rokKsigowyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))  // Jeeli nie istnieje baza danych zwraca true
            {
                MethodsClass.MesBoxShowError("Nie zostaa jeszcze utworzona adna firma.", "Bd");
                return;
            }
            ZmianaRokuKsiegowego zmianaRokuKsieg = new ZmianaRokuKsiegowego();
            if (zmianaRokuKsieg.ShowDialog()==DialogResult.OK)
                zmianaRokuKsieg.Close();
        }

        private void wprowadzanieDokumentwToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Dana firma nie istnieje", "Bd");
                return;
            }
            WprowadzanieDokumentow wprowDokum = new WprowadzanieDokumentow();
            if (wprowDokum.ShowDialog()==DialogResult.OK)
                wprowDokum.Close();
        }

        private void stawkiVATToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Nie istnieje jeszcze adna firma", "Bd");
                return;
            }
            StawkiVAT stawkiVAT = new StawkiVAT();
            if (stawkiVAT.ShowDialog()==DialogResult.OK)
                stawkiVAT.Close();            
        }

        private void dokumZaksiegToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Dana firma nie istnieje", "Bd");
                return;
            }
            EwidencjaDokumentowZaksiegowanych ewidenDokZaksieg = new EwidencjaDokumentowZaksiegowanych();
            if (ewidenDokZaksieg.ShowDialog() == DialogResult.OK)
                ewidenDokZaksieg.Close();
        }

        private void dowodyWewntrzneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Dana firma nie istnieje", "Bd");
                return;
            }
            DowodyWewnetrzne dowodyWew = new DowodyWewnetrzne();
            if (dowodyWew.ShowDialog()==DialogResult.OK)
                dowodyWew.Close();
        }

        private void ewidencjaPrzychodwToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                MethodsClass.MesBoxShowWarning("Ewidencja przychodw nie jest dostpna dla podatnikw rozliczajcych si wedug Podatkowej Ksigi Przychodw i Rozchodw", "Niepowodzenie");
                return;
            }
            EwidencjaPrzychodow ewidenPrzychodow = new EwidencjaPrzychodow();
            if (ewidenPrzychodow.ShowDialog()==DialogResult.OK)
                ewidenPrzychodow.Close();            
        }

        private void ewidencjaPrzebieguPojazdwToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowWarning("Dana firma nie istnieje", "Niepowodzenie");
                return;
            }
            else if (!MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                MethodsClass.MesBoxShowWarning("Ewidencja przebiegu pojazdw nie jest dostpna dla podatnikw rozliczajcych si wedug ewidencji przychodw. Opcj t mona zmieni w danych firmy.", "Niepowodzenie");
                return;
            }
            else if (MethodsClass.DbTableNotExistsOrIsEmpty("PojazdyPrywatneTabela"))
            {
                MethodsClass.MesBoxShowWarning("Zdefiniuj pojazdy prywatne", "Niepowodzenie");
                return;
            }
            else if (MethodsClass.DbTableNotExistsOrIsEmpty("CeleWyjazdPojPrywTabela"))
            {
                MethodsClass.MesBoxShowWarning("Zdefiniuj cele wyjazdw pojazdw prywatnych", "Niepowodzenie");
                return;
            }
            else if (MethodsClass.DbTableNotExistsOrIsEmpty("OpisTrasWyjazdTabela"))
            {
                MethodsClass.MesBoxShowWarning("Zdefiniuj opis tras wyjazdw", "Niepowodzenie");
                return;
            }
            EwidencjaPrzebieguPojazdow ewidenPrzebPojazd = new EwidencjaPrzebieguPojazdow();
            if (ewidenPrzebPojazd.ShowDialog()==DialogResult.OK)
                ewidenPrzebPojazd.Close();
        }

        private void kosztyPojazdwToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowWarning("Dana firma nie istnieje", "Niepowodzenie");
                return;
            }
            else if (!MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                MethodsClass.MesBoxShowWarning("Ewidencja kosztw pojazdw nie jest dostpna dla podatnikw rozliczajcych si wedug ewidencji przychodw. Opcj t mona zmieni w danych firmy.", "Niepowodzenie");
                return;
            }
            EwidencjaKosztowPojazdow ewidenKosztowPojazd = new EwidencjaKosztowPojazdow();
            if (ewidenKosztowPojazd.ShowDialog()==DialogResult.OK)
                ewidenKosztowPojazd.Close();
        }

        private void ewidencjaSprzedayToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowWarning("Dana firma nie istnieje", "Niepowodzenie");
                return;
            }  
            EwidencjaSprzedazy ewidenSprzedazy = new EwidencjaSprzedazy();
            if (ewidenSprzedazy.ShowDialog()==DialogResult.OK)
                ewidenSprzedazy.Close();
        }

        private void ewidencjaWyposaeniaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowWarning("Dana firma nie istnieje", "Niepowodzenie");
                return;
            }
            EwidencjaWyposazenia ewidenWyposazenia = new EwidencjaWyposazenia();
            if (ewidenWyposazenia.ShowDialog()==DialogResult.OK)
                ewidenWyposazenia.Close();
        }

        private void kontaKsigoweToolStripMenuItem_Click(object sender, EventArgs e)
        {
            definiowanieKontKsigowychToolStripMenuItem_Click(sender, e);
        }

        private void kontrachenciToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Kontrahenci kontra = new Kontrahenci();
            if (kontra.ShowDialog() == DialogResult.OK) 
                kontra.Close();
        }

        private void opisZdarzeGospodarczychToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpisZdarzenGospodarczych opisZdarzenGospod = new OpisZdarzenGospodarczych();
            if (opisZdarzenGospod.ShowDialog() == DialogResult.OK) 
                opisZdarzenGospod.Close();
        }

        private void rejestryVATToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.ExeFunctionRetBool("dbo.GetEwidencjaVAT()"))
            {
                MethodsClass.MesBoxShowWarning("Rejestry VAT nie s dostpne dla firm nie objtych podatkiem od towarw i usug VAT. Opcj t mona zmieni w danych fimy.", "Niepowodzenie");
                return;
            }
            RejestryVAT rejestryVAT = new RejestryVAT();
            if (rejestryVAT.ShowDialog() == DialogResult.OK) 
                rejestryVAT.Close();
        }

        private void notyKorygujaceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            NotyKorygujace notyKorygujace = new NotyKorygujace();
            if (notyKorygujace.ShowDialog() == DialogResult.OK) 
                notyKorygujace.Close();
        }

        private void podatkowaKsigaPrzychodwIRozchodwToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowWarning("Dana firma nie istnieje", "Niepowodzenie");
                return;
            }
            else if (!MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                MethodsClass.MesBoxShowWarning("Podatkowa Ksiga Przychodw i Rozchodow nie jest dostpna dla podatnikw rozliczajcych si wedug ewidencji przychodw. Opcj t mona zmieni w danych firmy.", "Niepowodzenie");
                return;
            }
            PKPiR PKPIR = new PKPiR();
            if (PKPIR.ShowDialog() == DialogResult.OK) 
                PKPIR.Close();
        }

        private void zabezpieczenieProgramuHasemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            UstawieniaZabezpieczeniaProgramu ustawZabezpiecz = new UstawieniaZabezpieczeniaProgramu();
            if (ustawZabezpiecz.ShowDialog() == DialogResult.OK) 
                ustawZabezpiecz.Close();
        }

        private void celeWyjazdwPojazdemPrywatnymToolStripMenuItem_Click(object sender, EventArgs e)
        {
            CeleWyjazdPojazdPrywat celeWyjazdPozjadPryw = new CeleWyjazdPojazdPrywat();
            if (celeWyjazdPozjadPryw.ShowDialog() == DialogResult.OK) 
                celeWyjazdPozjadPryw.Close();
        }

        private void opisTrasWyjazdwPojazdemPrywatnymToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpisTrasWyjazdPojazdPrywat opisTras = new OpisTrasWyjazdPojazdPrywat();
            if (opisTras.ShowDialog() == DialogResult.OK) 
                opisTras.Close();
        }

        private void wyjcieToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            DialogResult odp = MessageBox.Show("Czy napewno chcesz wyj z programu?", "Wyjcie",
    MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1);
            if (odp == DialogResult.Yes)
                Close();
        }

        private void pasekStanuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (pasekStanuToolStripMenuItem.Checked)
                pasekStanuToolStripMenuItem.Checked = false;
            else
                pasekStanuToolStripMenuItem.Checked = true;

            if (!pasekStanuToolStripMenuItem.Checked)
                statusBar.Visible = false;
            else
                statusBar.Visible = true;                
        }

        private void penyEkranToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!penyEkranToolStripMenuItem.Checked)
                penyEkranToolStripMenuItem.Checked = true;
            else
                penyEkranToolStripMenuItem.Checked = false;

            if (penyEkranToolStripMenuItem.Checked)
            {
                this.statusBar.Visible = false;
                this.FormBorderStyle = FormBorderStyle.None;
            }
            else
            {
                this.statusBar.Visible = true;
                this.FormBorderStyle = FormBorderStyle.FixedSingle;
            }
        }

        private void wprowadzanieDokumentw_Click(object sender, EventArgs e)
        {
            wprowadzanieDokumentwToolStripMenuItem_Click(sender, e);
        }

        private void dokumZaksieg_Click(object sender, EventArgs e)
        {
            dokumZaksiegToolStripMenuItem_Click(sender, e);
        }

        private void dowodyWewntrzne_Click(object sender, EventArgs e)
        {
            dowodyWewntrzneToolStripMenuItem_Click(sender, e);        
        }

        private void podatkowaKsigaPrzychodwIRozchodw_Click(object sender, EventArgs e)
        {
            podatkowaKsigaPrzychodwIRozchodwToolStripMenuItem_Click(sender, e);
        }

        private void rejestryVAT_Click(object sender, EventArgs e)
        {
            rejestryVATToolStripMenuItem_Click(sender, e);        
        }

        private void daneFirmy_Click(object sender, EventArgs e)
        {
            daneToolStripMenuItem_Click(sender, e);        
        }

        private void miesicKsigowy_Click(object sender, EventArgs e)
        {
            miesicKsigowyToolStripMenuItem_Click(sender, e);        
        }

        private void rokKsigowy_Click(object sender, EventArgs e)
        {
            rokKsigowyToolStripMenuItem_Click(sender, e);        
        }

        private void nowaToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Utworzenie nowej firmy";
        }
        
        private void definiowanieKontKsigowychToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Zdefiniowanie kont ksigowych";
        }
        
        private void usuFirmToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Usunicie firmy";
        }
        
        private void wprowadzanieDokumentwToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Wprowadzanie dokumentw ksigowych";
        }
        
        private void dokumZaksiegToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Ewidencja dokumentw zaksigowanych";
        }
        
        private void dowodyWewntrzneToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Dowody wewntrzne";
        }
        
        private void ewidencjaNajmuPodnajmuIDzierawyToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Ewidencja najmu, podnajmu, dzierawy";
        }
        
        private void ewidencjaPrzychodwToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Ewidencja przychodw";
        }
        
        private void ewidencjaPojazdwToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Ewidencja pojazdw";
        }

        private void ewidencjaSprzedayToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Ewidencja sprzeday";
        }

        private void ewidencjaWyposaeniaToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Ewidencja wyposaenia";
        }
        
        private void NotyKorygujceToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Noty korygujce";
        }

        private void podatkowaKsigaPrzychodwIRozchodwToolStripMenuItem_MouseEnter(object sender, EventArgs e)
        {
            statusBar.Panels[0].Text = "Podatkowa ksiga przychodw i rozchodw";
        }

        private void pojazdyPrywatneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PojazdyPrywatne pojazdyPrywatne = new PojazdyPrywatne();
            if (pojazdyPrywatne.ShowDialog() == DialogResult.OK)
                pojazdyPrywatne.Close();
        }

        private void stawkiZa1KmPrzebieguPojazduToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StawkaZaPrzebiegPojazdu stawkiZaPrzebiegPojazdu = new StawkaZaPrzebiegPojazdu();
            if (stawkiZaPrzebiegPojazdu.ShowDialog() == DialogResult.OK)
                stawkiZaPrzebiegPojazdu.Close();
        }

        private void kopiaBezpieczestwaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            KopiaBezpieczenstwa kopiaBezpieczenstwa = new KopiaBezpieczenstwa(true);
            if (kopiaBezpieczenstwa.ShowDialog() == DialogResult.OK)
                kopiaBezpieczenstwa.Close();
        }

        private void przywracanieKopiiBezpieczestwaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            KopiaBezpieczenstwa przywracanieKopiiBezpieczenstwa = new KopiaBezpieczenstwa(false);
            if (przywracanieKopiiBezpieczenstwa.ShowDialog() == DialogResult.OK)
                przywracanieKopiiBezpieczenstwa.Close();
        }

        private void kursViToolStripMenuItem_Click(object sender, EventArgs e)
        {
            KursVideo kurs = new KursVideo();
            if (kurs.ShowDialog() == DialogResult.OK)
                kurs.Close();
        }
    }
}