using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Management; // Additionally I must add reference that the method GetInformations work
using System.Data.SqlClient;
using System.IO;

namespace ProgramDB
{
    static class MethodsClass
    {
        private static string server = ".\\SQLEXPRESS";
        private static string database = "BazaDanychFileStream";
        private static string masterConnectionString = "Data Source= " + server + "; Initial Catalog= " + "master" + ";Integrated Security=SSPI";
        private static string connectionString = "Data Source= " + server + "; Initial Catalog= " + database + ";Integrated Security=SSPI";
        private static string[] month ={ "Stycze", "Luty", "Marzec", "Kwiecie", "Maj", "Czerwiec", "Lipiec", "Sierpie", "Wrzesie", "Padziernik", "Listopad", "Grudzie" };
        private static string nrDokumenWyposazenia;
        private static string nazwaWyposazenia;
        private static bool ifPressOKButton;

        public static bool ifPressOKButtonInNowyWprowDokum
        {
            set
            {
                ifPressOKButton = value;
            }
            get
            {
                return ifPressOKButton;
            }
        }

        public static string[] Miesiac
        {
            get
            {
                return month;
            }
        }

        public static string MasterConnectionString
        {
            get
            {
                return masterConnectionString;
            }
        }

        public static string sConnectionString
        {
            get
            {
                return connectionString;
            }
        }

        public static string Server
        {
            get
            {
                return server;
            }
        }

        public static string Database
        {
            get
            {
                return database;
            }
        }

        public static string NrDokumenWyposazenia
        {
            set
            {
                nrDokumenWyposazenia = value;
            }

            get
            {
                return nrDokumenWyposazenia;
            }
        }

        public static string NazwaWyposazenia
        {
            set
            {
                nazwaWyposazenia = value;
            }

            get
            {
                return nazwaWyposazenia;
            }
        }

        public static int DictionaryMonthStringToInt(string mies)
        {
            if (mies == "")
                return 0;
            Dictionary<string, int> dic = new Dictionary<string, int>();
            dic.Add("Stycze", 1);
            dic.Add("Luty", 2);
            dic.Add("Marzec", 3);
            dic.Add("Kwiecie", 4);
            dic.Add("Maj", 5);
            dic.Add("Czerwiec", 6);
            dic.Add("Lipiec", 7);
            dic.Add("Sierpie", 8);
            dic.Add("Wrzesie", 9);
            dic.Add("Padziernik", 10);
            dic.Add("Listopad", 11);
            dic.Add("Grudzie", 12);
            return dic[mies];
        }

        public static SqlConnection SqlConnect()
        {
            System.Data.SqlClient.SqlConnection tmpConn = new SqlConnection();
            tmpConn.ConnectionString = connectionString;
            return tmpConn;
        }

        public static void ExeReaderListViewString(ListView listView, string query)
        { // fill ListView 
            SqlConnection conn = new SqlConnection();
            try
            {
                listView.Items.Clear();
                conn.ConnectionString = connectionString;
                SqlCommand com = conn.CreateCommand();
                com.CommandType = CommandType.Text;
                com.CommandText = query;
                conn.Open();

                using (SqlDataReader reader = com.ExecuteReader())
                {
                    string[] sReader = new string[listView.Columns.Count];
                    while (reader.Read())
                    {
                        for (int z = 0; z < listView.Columns.Count; z++)
                            sReader[z] = reader.GetString(z);
                        listView.Items.Add(new ListViewItem(sReader));
                    }
                }
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
        }

        public static bool CheckDatabaseExists(string server, string database)
        {   // return true if database exist
            string cmdText = "select * from master.dbo.sysdatabases where name=\'" + database + "\'";
            bool bRet = false;
            using (SqlConnection sqlConnection = new SqlConnection(masterConnectionString))
            {
                sqlConnection.Open();
                using (SqlCommand sqlCmd = new SqlCommand(cmdText, sqlConnection))
                {
                    SqlDataReader reader = sqlCmd.ExecuteReader();
                    bRet = reader.HasRows;
                    reader.Close();
                }
            }
            return bRet;
        }

        public static bool DbTableExists(string strTableNameAndSchema, string strConnection)
        { // check if table exist 
            using (SqlConnection connection = new SqlConnection(strConnection))
            {
                string strCheckTable = String.Format("IF OBJECT_ID('{0}', 'U') IS NOT NULL SELECT 'true' ELSE SELECT 'false'", strTableNameAndSchema);

                using (SqlCommand command = new SqlCommand(strCheckTable, connection))
                {
                    command.CommandType = CommandType.Text;
                    connection.Open();
                    return Convert.ToBoolean(command.ExecuteScalar());
                }
            }
        }

        public static bool DbTableExists(string strTableNameAndSchema)
        { // check if table exist 
            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                string strCheckTable = String.Format("IF OBJECT_ID('{0}', 'U') IS NOT NULL SELECT 'true' ELSE SELECT 'false'", strTableNameAndSchema);

                using (SqlCommand command = new SqlCommand(strCheckTable, connection))
                {
                    command.CommandType = CommandType.Text;
                    connection.Open();
                    return Convert.ToBoolean(command.ExecuteScalar());
                }
            }
        }

        public static bool IsNotEmptyTable(string table)
        { // check if table is not empty then return true otherwise return false
            using (SqlConnection con = new SqlConnection())
            {
                con.ConnectionString = connectionString;
                SqlCommand com = con.CreateCommand();
                com.CommandType = CommandType.Text;
                com.CommandText = "if  exists(select * from " + table + ") select 1 else select 0";
                //if exists(select * from <your table>) select 'not empty' else  select 'empty'
                con.Open();
                if ((int)com.ExecuteScalar() == 1)
                    return true;
                else
                    return false;

            }
        }

        public static bool DbTableNotExistsOrIsEmpty(string tableName)
        { // check if table not exist or is empty then return true
            if (DbTableExists(tableName))
                return !IsNotEmptyTable(tableName);
            return true;
        }

        public static bool CzyUsunac()
        { 
            DialogResult odp = MessageBox.Show("Czy na pewno?", "Usu", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (odp == DialogResult.Yes)
                return true;
            else
                return false;
        }

        public static void MesBoxShowError(string tresc, string text)
        {
            MessageBox.Show(tresc, text, MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        public static void MesBoxShowWarning(string tresc, string text)
        {
            MessageBox.Show(tresc, text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
        }

        public static void MesBoxShowInformation(string tresc, string text)
        {
            MessageBox.Show(tresc, text, MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
        
        public static Label CreateMyLabel(int width, int height, int x, int y, string text, string name)
        { // create customer label
            // Create an instance of a Label
            Label label = new Label();
            label.BorderStyle = BorderStyle.None;
            // Specify that the text can display mnemonic characters.
            label.UseMnemonic = true;
            label.Size = new Size(width, height);
            label.Location = new Point(x, y);
            label.Text = text;
            label.Name = name;
            return label;
        }

        public static TextBox CreateMyTextBox(int width, int height, int x, int y, string text, string name)
        { // create customer textBox
            // Create an instance of a TexBox
            TextBox textBox = new TextBox();
            textBox.Size = new Size(width, height);
            textBox.Location = new Point(x, y);
            textBox.Text = text;
            textBox.Name = name;
            return textBox;
        }

        public static Button CreateMyButton(int width, int height, int x, int y, string text, string name)
        { // create customer button 
            // Create an instance of a TexBox
            Button button = new Button();
            button.Size = new Size(width, height);
            button.Location = new Point(x, y);
            button.Text = text;
            button.Name = name;
            return button;
        }

        public static void ownMaskedTextBox(object sender, KeyPressEventArgs e)
        { // it accept only digits, comma, dot and Back key and set format 0,00
            TextBox textBox = (TextBox)sender;
            int selStart = textBox.SelectionStart;
            string textValue = textBox.Text; // string textValue = textBox.Text;
            if ((char.IsNumber(e.KeyChar) || e.KeyChar == '.' || e.KeyChar == ',' || (Keys)e.KeyChar == Keys.Back) && (textValue.Length < 15))
            {
                if ((e.KeyChar == '.' || e.KeyChar == ',') && (sender as TextBox).Text.IndexOf(',') > -1) // if already exist . or decimal 
                {
                    if ((textValue.Length - textBox.SelectionStart) == 3) // item before decimal
                    { // if we press dot (or comma) we moved 1 positon to the right but it doesn't insert dot (or comma)
                        // but we must be before the comma
                        textBox.SelectionStart += 1;
                        selStart++;
                    }
                    e.Handled = true;
                }

                if ((e.KeyChar == '.') && (textValue.IndexOf(",") == -1)) // check if comma exist
                { // exchanged dot on comma when the comma doesn't exist
                    int z = textBox.SelectionStart;
                    {
                        StringBuilder sb = new StringBuilder();
                        sb.Append(textValue);
                        sb.Insert(z, Convert.ToString(","));
                        textBox.Text = Convert.ToString(sb);
                        e.Handled = true;
                        selStart++;
                    }
                }

                if (textValue.IndexOf(",") != -1) // check if comma exist
                {
                    if (char.IsNumber(e.KeyChar) && ((textValue.Length - textBox.SelectionStart == 4)))
                    { // insert digit before the comma
                        int z = textBox.SelectionStart;
                        {
                            StringBuilder sb = new StringBuilder();
                            sb.Append(textValue);
                            sb.Remove(z, 1);
                            sb.Insert(z, Convert.ToString(e.KeyChar));
                            textBox.Text = Convert.ToString(sb);
                            e.Handled = true;
                            selStart++;
                        }
                    }
                }

                if (textValue.IndexOf(",") != -1) // check if comma exist
                {
                    if (textBox.SelectionStart > textValue.IndexOf(","))
                    {
                        if (textValue.Length - textValue.IndexOf(",") == 3)
                        { // position after the comma 
                            if (char.IsNumber(e.KeyChar) && ((textValue.Length - textBox.SelectionStart == 2) || (textValue.Length - textBox.SelectionStart == 1)))
                            { // insert digits after the comma 
                                int z = textBox.SelectionStart;
                                {
                                    StringBuilder sb = new StringBuilder();
                                    sb.Append(textValue);
                                    sb.Remove(z, 1);
                                    sb.Insert(z, Convert.ToString(e.KeyChar));
                                    textBox.Text = Convert.ToString(sb);
                                    e.Handled = true;
                                    selStart++;
                                }
                            }
                            if ((Keys)e.KeyChar == Keys.Back && ((textValue.Length - textBox.SelectionStart == 1) || (textValue.Length - textBox.SelectionStart == 0))) // if press Backspace and (position  one before last from the end or last from the end)
                            { // we using BackSpace after the comma (in the fractional part)
                                int z = textBox.SelectionStart;
                                StringBuilder sb = new StringBuilder();
                                sb.Append(textValue);
                                sb.Remove(z - 1, 1); // we remove from the back with help BackSpace
                                textBox.Text = Convert.ToString(sb);
                                selStart++;
                            }
                            e.Handled = true;
                        }
                    }
                }
            }
            else
            {
                if (((Keys)e.KeyChar == Keys.Back) && (textValue.Length >= 15))
                { // this loop is false when the length of the textBox >= 15 digits and we press Backspace key 
                    // pass
                }
                else
                {
                    e.Handled = true;
                }
            }
            textBox.SelectionStart = selStart; // move cursor 1 position to the right after entering the digits    
        }

        public static void ownMaskedTextBoxEvent(TextBox textBox)
        {
            textBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(MethodsClass.ownMaskedTextBox);
        }

        public static void ownNumberMaskedTextBox(object sender, KeyPressEventArgs e)
        { // it accept only digits and Back key and set format digits
            TextBox textBox = (TextBox)sender;
            int selStart = textBox.SelectionStart;
            string textValue = textBox.Text; // string textValue = textBox.Text;
            if (!((char.IsNumber(e.KeyChar) || (Keys)e.KeyChar == Keys.Back) && (textValue.Length < 15)))
            { // if text value length > 15 and insert value not equal digit or back key
                if (((Keys)e.KeyChar == Keys.Back) && (textValue.Length >= 15))
                { // this loop is false when the length of the textBox >= 15 digits and we press Backspace key 
                    // pass
                }
                else
                {
                    e.Handled = true;
                }
            }
        }

        public static void ownNumberMaskedTextBoxEvent(TextBox textBox)
        {
            textBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(MethodsClass.ownNumberMaskedTextBox);
        }

        public static void ownListViewDrawSubItem(object sender, DrawListViewSubItemEventArgs e)
        {
            e.DrawText(TextFormatFlags.HorizontalCenter);
        }

        public static void ownListViewDrawColumnHeader(object sender, DrawListViewColumnHeaderEventArgs e)
        {
            e.DrawBackground();
            e.DrawText(TextFormatFlags.HorizontalCenter);
        }

        public static StatusBar CreateMyStatusBar()
        { // create customer StatusBar 
            // Create a StatusBar control.
            StatusBar statusBar1 = new StatusBar();
            // Create two StatusBarPanel objects to display in the StatusBar.
            StatusBarPanel panel1 = new StatusBarPanel();
            StatusBarPanel panel2 = new StatusBarPanel();

            // Display the first panel with a sunken border style.
            panel1.BorderStyle = StatusBarPanelBorderStyle.Sunken;
            // Initialize the text of the panel.
            panel1.Text = "Gotowe";
            // Set the AutoSize property to use all remaining space on the StatusBar.
            panel1.AutoSize = StatusBarPanelAutoSize.Spring;

            // Display the second panel with a raised border style.
            panel2.BorderStyle = StatusBarPanelBorderStyle.Raised;

            // Create ToolTip text that displays time the application was 
            //started.
            panel2.ToolTipText = "Prac z programem rozpoczto " + DateTime.Now.ToLongDateString() + " roku o godzinie " + DateTime.Now.ToShortTimeString();
            // Set the text of the panel to the current date.
            panel2.Text = DateTime.Now.ToLongDateString() + "   " + DateTime.Now.ToShortTimeString();
            // Set the AutoSize property to size the panel to the size of the contents.
            panel2.AutoSize = StatusBarPanelAutoSize.Contents;

            // Display panels in the StatusBar control.
            statusBar1.ShowPanels = true;

            // Add both panels to the StatusBarPanelCollection of the StatusBar.            
            statusBar1.Panels.Add(panel1);
            statusBar1.Panels.Add(panel2);

            return statusBar1;
        }

        public static string GetInformations(string column, string table)
        {
            ManagementScope oMs = new ManagementScope();
            ObjectQuery oQuery = new ObjectQuery("SELECT " + column + " FROM " + table);
            ManagementObjectSearcher oSearcher = new ManagementObjectSearcher(oMs, oQuery);
            ManagementObjectCollection oReturnCollection = oSearcher.Get();

            string info = "";
            foreach (ManagementObject oReturn in oReturnCollection)
            {
                info += Convert.ToString(oReturn[column]);

            }
            return info;
        }

        public static string GetMachineOS()
        {
            if (Environment.OSVersion.Platform == PlatformID.Win32NT)
            {
                if (Environment.OSVersion.Version.Major <= 4)
                    return String.Format("Windows NT {0}", Environment.OSVersion.Version.ToString());
                if (Environment.OSVersion.Version.Major == 5)
                {
                    if (Environment.OSVersion.Version.Minor == 0)
                        return String.Format("Windows 2000 {0}", Environment.OSVersion.Version.ToString());
                    else
                        return String.Format("Windows XP {0}", Environment.OSVersion.Version.ToString());
                }
            }

            if (Environment.OSVersion.Platform == PlatformID.Win32Windows)
            {
                if (Environment.OSVersion.Version.Major >= 4)
                {
                    if (Environment.OSVersion.Version.Minor == 0)
                        return String.Format("Windows 95 {0}", Environment.OSVersion.Version.ToString());
                    else if (Environment.OSVersion.Version.Minor < 90)
                        return String.Format("Windows 98 {0}", Environment.OSVersion.Version.ToString());
                    else
                        return String.Format("Windows Millenim Edition {0}", Environment.OSVersion.Version.ToString());
                }
            }

            return Environment.OSVersion.ToString(); //ELSE
        }

        public static string OldPassword(SqlConnection tmpConn)
        { // check password in the database 
            string sOldPassword = "";
            tmpConn.Open();
            string query = "SELECT Haslo FROM ZabezpieczenieProgramu";
            SqlCommand command = new SqlCommand(query, tmpConn);
            try
            {
                sOldPassword = (string)command.ExecuteScalar();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
            return sOldPassword;
        }

        public static string ColumnBookDigitToString(object digit)
        { // convert column book from digit to string  
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //add element to dictionary
            dic.Add("", "");
            dic.Add("6", "<Bez wpisu do ksigi>");
            dic.Add("7", "7 - Sprzeda towarw i usug");
            dic.Add("8", "8 - Pozostae przychody");
            dic.Add("10", "10 - Zakup towarw i materiaw wg. cen zakupu");
            dic.Add("11", "11 - Koszty uboczne zakupu");
            dic.Add("12", "12 - Wynagrodzenia w gotwce i w naturze");
            dic.Add("13", "13 - Pozostae wydatki");
            dic.Add("15", "15 - Inne koszty");
            //display element
            return dic[digit.ToString()];
        }

        public static string ColumnBookStringToDigit(object str)
        { // convert column book from string to digit   
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //add element to dictionary
            dic.Add("", "");
            dic.Add("<Bez wpisu do ksigi>", "6");
            dic.Add("7 - Sprzeda towarw i usug", "7");
            dic.Add("8 - Pozostae przychody", "8");
            dic.Add("10 - Zakup towarw i materiaw wg. cen zakupu", "10");
            dic.Add("11 - Koszty uboczne zakupu", "11");
            dic.Add("12 - Wynagrodzenia w gotwce i w naturze", "12");
            dic.Add("13 - Pozostae wydatki", "13");
            dic.Add("15 - Inne koszty", "15");
            //display element
            return dic[str.ToString()];
        }

        public static string LumpSumPercentToString(object percent)
        { // convert a lump sum from percent to string 
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //add element to dictionary
            dic.Add("", "");
            dic.Add("20.00%", "20.00% - Wedug stawki pierwszej");
            dic.Add("17.00%", "17.00% - Wedug stawki drugiej");
            dic.Add("8.50%", "8.50% - Wedug stawki trzeciej");
            dic.Add("5.50%", "5.50% - Wedug stawki czwartej");
            dic.Add("3.00%", "3.00% - Wedug stawki pitej");
            dic.Add("10.00%", "10.00% - Wedug stawki szstej");
            dic.Add("Brak stawki", "Brak stawki");
            dic.Add("Nie podlega ryczatowi", "<Nie podlega ryczatowi>");
            //display element
            return dic[percent.ToString()];
        }

        public static string LumpSumStringToPercent(object str)
        { // convert a lump sum from string to percent 
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //add element to dictionary
            dic.Add("", "");
            dic.Add("20.00% - Wedug stawki pierwszej", "20.00%");
            dic.Add("17.00% - Wedug stawki drugiej", "17.00%");
            dic.Add("8.50% - Wedug stawki trzeciej", "8.50%");
            dic.Add("5.50% - Wedug stawki czwartej", "5.50%");
            dic.Add("3.00% - Wedug stawki pitej", "3.00%");
            dic.Add("10.00% - Wedug stawki szstej", "10.00%");
            //dic.Add("Brak stawki", "Brak stawki");
            dic.Add("<Nie podlega ryczatowi>", "Nie podlega ryczatowi");
            //display element            
            return dic[str.ToString()];
        }

        public static string KindRegisterDigitToString(object sdigit)
        { // change the kind of the register from digit to long text 
            //create dictionary
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //add element to dictionary
            dic.Add("", "");
            dic.Add("0", "0 - bez ewidencji VAT");
            dic.Add("1", "1 - Dostawa towarw i usug");
            dic.Add("2", "2 - Opodat.nab.r.trw.zw.wycznie z czynnociami opodatkowanymi");
            dic.Add("3", "3 - Opodat.nab.r.trw.zw.z czynnociami opodatkowanymi i zwolnionymi");
            dic.Add("4", "4 - Opodat.nab.r.trw.zw.wy. z czynnociami zwolnionymi");
            dic.Add("5", "5 - Opodat.nab.tow.i us.pozost.zw.wycznie z czynnociami opodatkowanymi");
            dic.Add("6", "6 - Opodat.nab.tow.i us.pozost.zw.z czynnociami opodatkowanymi i zwolnionymi");
            dic.Add("7", "7 - Opodat.nab.tow.i us.pozost.zw.wycznie z czynnociami zwolnionymi");
            dic.Add("8", "8 - Import usug zw.wycznie z czynnociami opodatkowanymi");
            dic.Add("9", "9 - Import usug zw.z czynnociami opodatkowanymi i zwolnionymi");
            dic.Add("10", "10 - Import usug zw.wycznie z czynnociami zwolnionymi");
            dic.Add("11", "11 - Import usug r.trw.zw.wycznie w czynnociami opodatkowanymi");
            dic.Add("12", "12 - Import usug r.trw.zw.z czynnociami opodatkowanymi i zwolnionymi");
            dic.Add("13", "13 - Import usug r.trw.zw.wy.z czynnociami zwolnionymi");
            //display element
            return dic[sdigit.ToString()];
        }

        public static string KindRegisterStringToDigit(object str)
        { // change the kind of the register from long text to digit 
            //create dictionary
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //add element to dictionary
            dic.Add("", "");
            dic.Add("0 - bez ewidencji VAT", "0");
            dic.Add("1 - Dostawa towarw i usug", "1");
            dic.Add("2 - Opodat.nab.r.trw.zw.wycznie z czynnociami opodatkowanymi", "2");
            dic.Add("3 - Opodat.nab.r.trw.zw.z czynnociami opodatkowanymi i zwolnionymi", "3");
            dic.Add("4 - Opodat.nab.r.trw.zw.wy. z czynnociami zwolnionymi", "4");
            dic.Add("5 - Opodat.nab.tow.i us.pozost.zw.wycznie z czynnociami opodatkowanymi", "5");
            dic.Add("6 - Opodat.nab.tow.i us.pozost.zw.z czynnociami opodatkowanymi i zwolnionymi", "6");
            dic.Add("7 - Opodat.nab.tow.i us.pozost.zw.wycznie z czynnociami zwolnionymi", "7");
            dic.Add("8 - Import usug zw.wycznie z czynnociami opodatkowanymi", "8");
            dic.Add("9 - Import usug zw.z czynnociami opodatkowanymi i zwolnionymi", "9");
            dic.Add("10 - Import usug zw.wycznie z czynnociami zwolnionymi", "10");
            dic.Add("11 - Import usug r.trw.zw.wycznie w czynnociami opodatkowanymi", "11");
            dic.Add("12 - Import usug r.trw.zw.z czynnociami opodatkowanymi i zwolnionymi", "12");
            dic.Add("13 - Import usug r.trw.zw.wy.z czynnociami zwolnionymi", "13");
            //display element
            return dic[str.ToString()];
        }

        public static bool CzyWybranaPozycja(ListView listView)
        {
            if (listView == null) return false;
            if (listView.SelectedItems.Count != 1)
            {
                MessageBox.Show("Wybierz jeden wiersz!", "Bd", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
            return true;
        }

        public static void ExeReaderComboBox(ComboBox comboBox, string query)
        { // fill comboBox
            SqlConnection conn = new SqlConnection();
            try
            {
                comboBox.Items.Clear();
                conn.ConnectionString = connectionString;
                SqlCommand com = conn.CreateCommand();
                com.CommandType = CommandType.Text;
                com.CommandText = query;
                conn.Open();

                using (SqlDataReader reader = com.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        comboBox.Items.Add(reader[0].ToString());
                    }
                }
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
        }

        public static void ExeReaderComboBox(ComboBox comboBox, string query, char sign)
        { // fill comboBox 
            SqlConnection conn = new SqlConnection();
            try
            {
                comboBox.Items.Clear();
                conn.ConnectionString = connectionString;
                SqlCommand com = conn.CreateCommand();
                com.CommandType = CommandType.Text;
                com.CommandText = query;
                conn.Open();

                using (SqlDataReader reader = com.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        comboBox.Items.Add(reader[0].ToString() + " " + sign + " " + reader[1].ToString());
                    }
                }
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
        }

        public static bool ExeFunctionRetBool(string nameFunction)
        { // execute function which return bool value 
            bool value = false;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand("SELECT " + nameFunction, conn);
                conn.Open();
                if (Convert.ToInt32(command.ExecuteScalar()) == 1)
                    value = true;
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return value;
        }

        public static object[] GetTwoCellInFromOneWithSign(object str, char sign)
        { // return table of split object 
            object[] table = str.ToString().Split('-');
            for (int i = 0; i < table.Length; i++)
                table[i] = table[i].ToString().Trim();
            return table;
        }

        public static int ExeStoredProcedureRetInt(string nameStoredProcedure)
        { // execute stored procedure which return int value 
            int id = 0;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                conn.Open();
                id = Convert.ToInt32(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return id;
        }

        public static int ExeStoredProcedureRetInt(string nameStoredProcedure, string[] nameOfParameter, object[] valueOfParameter)
        { // execute stored procedure which return int value 
            int id = 0;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                for (int i=0; i<nameOfParameter.Length; i++)
                    command.Parameters.AddWithValue(nameOfParameter[i], valueOfParameter[i]);
                conn.Open();
                id = Convert.ToInt32(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return id;
        }

        public static decimal ExeStoredProcedureRetDecimal(string nameStoredProcedure)
        { // execute stored procedure which return decimal value 
            decimal dec = 0;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                conn.Open();
                dec = Convert.ToDecimal(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return dec;
        }

        public static decimal ExeStoredProcedureRetDecimal(string nameStoredProcedure, string nameOfParameter, object valueOfParameter)
        { // execute stored procedure which return decimal value 
            decimal dec = 0;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.AddWithValue(nameOfParameter, valueOfParameter);
                conn.Open();
                dec = Convert.ToDecimal(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return dec;
        }

        public static int ExeStoredProcedureRetInt(string nameStoredProcedure, string nameOfParameter, object valueOfParameter)
        { // execute stored procedure which return int value 
            int id = 0;
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.AddWithValue(nameOfParameter, valueOfParameter);
                conn.Open();
                id = Convert.ToInt32(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return id;
        }

        public static string ExeStoredProcedureRetString(string nameStoredProcedure, string nameOfParameter, object valueOfParameter)
        { // execute stored procedure which return string value 
            string retValue = "";
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                command.Parameters.AddWithValue(nameOfParameter, valueOfParameter);
                conn.Open();
                retValue = Convert.ToString(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return retValue;
        }

        public static string ExeStoredProcedureRetString(string nameStoredProcedure, string[] nameOfParameter, object[] valueOfParameter)
        { // execute stored procedure which return string value 
            string retValue = "";
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandText = nameStoredProcedure;
                command.CommandType = CommandType.StoredProcedure;
                command.Connection = conn;
                for (int i = 0; i < nameOfParameter.Length; i++)
                    command.Parameters.AddWithValue(nameOfParameter[i], valueOfParameter[i]);
                conn.Open();
                retValue = Convert.ToString(command.ExecuteScalar());
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
            return retValue;
        }

        public static void InvalidOperationExceptionFunction(InvalidOperationException ex)
        {
            string str = "Source:" + ex.Source;
            str += "\n" + "Message:" + ex.Message;
            str += "\n" + "\n";
            str += "\n" + "Stack Trace :" + ex.StackTrace;
            MessageBox.Show(str, "Specific Exception");

            FileStream fsZapis = new FileStream("C://errorSpecificException.txt", FileMode.Create);
            //create stream type StreamWriter
            StreamWriter sw = new StreamWriter(fsZapis);
            sw.WriteLine(str);
            sw.Close();
            MessageBox.Show("It was create file name errorSpecificException.txt on the hard disc name C", "Specific Exception", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public static void SqlExceptionFunction(SqlException ex)
        {
            StringBuilder errorMessages = new StringBuilder();
            for (int i = 0; i < ex.Errors.Count; i++)
            {
                errorMessages.Append("Index #" + i + "\n" +
                    "Message: " + ex.Errors[i].Message + "\n" +
                    "LineNumber: " + ex.Errors[i].LineNumber + "\n" +
                    "Source: " + ex.Errors[i].Source + "\n" +
                    "Procedure: " + ex.Errors[i].Procedure + "\n");
            }
            MessageBox.Show(errorMessages.ToString(), "Database Exception");

            FileStream fsZapis = new FileStream("C://errorDatabaseException.txt", FileMode.Create);
            //create stream type StreamWriter
            StreamWriter sw = new StreamWriter(fsZapis);
            sw.WriteLine(errorMessages);
            sw.Close();
            MessageBox.Show("It was create file name errorDatabaseException.txt on the hard disc name C", "Database Exception", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public static void GenericExceptionFunction(Exception ex)
        {
            string str = "Source:" + ex.Source;
            str += "\n" + "Message:" + ex.Message;
            MessageBox.Show(str, "Generic Exception");

            FileStream fsZapis = new FileStream("C://errorGenericException.txt", FileMode.Create);
            //create stream type StreamWriter
            StreamWriter sw = new StreamWriter(fsZapis);
            sw.WriteLine(str);
            sw.Close();
            MessageBox.Show("It was create file name errorGenericException.txt on the hard disc name C", "Database Exception", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public static void FinallyExceptionFunction(SqlConnection connection)
        {
            if (connection.State == ConnectionState.Open)
            {
                //MessageBox.Show("Finally block closing the connection", "Finally");
                connection.Close();
            }
        }

        public static void UsunPozycje(string query, ListView listView)
        { // Delete item from ListView
            SqlConnection tmpConn = MethodsClass.SqlConnect();
            try
            {
                tmpConn.Open();
                using (SqlCommand myCommand = new SqlCommand(query, tmpConn))
                {
                    myCommand.ExecuteNonQuery();
                }
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
            listView.Items.Remove(listView.SelectedItems[0]);
        }

        public static int ExeScalarInt(string query)
        { 
            int id = 0;
            SqlConnection tmpConn = MethodsClass.SqlConnect(); 
            SqlCommand myCommand = new SqlCommand(query, tmpConn);
            try
            {
                tmpConn.Open();
                id = (int)myCommand.ExecuteScalar();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
            return id;
        }

        public static string ExeScalarString(string query)
        {
            string id = "";
            SqlConnection tmpConn = MethodsClass.SqlConnect();
            SqlCommand myCommand = new SqlCommand(query, tmpConn);
            try
            {
                tmpConn.Open();
                id = (string)myCommand.ExecuteScalar();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
            return id;
        }

        public static void ExeNonQuery(string query)
        {
            SqlConnection tmpConn = MethodsClass.SqlConnect();
            SqlCommand myCommand = new SqlCommand(query, tmpConn);
            try
            {
                tmpConn.Open();
                myCommand.ExecuteNonQuery();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
        }

        public static int GetShortDayFromStringDate(object text)
        {
            return (((DateTime)text)).Day;
        }

        public static string GetLongMonthFromStringDate(object text)
        {
            return month[((DateTime)text).Month - 1];
        }

        public static int GetShortMonthFromStringDate(object text)
        {
            return ((DateTime)text).Month;
        }

        public static int GetShortYearFromStringDate(object text)
        { 
            return ((DateTime)text).Year;
        }

        public static string GetStringMonthFromInt(int monthValue)
        { // return month in string format
            return month[monthValue-1];
        }

        public static string ConvertMoneyToString(object text)
        { // convert Datetime to the correct string format
            return String.Format("{0:F}", text); // return format 1230.00
        }

        public static void SetDateFormatDataGridView(DataGridView dataGridView, string column)
        { // set format to the DateTime column in the DataGridView
            dataGridView.Columns[column].DefaultCellStyle.Format = "dd-MM-yyyy";
        }

        public static void SetMoneyFormatDataGridView(DataGridView dataGridView, string column)
        { // set format to the Money column in the DataGridView
            dataGridView.Columns[column].DefaultCellStyle.Format = "N2";
        }

        public static bool ifSelectedRow(DataGridView dataGridView)
        { // if row is selected
            int selectedRowCount = dataGridView.Rows.GetRowCount(DataGridViewElementStates.Selected);
            if (selectedRowCount == 1)
            {
                return true;
            }
            else if (selectedRowCount == 0)
            {
                MesBoxShowError("Wybierz wiersz", "Bd");
                return false;
            }
            else //if (selectedRowCount > 1)
            {
                MesBoxShowError("Wybierz jeden wiersz", "Bd");
                return false;
            }
        }

        public static void ExeUspUpdateBooked(string nameStoredProcedure, string id, object idV, string boolValue, object boolV)
        { // execute using stored procedure which update cell name booked in the database 
            SqlConnection conn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand command = new SqlCommand(nameStoredProcedure, conn);
                command.CommandType = CommandType.StoredProcedure;
                command.Parameters.AddWithValue(id, idV);
                command.Parameters.AddWithValue(boolValue, boolV);
                conn.Open();
                command.ExecuteNonQuery();
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(conn);
            }
        }

        public static int[] GetDateFromDataKsiegowania()
        { // return date from DataKsiegowania table 
            int month = MethodsClass.ExeStoredProcedureRetInt("uspGetMonthFromDataKsiegowania");
            int year = MethodsClass.ExeStoredProcedureRetInt("uspGetYearFromDataKsiegowania");
            int day = DateTime.Today.Day;
            if ((month == 4) || (month == 6) || (month == 9) || (month == 11))
                if (day == 31)
                    day = 30;
            if (month == 2)
                if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0)
                    if (day > 28)
                        day = 29;
            return new int[] { year, month, day};
        }
    }
}
