using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace UserControl
{
    class MoneyTextBox : TextBox
    { // create customer TextBox 
        public MoneyTextBox()
        {
            InitializeComponent();
        }

        private void InitializeComponent()
        {
            this.Text = "0,00";
            this.BackColor = Color.White;
            this.TextAlign = HorizontalAlignment.Right;
            this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(ownMaskedTextBox);
            this.TextChanged += new EventHandler(convertMoneyToString);
        }

        private void convertMoneyToString(object sender, EventArgs e)
        {
            decimal decimalNumber;
            TextBox textBox = (TextBox)sender;
            if (Decimal.TryParse(textBox.Text, out decimalNumber)) 
                textBox.Text = String.Format("{0:F}", decimalNumber); // return format 1230.0
        }

        private void ownMaskedTextBox(object sender, KeyPressEventArgs e)
        { // it accept only digits, comma, dot and Back key and set format 0,00
            TextBox textBox = (TextBox)sender;
            int selStart = textBox.SelectionStart;
            string textValue = textBox.Text; // string textValue = textBox.Text;
            if ((char.IsNumber(e.KeyChar) || e.KeyChar == '.' || e.KeyChar == ',' || (Keys)e.KeyChar == Keys.Back) && (textValue.Length < 15))
            {
                if ((e.KeyChar == '.' || e.KeyChar == ',') && (sender as TextBox).Text.IndexOf(',') > -1) // if already exist . or decimal 
                {
                    if ((textValue.Length - textBox.SelectionStart) == 3) // item before decimal
                    { // if we press dot (or comma) we moved 1 positon to the right but it doesn't insert dot (or comma)
                        // but we must be before the comma
                        textBox.SelectionStart += 1;
                        selStart++;
                    }
                    e.Handled = true;
                }

                if ((e.KeyChar == '.') && (textValue.IndexOf(",") == -1)) // check if comma exist
                { // exchanged dot on comma when the comma doesn't exist
                    int z = textBox.SelectionStart;
                    {
                        StringBuilder sb = new StringBuilder();
                        sb.Append(textValue);
                        sb.Insert(z, Convert.ToString(","));
                        textBox.Text = Convert.ToString(sb);
                        e.Handled = true;
                        selStart++;
                    }
                }

                if (textValue.IndexOf(",") != -1) // check if comma exist
                {
                    if (char.IsNumber(e.KeyChar) && ((textValue.Length - textBox.SelectionStart == 4)))
                    { // insert digit before the comma
                        int z = textBox.SelectionStart;
                        {
                            StringBuilder sb = new StringBuilder();
                            sb.Append(textValue);
                            sb.Remove(z, 1);
                            sb.Insert(z, Convert.ToString(e.KeyChar));
                            textBox.Text = Convert.ToString(sb);
                            e.Handled = true;
                            selStart++;
                        }
                    }
                }

                if (textValue.IndexOf(",") != -1) // check if comma exist
                {
                    if (textBox.SelectionStart > textValue.IndexOf(","))
                    {
                        if (textValue.Length - textValue.IndexOf(",") == 3)
                        { // position after the comma 
                            if (char.IsNumber(e.KeyChar) && ((textValue.Length - textBox.SelectionStart == 2) || (textValue.Length - textBox.SelectionStart == 1)))
                            { // insert digits after the comma 
                                int z = textBox.SelectionStart;
                                {
                                    StringBuilder sb = new StringBuilder();
                                    sb.Append(textValue);
                                    sb.Remove(z, 1);
                                    sb.Insert(z, Convert.ToString(e.KeyChar));
                                    textBox.Text = Convert.ToString(sb);
                                    e.Handled = true;
                                    selStart++;
                                }
                            }
                            if ((Keys)e.KeyChar == Keys.Back && ((textValue.Length - textBox.SelectionStart == 1) || (textValue.Length - textBox.SelectionStart == 0))) // if press Backspace and (position  one before last from the end or last from the end)
                            { // we using BackSpace after the comma (in the fractional part)
                                int z = textBox.SelectionStart;
                                StringBuilder sb = new StringBuilder();
                                sb.Append(textValue);
                                sb.Remove(z - 1, 1); // we remove from the back with help BackSpace
                                textBox.Text = Convert.ToString(sb);
                                selStart++;
                            }
                            e.Handled = true;
                        }
                    }
                }
            }
            else
            {
                if (((Keys)e.KeyChar == Keys.Back) && (textValue.Length >= 15))
                { // this loop is false when the length of the textBox >= 15 digits and we press Backspace key 
                    // pass
                }
                else
                {
                    e.Handled = true;
                }
            }
            textBox.SelectionStart = selStart; // move cursor 1 position to the right after entering the digits    
        }
    }
}
