using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Drawing.Printing;

namespace ProgramDB
{
    public partial class NotyKorygujace : Form, InterfaceClass.ITakeData
    {
        private DataGridViewPrinter MyDataGridViewPrinter;
        private string comboBoxText;
        private string[] sqlData ={ "Nr noty korygujcej", "Data noty", "DotyczFVKor", "Nr faktury", "Data faktury", "Z dat sprzeday", "TrescKorygowana", "TrescPrawidlowa" }; // "KontrahenciID"          
        private int[] positionSqlDataInDataGridView ={ 0, 1, 2, 4, 5, 6 };
        public NotyKorygujace()
        {
            InitializeComponent();
        }

        private int WybranyWiersz
        {
            get
            {
                return dataGridView1.SelectedRows[0].Index; // return selected row
            }
        }

        public DataTable GetTableToComboBox()
        {
            return dataSet1.Tables["KontrahenciTabela"]; 
        }

        public string ComboBoxText
        {
            get
            {
                return comboBoxText;
            }
        }

        public void EdytujOK(params object[] text)
        { // Zapisujemy zmiany w edytowanej nocie korygujacej
            int i = 0;
            int ww = WybranyWiersz; // optimization 
            for (; i < sqlData.Length; i++)
            {
                if (i != 2)
                    dataGridView1.Rows[ww].Cells[sqlData[i]].Value = text[i];
                else
                    dataGridView1.Rows[ww].Cells[sqlData[i]].Value = bool.Parse(text[i].ToString());
            }
            DataColumn[] keys = new DataColumn[1];
            keys[0] = dataSet1.Tables["KontrahenciTabela"].Columns["NazwaSkrocona"];
            dataSet1.Tables["KontrahenciTabela"].PrimaryKey = keys;
            
            DataRow findMyRow = dataSet1.Tables["KontrahenciTabela"].Rows.Find(text[i]);
            dataGridView1.Rows[ww].Cells["KontrahenciID"].Value = findMyRow[0];
        }

        public void Dodaj(params object[] text)
        {  // Dodajemy jedna note korygujaca
            DataRow myDataRow = dataSet1.Tables["NotyKorygujaceTabela"].NewRow();
            int i = 0;
            for (; i < sqlData.Length; i++)
            {
                if (i != 2)
                    myDataRow[sqlData[i]] = text[i];
                else
                {
                    myDataRow[sqlData[i]] = bool.Parse(text[i].ToString());
                }
            }

            DataColumn[] keys = new DataColumn[1];
            keys[0] = dataSet1.Tables["KontrahenciTabela"].Columns["NazwaSkrocona"];
            dataSet1.Tables["KontrahenciTabela"].PrimaryKey = keys;
            
            DataRow findMyRow = dataSet1.Tables["KontrahenciTabela"].Rows.Find(text[i]);
            myDataRow["KontrahenciID"] = findMyRow[0];   
            dataSet1.Tables["NotyKorygujaceTabela"].Rows.Add(myDataRow);
        }

        private void NotyKorygujace_Load(object sender, EventArgs e)
        {  // create table noty korygujace if does not exist
            if (!MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            {
                MethodsClass.MesBoxShowError("Dana firma nie istnieje", "Bd");
                return;
            }

            if (!MethodsClass.DbTableExists("KontrahenciTabela", MethodsClass.sConnectionString))
            {
                MethodsClass.MesBoxShowError("Zdefiniuj najpierw kontrahentow!", "Bd");
                return;    
            }

            if (!MethodsClass.DbTableExists("NotyKorygujaceTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE NotyKorygujaceTabela (NotyKorygujaceID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY, " +
"NrNoty INT NULL, DataNoty DATETIME NULL, DotyczFVKor BIT NULL, " + 
"NotaDoFaktury NVARCHAR(50) NULL, ZDnia DATETIME NULL, ZDataSprzedazy DATETIME NULL, TrescKorygowana NVARCHAR(50) NULL, TrescPrawidlowa NVARCHAR(50) NULL, KontrahenciID INT NOT NULL REFERENCES KontrahenciTabela (KontrahenciID) " + ")";
                MethodsClass.ExeNonQuery(sCreateTable);
            }
                        
            this.sqlDataAdapter2.Fill(this.dataSet1, "KontrahenciTabela");
            this.sqlDataAdapter1.Fill(this.dataSet1, "NotyKorygujaceTabela");
            dataSet1.Relations.Add("Noty_Kontrahenci", dataSet1.Tables["KontrahenciTabela"].Columns["KontrahenciID"],
dataSet1.Tables["NotyKorygujaceTabela"].Columns["KontrahenciID"], false);
            dataGridView1.DataSource = dataSet1; 
            dataGridView1.DataMember = "NotyKorygujaceTabela";

            dataGridView1.Columns[0].Visible = false;
            dataGridView1.Columns[3].Visible = false;
            dataGridView1.Columns[7].Visible = false;
            dataGridView1.Columns[8].Visible = false;
            dataGridView1.Columns[9].Visible = false;
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[1]);
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[4]);
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[5]);
            dataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            dataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            dataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            dataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            dataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            dataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            dataGridView1.GridColor = SystemColors.ControlDarkDark;
            dataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);
            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter; 
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NowaNotaKorygujaca nowaNotaKoryg = new NowaNotaKorygujaca(this, true); // set false when we clicked Nowy button
            if (nowaNotaKoryg.ShowDialog() == DialogResult.OK)
                nowaNotaKoryg.Close();
        }

        private void Usun_Click(object sender, EventArgs e)
        {            
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(dataGridView1))
                {
                    if (dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        dataGridView1.Rows.Remove(dataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }
            }
        }

        private void NotyKorygujace_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.F2:
                    Nowy_Click(null, null);
                    break;
                case Keys.F4:
                    drukuj_Click(null, null);
                    break;
                case Keys.F8:
                    Usun_Click(null, null);
                    break;
                case Keys.F10:
                    Close();
                    break;
                default:
                    break;
            }
        }

        private void Wyjscie_Click(object sender, EventArgs e)
        {
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
                sqlDataAdapter1.Update(dataSet1);
        }

        private void dataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    DataColumn[] keys = new DataColumn[1];
                    keys[0] = dataSet1.Tables["KontrahenciTabela"].Columns["KontrahenciID"];
                    dataSet1.Tables["KontrahenciTabela"].PrimaryKey = keys;

                    DataRow findMyRow = dataSet1.Tables["KontrahenciTabela"].Rows.Find(dataGridView1.Rows[WybranyWiersz].Cells["KontrahenciID"].Value);
                    comboBoxText = findMyRow[1].ToString();

                    NowaNotaKorygujaca edycjaNotyKoryg = new NowaNotaKorygujaca(this, false); // set false when we clicked Edytuj button
                    edycjaNotyKoryg.Text = "Edycja grupy kontrahentw";
                    edycjaNotyKoryg.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[4]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[7]].Value);
                    if (edycjaNotyKoryg.ShowDialog() == DialogResult.OK)
                        edycjaNotyKoryg.Close();
                }
            }
            else
            {
                MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
            }
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = printDocument1;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private void drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            printDocument1.DocumentName = "PrintDocument";
            printDocument1.PrinterSettings = MyPrintDialog.PrinterSettings;
            printDocument1.DefaultPageSettings = MyPrintDialog.PrinterSettings.DefaultPageSettings;
            printDocument1.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(dataGridView1, printDocument1, true, true, "Noty korygujce", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(dataGridView1, printDocument1, false, true, "Noty korygujce", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);

            return true;
        }
    }
}