using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ProgramDB
{
    public partial class NowaFirma : Form
    {
        public NowaFirma()
        {
            InitializeComponent();
            MethodsClass.ownNumberMaskedTextBoxEvent(this.nrDomuTextBox);
            MethodsClass.ownNumberMaskedTextBoxEvent(this.nrLokaluTextBox);
            MethodsClass.ownNumberMaskedTextBoxEvent(this.kod1TextBox);
            MethodsClass.ownNumberMaskedTextBoxEvent(this.kod2TextBox);
        }
        private static string idenFirmy, nazwaSk, nazwaFull, NIP, regon, nrZezwolenia, urzadSkarbowy, bank, konto, rodzajDzialalnosci, kraj,
wojewodzctwo, powiat, gmina, ulica, miejscowosc, poczta, telefon, email, miejsceProwDzial;
        private static int nrDomu, nrLokalu, kod1, kod2;
        public static bool ewidencjaVAT, PKPiR;

        public static string IdenFirmy
        {
            get
            {
                return idenFirmy;
            }
        }

        public static bool EwidencjaVAT
        {
            get
            {
                return ewidencjaVAT;
            }
        }

        public static bool GetPKPiR
        {
            get
            {
                return PKPiR;
            }
        }

        private void NowaFirma_Load(object sender, EventArgs e)
        {
            if (MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database) && MethodsClass.IsNotEmptyTable("DaneFirmy"))  // Jeeli istnieje baza danych (i tabela DaneFirmy) zwraca true
            {   // fill the form from the table in the database 
                this.Text = "Edycja danych firmy";
                using (SqlConnection con = new SqlConnection())
                {
                    con.ConnectionString = MethodsClass.sConnectionString;
                    SqlCommand com = con.CreateCommand();
                    com.CommandType = CommandType.Text;
                    com.CommandText = "IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[DaneFirmy]')" +
"AND OBJECTPROPERTY(id, N'IsUserTable') = 1) SELECT idenFirmy, nazwaSk, nazwaFull, NIP, regon, nrZezwolenia, urzadSkarbowy, bank, konto, rodzajDzialalnosci, kraj, wojewodzctwo,"+
"powiat, gmina, ulica, nrDomu, nrLokalu, miejscowosc, kod1, kod2, poczta, telefon, email, miejsceProwDzial, ewidencjaVAT, PKPiR FROM DaneFirmy";
                    con.Open();

                    using (SqlDataReader reader = com.ExecuteReader())
                    {
                        while (reader.Read())
                        {                            
                            tbIdentFirmy.Text = (string) reader[0];
                            tbNazwaSkrocona.Text = (string) reader[1];
                            tbNazwaPelna.Text = (string) reader[2];
                            tbNIP.Text = (string) reader[3];
                            tbREGON.Text = (string) reader[4];
                            tbNrZezwolenia.Text = (string) reader[5];
                            tbUrzadSkarb.Text = (string) reader[6];
                            textBox8.Text = (string) reader[7];
                            textBox9.Text = (string) reader[8];
                            textBox10.Text = (string) reader[9];
                            tbKraj.Text = (string) reader[10];
                            tbWojewodzctwo.Text = (string) reader[11];
                            textBox13.Text = (string) reader[12];
                            textBox14.Text = (string) reader[13];
                            tbUlica.Text = (string) reader[14];
                            nrDomuTextBox.Text = Convert.ToString(reader[15]);
                            nrLokaluTextBox.Text = Convert.ToString(reader[16]);
                            tbMiejscowosc.Text = (string) reader[17];
                            kod1TextBox.Text = Convert.ToString(reader[18]);
                            kod2TextBox.Text = Convert.ToString(reader[19]);
                            textBox21.Text = (string) reader[20];
                            textBox22.Text = (string) reader[21];
                            textBox23.Text = (string) reader[22];
                            textBox24.Text = (string) reader[23];
                            checkBox1.Checked = (bool) reader[24];
                            PKPiRCheckBox.Checked = (bool) reader[25];
                            EwidenPrzychCheckBox.Checked = ! Convert.ToBoolean(reader[25]);
                        }                    
                    }
                }
            }
        }
        private void OK_Click(object sender, EventArgs e)
        {
            if ((tbIdentFirmy.Text == "") || (tbNazwaSkrocona.Text == "") || (tbNazwaPelna.Text == "") || (tbNIP.Text == "") || (tbREGON.Text == "") || (tbNrZezwolenia.Text =="") || (tbUrzadSkarb.Text == "") || (tbKraj.Text == "") || (tbWojewodzctwo.Text == "") || (tbUlica.Text == "") || (tbMiejscowosc.Text == "") || (nrDomuTextBox.Text == "") || (nrLokaluTextBox.Text == "") || (kod1TextBox.Text == "") || (kod2TextBox.Text == ""))
            {
                MethodsClass.MesBoxShowWarning("Podaj wszystkie wymagane wartoci", "Uwaga");
                return;
            }
            idenFirmy = tbIdentFirmy.Text;
            nazwaSk = tbNazwaSkrocona.Text;
            nazwaFull = tbNazwaPelna.Text;
            NIP = tbNIP.Text;
            regon = tbREGON.Text;
            nrZezwolenia = tbNrZezwolenia.Text;
            urzadSkarbowy = tbUrzadSkarb.Text;
            bank = textBox8.Text;
            konto = textBox9.Text;
            rodzajDzialalnosci = textBox10.Text;
            kraj = tbKraj.Text;
            wojewodzctwo = tbWojewodzctwo.Text;
            powiat = textBox13.Text;
            gmina = textBox14.Text;
            ulica = tbUlica.Text;
            nrDomu = Convert.ToInt32(nrDomuTextBox.Text);
            nrLokalu = Convert.ToInt32(nrLokaluTextBox.Text);
            miejscowosc = tbMiejscowosc.Text;
            kod1 = Convert.ToInt32(kod1TextBox.Text);
            kod2 = Convert.ToInt32(kod2TextBox.Text);
            poczta = textBox21.Text;
            telefon = textBox22.Text;
            email = textBox23.Text;
            miejsceProwDzial = textBox24.Text;
            ewidencjaVAT = checkBox1.Checked;
            PKPiR = PKPiRCheckBox.Checked;
            if (MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database))
            { // update the table in the database 
                string sUpdateFirstRow = "UPDATE DaneFirmy SET idenFirmy = '" + idenFirmy+
"' , nazwaSk = '" + nazwaSk + "' , nazwaFull = '" + nazwaFull + "' , NIP = '" + NIP + "' , regon = '" + regon + "' , nrZezwolenia = '" + nrZezwolenia +
"' , urzadSkarbowy = '" + urzadSkarbowy + "' , bank ='" + bank + "' , konto = '" + konto + "' , rodzajDzialalnosci = '" + rodzajDzialalnosci +
"' , kraj = '" + kraj + "' , wojewodzctwo ='" + wojewodzctwo + "' , powiat = '" + powiat + "' , gmina = '" + gmina +
"' , ulica = '" + ulica + "' , nrDomu = '" + nrDomu + "', nrLokalu = '" + nrLokalu + "' , miejscowosc = '" + miejscowosc +
"' , kod1 = '" + kod1 + "' , kod2 = '" + kod2 + "' , poczta = '" + poczta + "' , telefon = '" + telefon + "', email = '" + email +
"' , miejsceProwDzial = '" + miejsceProwDzial + "' , ewidencjaVAT = '" + ewidencjaVAT + "' , PKPiR = '" + PKPiR +"'";
                MethodsClass.ExeNonQuery(sUpdateFirstRow);
            }
            else
            {
                SqlConnection tmpConn = new SqlConnection(MethodsClass.MasterConnectionString);
                string sqlCreateDBQuery = "CREATE DATABASE BazaDanychFileStream ";
                string sqlq = " USE BazaDanychFileStream";
                /*sqlCreateDBQuery = " CREATE DATABASE BazaDanychFileStream"
                                   + " ON PRIMARY "
                                   + " (NAME = BazaDanychFileStream_data" + ", "
                                   + " FILENAME = 'D:\\BazaDanychFileStream_data.mdf', "
                                   + " SIZE = 3MB,"
                                   + " FILEGROWTH = 5MB " + ") "
                                   + " LOG ON (NAME = MojaBazaDanych_Log " + ", "
                                   + " FILENAME = 'D:\\MojaBazaDanychLog.ldf', "
                                   + " SIZE = 3MB, "
                                   + " FILEGROWTH = 5MB " + ") "; */

                string sCreateTable = "CREATE TABLE DaneFirmy (FirmaID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY," +
"idenFirmy NVARCHAR(50) NOT NULL, nazwaSk NVARCHAR(50) NOT NULL, nazwaFull NVARCHAR(50) NOT NULL, " +
"NIP NVARCHAR(50) NULL, regon NVARCHAR(50) NULL, nrZezwolenia NVARCHAR(50) NULL, urzadSkarbowy NVARCHAR(50) NOT NULL, bank NVARCHAR(50) NULL," +
"konto NVARCHAR(50) NULL, rodzajDzialalnosci NVARCHAR(50) NULL, kraj NVARCHAR(50) NOT NULL, wojewodzctwo NVARCHAR(50) NOT NULL, powiat NVARCHAR(50) NULL, gmina NVARCHAR(50) NULL, ulica NVARCHAR(50) NULL," +
"nrDomu naturalnumber, nrLokalu naturalnumber, miejscowosc NVARCHAR(50) NOT NULL," +
"kod1 naturalnumber, kod2 naturalnumber, poczta NVARCHAR(50) NULL, telefon NVARCHAR(50) NULL, email NVARCHAR(50) NULL, miejsceProwDzial NVARCHAR(50) NULL, ewidencjaVAT BIT, PKPiR BIT" + ")";
                
                string sInsertFirstRow = "INSERT INTO DaneFirmy (idenFirmy, nazwaSk, nazwaFull, NIP, regon, nrZezwolenia, urzadSkarbowy, bank, konto, rodzajDzialalnosci, kraj, wojewodzctwo, powiat, gmina, ulica, nrDomu, nrLokalu, miejscowosc, kod1, kod2, poczta, telefon, email, miejsceProwDzial, ewidencjaVAT, PKPiR)"
+ "VALUES( @idenFirmy, @nazwaSk, @nazwaFull, @NIP, @regon, @nrZezwolenia, @urzadSkarbowy, @bank, @konto, @rodzajDzialalnosci, @kraj, @wojewodzctwo, @powiat, @gmina, @ulica, @nrDomu, @nrLokalu, @miejscowosc, @kod1, @kod2, @poczta, @telefon, @email, @miejsceProwDzial, @ewidencjaVAT, @PKPiR )";

                string CreateTableDataKsieg = "CREATE TABLE DataKsiegowania (DataKsiegID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY," +
"Miesiac TINYINT NOT NULL, Rok SMALLINT NOT NULL )";

                string InsertFirstRowDataKsieg = "INSERT INTO DataKsiegowania (Miesiac, Rok) VALUES( @Miesiac, @Rok )";
                SqlTransaction transaction = null;
                SqlCommand myCommand;
                
                try
                {
                    tmpConn.Open();
                    myCommand = tmpConn.CreateCommand();
                    myCommand.CommandText = sqlCreateDBQuery;
                    myCommand.ExecuteNonQuery();
                    transaction = tmpConn.BeginTransaction("myTransaction");
                    myCommand.Transaction = transaction;
                    myCommand.CommandText = sqlq;
                    myCommand.ExecuteNonQuery();
                    myCommand.CommandText = sCreateTable;
                    myCommand.ExecuteNonQuery();
                    myCommand.CommandText = sInsertFirstRow;
                    myCommand.Parameters.AddWithValue("@idenFirmy", idenFirmy);
                    myCommand.Parameters.AddWithValue("@nazwaSk", nazwaSk);
                    myCommand.Parameters.AddWithValue("@nazwaFull", nazwaFull);
                    myCommand.Parameters.AddWithValue("@NIP", NIP);
                    myCommand.Parameters.Add("@regon", SqlDbType.NVarChar, 50);
                    myCommand.Parameters.Add("@nrZezwolenia", SqlDbType.NVarChar, 50);
                    myCommand.Parameters.Add("@urzadSkarbowy", SqlDbType.NVarChar, 50);
                    myCommand.Parameters.Add("@bank", SqlDbType.NVarChar, 50);
                    myCommand.Parameters.Add("@konto", SqlDbType.NVarChar, 50);
                    myCommand.Parameters.Add("@rodzajDzialalnosci", SqlDbType.NVarChar, 50);
                    myCommand.Parameters.Add("@kraj", SqlDbType.NVarChar, 50);
                    myCommand.Parameters["@regon"].Value = regon;
                    myCommand.Parameters["@nrZezwolenia"].Value = nrZezwolenia;
                    myCommand.Parameters["@urzadSkarbowy"].Value = urzadSkarbowy;
                    myCommand.Parameters["@bank"].Value = bank;
                    myCommand.Parameters["@konto"].Value = konto;
                    myCommand.Parameters["@rodzajDzialalnosci"].Value = rodzajDzialalnosci;
                    myCommand.Parameters["@kraj"].Value = kraj;
                    myCommand.Parameters.Add("@wojewodzctwo", SqlDbType.NVarChar, 50).Value = wojewodzctwo;
                    myCommand.Parameters.Add("@powiat", SqlDbType.NVarChar, 50).Value = powiat;
                    myCommand.Parameters.Add("@gmina", SqlDbType.NVarChar, 50).Value = gmina;
                    myCommand.Parameters.Add("@ulica", SqlDbType.NVarChar, 50).Value = ulica;
                    myCommand.Parameters.Add("@nrDomu", SqlDbType.Int, 50).Value = nrDomu;
                    myCommand.Parameters.Add("@nrLokalu", SqlDbType.Int, 50).Value = nrLokalu;
                    myCommand.Parameters.Add("@miejscowosc", SqlDbType.NVarChar, 50).Value = miejscowosc;
	                SqlParameter param1  = new SqlParameter();
                    param1.ParameterName = "@kod1";
                    param1.Value = kod1;
                    myCommand.Parameters.Add(param1);
                    SqlParameter param2 = new SqlParameter();
                    param2.ParameterName = "@kod2";
                    param2.Value = kod1;
                    myCommand.Parameters.Add(param2);
                    SqlParameter param3 = new SqlParameter();
                    param3.ParameterName = "@poczta";
                    param3.Value = poczta;
                    myCommand.Parameters.Add(param3);
                    myCommand.Parameters.Add(new SqlParameter("@telefon", telefon));
                    myCommand.Parameters.Add(new SqlParameter("@email", email));
                    myCommand.Parameters.Add(new SqlParameter("@miejsceProwDzial", miejsceProwDzial));
                    SqlParameter param4 = myCommand.CreateParameter();
                    param4.ParameterName = "@ewidencjaVAT";
                    param4.SqlDbType = SqlDbType.NVarChar; 
                    param4.Value = ewidencjaVAT;
                    myCommand.Parameters.Add(param4);
                    SqlParameter param5 = myCommand.CreateParameter();
                    param5.ParameterName = "@PKPiR";
                    param5.Value = PKPiR;
                    myCommand.Parameters.Add(param5);

                    myCommand.ExecuteNonQuery();
                    myCommand.CommandText = CreateTableDataKsieg;
                    myCommand.ExecuteNonQuery();
                    myCommand.CommandText = InsertFirstRowDataKsieg;
                    myCommand.Parameters.AddWithValue("@Miesiac", DateTime.Today.Month);
                    myCommand.Parameters.AddWithValue("@Rok", DateTime.Today.Year);
                    myCommand.ExecuteNonQuery();
                    transaction.Commit();
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MethodsClass.SqlExceptionFunction(ex);
                    transaction.Rollback("myTransaction"); 
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
                finally
                {
                    transaction.Dispose();
                    MethodsClass.FinallyExceptionFunction(tmpConn);
                }
            }
            Close();
        }

        private void PKPiRCheckBox_MouseClick(object sender, MouseEventArgs e)
        {
            if (PKPiRCheckBox.Checked)
                EwidenPrzychCheckBox.Checked = false;
            else
                EwidenPrzychCheckBox.Checked = true;
        }

        private void EwidenPrzychCheckBox_MouseClick(object sender, MouseEventArgs e)
        {
            if (EwidenPrzychCheckBox.Checked)
                PKPiRCheckBox.Checked = false;
            else
                PKPiRCheckBox.Checked = true;
        }
    }
}