﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ProgramDB
{
    public partial class NoweKontoKsięgowe : Form, InterfaceClass.ISendData
    {
        private KontaKsięgowe kk;
        private bool czyNowy;
        public NoweKontoKsięgowe(KontaKsięgowe k, bool nowy)
        {
            InitializeComponent();
            kk = k;
            czyNowy = nowy;
            if (!MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                comboBox1.Items.Clear();
                comboBox1.Items.AddRange(new string[] { "20.00% - Według stawki pierwszej", "17.00% - Według stawki drugiej", "8.50% - Według stawki trzeciej", "5.50% - Według stawki czwartej", "3.00% - Według stawki piątej", "10.00% - Według stawki szóstej", "Brak stawki", "<Nie podlega ryczałtowi>" });   
                kolumnaKsiazkiLabel.Text = "Ryczałt";
            }
            comboBox2.Text = "0 - bez ewidencji VAT";
        }

        public void Edytuj(params object[] text)
        {  // Retrieves data for editing 
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                kontoKsNumberTextBox.Text = text[0].ToString();
                textBox2.Text = text[1].ToString();
                textBox3.Text = text[2].ToString();
                comboBox1.Text = MethodsClass.ColumnBookDigitToString(text[3]);
                comboBox2.Text = MethodsClass.KindRegisterDigitToString(text[4]);
                NrRejestracyjnyTextBox.Text = text[5].ToString();
            }
            else
            {
                kontoKsNumberTextBox.Text = text[0].ToString();
                textBox2.Text = text[1].ToString();
                textBox3.Text = text[2].ToString();
                comboBox1.Text = MethodsClass.LumpSumPercentToString(text[3]);
                comboBox2.Text = MethodsClass.KindRegisterDigitToString(text[4]);
                NrRejestracyjnyTextBox.Text = text[5].ToString();
            }
            if (NrRejestracyjnyTextBox.Text != "")
                kosztyPojazdu.Checked=true;
        }

        private void NoweKontoKsięgowe_Load(object sender, EventArgs e)
        {
            SqlConnection tmpConn = MethodsClass.SqlConnect();
            string squery = "SELECT ewidencjaVAT FROM DaneFirmy";
            SqlCommand myCommand = new SqlCommand(squery, tmpConn);
            try
            {
                tmpConn.Open();
                if (!(bool)myCommand.ExecuteScalar()) // return True if field ewidencjaVAT == False
                    comboBox2.Enabled = false;
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
        }

        private void OK_Click(object sender, EventArgs e)
        {
            if (czyNowy)
                kk.Dodaj(kontoKsNumberTextBox.Text, textBox2.Text, textBox3.Text, comboBox1.Text, comboBox2.Text, NrRejestracyjnyTextBox.Text);
            else
                kk.EdytujOK(kontoKsNumberTextBox.Text, textBox2.Text, textBox3.Text, comboBox1.Text, comboBox2.Text, NrRejestracyjnyTextBox.Text);
        }

        private void kosztyPojazdu_CheckedChanged(object sender, EventArgs e)
        {
            if (kosztyPojazdu.Checked)
                NrRejestracyjnyTextBox.Enabled = true;
            else
                NrRejestracyjnyTextBox.Enabled = false;
        }
    }
}