using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ProgramDB
{
    public partial class NowyDowodWewnetrzny : Form, InterfaceClass.ISendData 
    {
        private DowodyWewnetrzne dw;
        private bool czyNowy;
        public NowyDowodWewnetrzny(DowodyWewnetrzne w, bool nowy)
        {
            InitializeComponent();
            dw = w;
            czyNowy = nowy;
            this.iloscMoneyTextBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.customerTextBoxKeyUp);
            this.cenaMoneyTextBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.customerTextBoxKeyUp);
        }

        private void customerTextBoxKeyUp(object sender, KeyEventArgs e)
        {
            wartoscMoneyTextBox.Text = String.Format("{0:0.00}", Convert.ToDouble(iloscMoneyTextBox.Text) * Convert.ToDouble(cenaMoneyTextBox.Text));
        }

        public void Edytuj(params object[] text)
        {  // Retrieves data for editing 
            numericUpDown1.Value = Convert.ToDecimal(text[0]);
            dateTimePicker1.Value = DateTime.ParseExact(text[1].ToString(), "yyyy-MM-dd HH:mm:ss", null);
            richTextBox1.Text = text[2].ToString(); 
            textBox1.Text = text[3].ToString();
            iloscMoneyTextBox.Text = text[4].ToString();
            textBox3.Text = text[5].ToString();
            cenaMoneyTextBox.Text = MethodsClass.ConvertMoneyToString(text[6]);
            wartoscMoneyTextBox.Text = MethodsClass.ConvertMoneyToString(text[7]);
        }

        private void OK_Click(object sender, EventArgs e)
        {
            if ((textBox1.Text == "") || (textBox3.Text == ""))
            {
                MethodsClass.MesBoxShowInformation("Wypenij wszystkie wymagane pola!", "Uwaga");
                return;
            }
            if (czyNowy)
                dw.Dodaj(numericUpDown1.Value, dateTimePicker1.Value, richTextBox1.Text, textBox1.Text, iloscMoneyTextBox.Text, textBox3.Text, cenaMoneyTextBox.Text, wartoscMoneyTextBox.Text);
            else
                dw.EdytujOK(numericUpDown1.Value, dateTimePicker1.Value, richTextBox1.Text, textBox1.Text, iloscMoneyTextBox.Text, textBox3.Text, cenaMoneyTextBox.Text, wartoscMoneyTextBox.Text);
            Close();
        }
    }
}