using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ProgramDB
{
    public partial class NowyWprowadzanyDokument : Form, InterfaceClass.ISendData 
    {
        private WprowadzanieDokumentow wd;
        private EwidencjaDokumentowZaksiegowanych edz;
        private object thisobject = null;
        private byte czyNowy;
        private decimal razem;
        private int selectRowFromDatabase;
        private decimal ptuC;
        private decimal ptuD;
        public NowyWprowadzanyDokument(object obj, byte nowy, decimal sum, int selectRow)
        {
            // first value is object from which we call form; second value if equal: 0 - call NowyWprowadzanyDokument previously entered data, 
            // 1 - call empty NowyWprowadzanyDokument Form, 2 - call NowyWprowadzanyDokument from DowodyWewnetrzne form, 3 - call NowyWprowadzanyDokument from EwidencjaSprzeday form, 
            //4 - call NowyWprowadzanyDokument from EwidencjaWyposazenia form; third value set sum of value; four value set selected row

            InitializeComponent();

            thisobject = obj;
            if (obj is WprowadzanieDokumentow)
                wd = (WprowadzanieDokumentow)obj;
            else // if (obj is EwidencjaDokumentowZaksiegowanych)
                edz = (EwidencjaDokumentowZaksiegowanych)obj;

            czyNowy = nowy; // if it's new or edition or Internal evidence or Sales records or records of equipment
            if (czyNowy == 1)
            { // insert data of accounting 
                int[] date=MethodsClass.GetDateFromDataKsiegowania();
                dateTimePicker2.Value = new DateTime(date[0], date[1], date[2]);

                rodzajRozliczeniaComboBox.Text = "Nie podlega rozliczeniu";
            }
            razem = sum;
            selectRowFromDatabase = selectRow;
            foreach (Control vControl in this.panelNowyWprowDokum4.Controls)
                if (vControl is TextBox)
                {
                    MethodsClass.ownMaskedTextBoxEvent((TextBox)vControl);
                }
            ptuC = MethodsClass.ExeStoredProcedureRetDecimal("uspGetPTUC");
            ptuD = MethodsClass.ExeStoredProcedureRetDecimal("uspGetPTUD");
            ptuCLabel.Text = "Stawka " + ((ptuC - Math.Floor(ptuC)) == 0 ? Math.Round(ptuC) : ptuC).ToString() + "%";
            ptuDLabel.Text = "Stawka " + ((ptuD - Math.Floor(ptuD)) == 0 ? Math.Round(ptuD) : ptuD).ToString() + "%";
        }

        private void ObliczNetto()
        {
            textBox21.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox5.Text) + Convert.ToDouble(textBox8.Text) + Convert.ToDouble(textBox11.Text) + Convert.ToDouble(textBox14.Text) + Convert.ToDouble(textBox17.Text) + Convert.ToDouble(textBox18.Text) + Convert.ToDouble(textBox19.Text) + Convert.ToDouble(textBox20.Text));
        }

        private void ObliczVAT()
        {
            textBox22.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox6.Text) + Convert.ToDouble(textBox9.Text) + Convert.ToDouble(textBox12.Text) + Convert.ToDouble(textBox15.Text));
        }

        private void ObliczBrutto()
        {
            razemMoneyTextBox.Text = textBox23.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox21.Text) + Convert.ToDouble(textBox22.Text));
            moneyTextBox1.Text = razemMoneyTextBox.Text;
        }

        public void Edytuj(params object[] text)
        {  // Pobiera dane (z DataGridView) do edycji 
            nrDokumentuTextBox.Text = text[0].ToString();
            dateTimePicker1.Value = Convert.ToDateTime(text[1]);
            dateTimePicker2.Value = Convert.ToDateTime(text[2]);
            uwagiTextBox.Text = text[3].ToString();
            richTextBox1.Text = text[4].ToString();
            rodzajRozliczeniaComboBox.Text = text[5].ToString();
            formaplatnosciComboBox.Text = text[6].ToString();
            dateTimePicker3.Value = Convert.ToDateTime(text[7]);
            moneyTextBox1.Text = text[8].ToString();
            transakcjaComboBox.Text = text[9].ToString();
            dateTimePicker4.Value = Convert.ToDateTime(text[10]);
            numericUpDown1.Value = Convert.ToDecimal(text[11]);
            int i = 30; 
            foreach (Control vControl in this.panelNowyWprowDokum4.Controls)
                if (vControl is TextBox)
                {
                    ((TextBox)vControl).Text = MethodsClass.ConvertMoneyToString(text[i]);
                    i--;
                }
            razemMoneyTextBox.Text = MethodsClass.ConvertMoneyToString(text[30]);
        }

        private void myTextBoxKeyUp(object sender, KeyEventArgs e)
        {
            ObliczNetto();
            ObliczBrutto();
        }

        private void NowyWprowadzanyDokument_Load(object sender, EventArgs e)
        {
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
                MethodsClass.ExeReaderComboBox(kontoKsComboBox, "SELECT KontoKsiegowe, Nazwa FROM KontoKsiegoweTabela", '-');
            else
                MethodsClass.ExeReaderComboBox(kontoKsComboBox, "SELECT [Konto ksigowe], Nazwa FROM KontoKsiegoweRyczaltTabela", '-');
            MethodsClass.ExeReaderComboBox(comboBox2, "SELECT NazwaSkrocona FROM KontrahenciView");
            MethodsClass.ExeReaderComboBox(opisZdarzenGospComboBox, "SELECT OpisZdarzenGospodarczych FROM OpisZdarzenGospView");

            // add event KeyUp to the TextBox
            this.textBox17.KeyUp += new System.Windows.Forms.KeyEventHandler(this.myTextBoxKeyUp);
            this.textBox18.KeyUp += new System.Windows.Forms.KeyEventHandler(this.myTextBoxKeyUp);
            this.textBox19.KeyUp += new System.Windows.Forms.KeyEventHandler(this.myTextBoxKeyUp);
            this.textBox20.KeyUp += new System.Windows.Forms.KeyEventHandler(this.myTextBoxKeyUp);
            this.textBox21.KeyUp += new System.Windows.Forms.KeyEventHandler(this.myTextBoxKeyUp);

            if (czyNowy == 0)
            {   // we must insert here because in the Edytuj method we couldn't insert comboBox - it wasn't available (and we have only drop-down list) 
                if (thisobject is WprowadzanieDokumentow)
                {
                    kontoKsComboBox.Text = wd.ComboBoxKontoKsiegowe;
                    comboBox2.Text = wd.ComboBoxKontrahent;
                    opisZdarzenGospComboBox.Text = wd.ComboBoxOpisZdarzeniaGosp;
                    rejestrComboBox.Text = wd.ComboBoxRejestr;
                }
                else // if (thisobject is EwidencjaDokumentowZaksiegowanych)
                {
                    kontoKsComboBox.Text = edz.ComboBoxKontoKsiegowe;
                    comboBox2.Text = edz.ComboBoxKontrahent;
                    opisZdarzenGospComboBox.Text = edz.ComboBoxOpisZdarzeniaGosp;
                    rejestrComboBox.Text = edz.ComboBoxRejestr;
                }
            }
            else if (czyNowy == 2) // if I booked DowodyWewnetrzne table
            {
                nrDokumentuTextBox.Text = "Dowd wewntrzny Nr 1";
                rodzajRozliczeniaComboBox.Text = "Nie podlega rozliczeniu";
                textBox23.Text = razem.ToString();
                razemMoneyTextBox.Text = razem.ToString();
            }
            else if (czyNowy == 3) // if I booked EwidencjaSprzeday table
            {
                rodzajRozliczeniaComboBox.Text = "Nie podlega rozliczeniu";
                textBox23.Text = razem.ToString();
                razemMoneyTextBox.Text = textBox23.Text;
            }
            else if (czyNowy == 4) // if I booked EwidencjaWyposazenia table
            {
                nrDokumentuTextBox.Text = MethodsClass.NrDokumenWyposazenia;
                uwagiTextBox.Text = MethodsClass.NazwaWyposazenia;
                textBox23.Text = razem.ToString();
                razemMoneyTextBox.Text = textBox23.Text;
            }
        }

        private void OK_Click(object sender, EventArgs e)
        {
            MethodsClass.ifPressOKButtonInNowyWprowDokum = true;

            if ((kontoKsComboBox.SelectedIndex == -1) || (comboBox2.SelectedIndex == -1) || (opisZdarzenGospComboBox.SelectedIndex == -1) || (rejestrComboBox.SelectedIndex == -1) || (nrDokumentuTextBox.Text == ""))
            {
                MethodsClass.MesBoxShowWarning("Wprowad wszystkie wymagane wartoci", "Bd");
                return;
            }
            else if (Convert.ToDecimal(moneyTextBox1.Text) > Convert.ToDecimal(razemMoneyTextBox.Text))
            {
                MethodsClass.MesBoxShowWarning("Warto zapaty nie moe by wiksza ni kwota do zapaty.", "Niepowodzenie");
                return;
            }
            if (thisobject is WprowadzanieDokumentow)
            {
                if (czyNowy != 0)
                    wd.Dodaj(kontoKsComboBox.Text, comboBox2.Text, nrDokumentuTextBox.Text, dateTimePicker1.Value, dateTimePicker2.Value, opisZdarzenGospComboBox.Text, uwagiTextBox.Text, richTextBox1.Text, rodzajRozliczeniaComboBox.Text, formaplatnosciComboBox.Text, dateTimePicker3.Value, moneyTextBox1.Text, MethodsClass.KindRegisterStringToDigit(rejestrComboBox.Text), transakcjaComboBox.Text, dateTimePicker4.Value, numericUpDown1.Value, textBox5.Text, textBox6.Text, textBox7.Text, textBox8.Text, textBox9.Text, textBox10.Text, textBox11.Text, textBox12.Text, textBox13.Text, textBox14.Text, textBox15.Text, textBox16.Text, textBox17.Text, textBox18.Text, textBox19.Text, textBox20.Text, textBox21.Text, textBox22.Text, razemMoneyTextBox.Text, czyNowy, selectRowFromDatabase);
                else
                    wd.EdytujOK(kontoKsComboBox.Text, comboBox2.Text, nrDokumentuTextBox.Text, dateTimePicker1.Value, dateTimePicker2.Value, opisZdarzenGospComboBox.Text, uwagiTextBox.Text, richTextBox1.Text, rodzajRozliczeniaComboBox.Text, formaplatnosciComboBox.Text, dateTimePicker3.Value, moneyTextBox1.Text, MethodsClass.KindRegisterStringToDigit(rejestrComboBox.Text), transakcjaComboBox.Text, dateTimePicker4.Value, numericUpDown1.Value, textBox5.Text, textBox6.Text, textBox7.Text, textBox8.Text, textBox9.Text, textBox10.Text, textBox11.Text, textBox12.Text, textBox13.Text, textBox14.Text, textBox15.Text, textBox16.Text, textBox17.Text, textBox18.Text, textBox19.Text, textBox20.Text, textBox21.Text, textBox22.Text, razemMoneyTextBox.Text);
            }
            else // if (thisobject is EwidencjaDokumentowZaksiegowanych)
            {
                edz.EdytujOK(kontoKsComboBox.Text, comboBox2.Text, nrDokumentuTextBox.Text, dateTimePicker1.Value, dateTimePicker2.Value, opisZdarzenGospComboBox.Text, uwagiTextBox.Text, richTextBox1.Text, rodzajRozliczeniaComboBox.Text, formaplatnosciComboBox.Text, dateTimePicker3.Value, moneyTextBox1.Text, MethodsClass.KindRegisterStringToDigit(rejestrComboBox.Text), transakcjaComboBox.Text, dateTimePicker4.Value, numericUpDown1.Value, textBox5.Text, textBox6.Text, textBox7.Text, textBox8.Text, textBox9.Text, textBox10.Text, textBox11.Text, textBox12.Text, textBox13.Text, textBox14.Text, textBox15.Text, textBox16.Text, textBox17.Text, textBox18.Text, textBox19.Text, textBox20.Text, textBox21.Text, textBox22.Text, razemMoneyTextBox.Text);
            }
            Close();
        }

        private void textBox5_KeyUp(object sender, KeyEventArgs e)
        {
            textBox6.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox5.Text) * 0.22);
            textBox7.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox6.Text) + Convert.ToDouble(textBox5.Text));
            ObliczNetto();
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox6_KeyUp(object sender, EventArgs e)
        {
            textBox7.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox6.Text) + Convert.ToDouble(textBox5.Text));
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox8_KeyUp(object sender, EventArgs e)
        {
            textBox9.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox8.Text) * 0.07);
            textBox10.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox9.Text) + Convert.ToDouble(textBox8.Text));
            ObliczNetto();
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox9_KeyUp(object sender, EventArgs e)
        {
            textBox10.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox9.Text) + Convert.ToDouble(textBox8.Text));
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox11_KeyUp(object sender, EventArgs e)
        {
            textBox12.Text = String.Format("{0:0.00}", Convert.ToDecimal(textBox11.Text) * ptuC);
            textBox13.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox12.Text) + Convert.ToDouble(textBox11.Text));
            ObliczNetto();
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox12_KeyUp(object sender, EventArgs e)
        {
            textBox13.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox12.Text) + Convert.ToDouble(textBox11.Text));
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox14_KeyUp(object sender, EventArgs e)
        {
            textBox15.Text = String.Format("{0:0.00}", Convert.ToDecimal(textBox14.Text) * ptuD);
            textBox16.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox15.Text) + Convert.ToDouble(textBox14.Text));
            ObliczNetto();
            ObliczVAT();
            ObliczBrutto();
        }

        private void textBox15_KeyUp(object sender, EventArgs e)
        {
            textBox16.Text = String.Format("{0:0.00}", Convert.ToDouble(textBox15.Text) + Convert.ToDouble(textBox14.Text));
            ObliczVAT();
            ObliczBrutto();
        }

        private void kontoKsComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            rejestrComboBox.Text = MethodsClass.KindRegisterDigitToString(MethodsClass.ExeStoredProcedureRetInt("uspGetRodzajRejestru", new string[] { "KontoKsiegowe", "Nazwa" }, MethodsClass.GetTwoCellInFromOneWithSign(kontoKsComboBox.Text, '-')));
        }
    }
}