using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient; 

namespace ProgramDB
{
    public partial class NowyWyjazd : Form, InterfaceClass.ISendData
    {
        private EwidencjaPrzebieguPojazdow epp;
        private bool czyNowy;
        private int wybranyWiersz;
        public NowyWyjazd(EwidencjaPrzebieguPojazdow ep, bool nowy)
        {
            InitializeComponent();
            epp = ep;
            czyNowy = nowy;
        }

        private void NowyWyjazd_Load(object sender, EventArgs e)
        {
            string pojazdNrReje="";
            foreach (DataRow comboRow in epp.GetTablePojazdyPrywatneTabela().Rows)
            {
                if ((!czyNowy) && (epp.ComboBoxPojazd.Equals(comboRow[2].ToString())))
                    pojazdNrReje = comboRow[1].ToString() + " - " + comboRow[2].ToString(); //  We join Pojazd and NrRejestracyjny. We must that positon in the comboBox because without this position we couldn't insert this value to comboBox (we have only this position in the drop-down list) 
                comboBox1.Items.Add(comboRow[1] + " - " + comboRow[2]); 
            }
            foreach (DataRow comboRow in epp.GetTableCeleWyjazdPojPrywTabela().Rows)
                comboBox2.Items.Add(comboRow[1]); // insert value in the drop-down list

            foreach (DataRow comboRow in epp.GetTableOpisTrasWyjazdTabela().Rows)
                comboBox3.Items.Add(comboRow[1]);

            if (!czyNowy)
            {   // we must insert here because in the Edytuj method we couldn't insert comboBox - it wasn't available (and we have only drop-down list) 
                comboBox1.Text = pojazdNrReje;
                comboBox2.Text = epp.ComboBoxCelWyjazdu;
                comboBox3.Text = epp.ComboBoxOpisTrasy;
            }
        }

        public void Edytuj(params object[] text)
        {  // Pobiera dane do edycji 
            dateTimePicker1.Value = DateTime.ParseExact(text[0].ToString(), "yyyy-MM-dd HH:mm:ss", null);
            //comboBox1.Text = text[1].ToString();
            //comboBox2.Text = text[2].ToString();
            //comboBox3.Text = text[3].ToString();
            odlegloscTextBox.Text = text[1].ToString();
            wartoscTextBox.Text = text[2].ToString();
            uwagiTextBox.Text = text[3].ToString();
            wybranyWiersz = Convert.ToInt32(text[4]);
        }

        private void OK_Click(object sender, EventArgs e)
        {
            if (czyNowy)
            {
                if (odlegloscTextBox.Text != "")
                    epp.Dodaj(dateTimePicker1.Value, comboBox1.Text, comboBox2.Text, comboBox3.Text, wartoscTextBox.Text, uwagiTextBox.Text);
            }
            else
                epp.EdytujOK(dateTimePicker1.Value, comboBox1.Text, comboBox2.Text, comboBox3.Text, wartoscTextBox.Text, uwagiTextBox.Text, wybranyWiersz);
        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            DataColumn[] keys = new DataColumn[1];
            keys[0] = epp.GetDataSet.Tables["OpisTrasWyjazdTabela"].Columns["OpisTrasWyjazd"];
            epp.GetDataSet.Tables["OpisTrasWyjazdTabela"].PrimaryKey = keys;
            DataRow findMyRow = epp.GetDataSet.Tables["OpisTrasWyjazdTabela"].Rows.Find(comboBox3.Text);
            odlegloscTextBox.Text = findMyRow[2].ToString();

            SqlConnection tmpConn = tmpConn = MethodsClass.SqlConnect();
            try
            {
                SqlCommand myCommand = new SqlCommand("SELECT StawkaZaPrzebiegPojazdu FROM StawkaZaPrzebiegPojazduTabela", tmpConn);
                tmpConn.Open();
                wartoscTextBox.Text = Convert.ToString(Convert.ToDouble(odlegloscTextBox.Text) * Convert.ToDouble(myCommand.ExecuteScalar()));
            }
            catch (System.InvalidOperationException ex)
            {
                MethodsClass.InvalidOperationExceptionFunction(ex);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                MethodsClass.SqlExceptionFunction(ex);
            }
            catch (System.Exception ex)
            {
                MethodsClass.GenericExceptionFunction(ex);
            }
            finally
            {
                MethodsClass.FinallyExceptionFunction(tmpConn);
            }
        }
    }      
}