using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace UserControl
{
    class NumberTextBox : TextBox
    { // create customer TextBox which accept only numeric value 
        public NumberTextBox()
        {
            InitializeComponent();
        }

        private void InitializeComponent()
        {
            this.Text = "0";
            this.BackColor = Color.White;
            this.TextAlign = HorizontalAlignment.Right;
            this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(ownNumberMaskedTextBox);
        }

        private void ownNumberMaskedTextBox(object sender, KeyPressEventArgs e)
        { // it accept only digits and Back key and set format digits
            TextBox textBox = (TextBox)sender;
            int selStart = textBox.SelectionStart;
            string textValue = textBox.Text; // string textValue = textBox.Text;
            if (!((char.IsNumber(e.KeyChar) || (Keys)e.KeyChar == Keys.Back) && (textValue.Length < 15)))
            { // if text value length > 15 and insert value not equal digit or back key
                if (((Keys)e.KeyChar == Keys.Back) && (textValue.Length >= 15))
                { // this loop is false when the length of the textBox >= 15 digits and we press Backspace key 
                    // pass
                }
                else
                {
                    e.Handled = true;
                }
            }
        }
    }
}
