using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Printing;
using System.IO;
using System.Xml;

namespace ProgramDB
{
    public partial class PKPiR : Form
    {
        private DataGridViewPrinter MyDataGridViewPrinter;
        public PKPiR()
        {
            InitializeComponent();
        }

        private void PKPiR_Load(object sender, EventArgs e)
        {
            this.sqlDataAdapter1.Fill(this.dataSet1, "WprowadzanieDokumentowTabela");
            ownDataGridView1.DataSource = dataSet1;
            ownDataGridView1.DataMember = "WprowadzanieDokumentowTabela";

            ownDataGridView1.Columns["WprowadzanieDokumentowID"].Visible = false;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Tahoma", 9, FontStyle.Bold, GraphicsUnit.Point);
            ownDataGridView1.ColumnHeadersDefaultCellStyle.BackColor = SystemColors.ControlDark;
            ownDataGridView1.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single;
            ownDataGridView1.DefaultCellStyle.Font = new Font("Tahoma", 8, FontStyle.Regular, GraphicsUnit.Point);
            ownDataGridView1.AlternatingRowsDefaultCellStyle.BackColor = SystemColors.ControlLight;
            ownDataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.Single;
            ownDataGridView1.GridColor = SystemColors.ControlDarkDark;
            ownDataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);
            ownDataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            ownDataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void Drukuj_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
                printDocument1.Print();
        }

        private void Sumy_Click(object sender, EventArgs e)
        {
            SumyPKPIR sumy = new SumyPKPIR();
            if (sumy.ShowDialog()==DialogResult.OK)
                sumy.Close();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            bool more = MyDataGridViewPrinter.DrawDataGridView(e.Graphics);
            if (more == true)
                e.HasMorePages = true;
        }

        private void podgladWydruku_Click(object sender, EventArgs e)
        {
            if (SetupThePrinting())
            {
                PrintPreviewDialog MyPrintPreviewDialog = new PrintPreviewDialog();
                MyPrintPreviewDialog.Document = printDocument1;
                MyPrintPreviewDialog.ShowDialog();
            }
        }

        private bool SetupThePrinting()
        {
            PrintDialog MyPrintDialog = new PrintDialog();
            MyPrintDialog.AllowCurrentPage = false;
            MyPrintDialog.AllowPrintToFile = false;
            MyPrintDialog.AllowSelection = false;
            MyPrintDialog.AllowSomePages = false;
            MyPrintDialog.PrintToFile = false;
            MyPrintDialog.ShowHelp = false;
            MyPrintDialog.ShowNetwork = false;

            if (MyPrintDialog.ShowDialog() != DialogResult.OK)
                return false;

            printDocument1.DocumentName = "PrintDocument";
            printDocument1.PrinterSettings = MyPrintDialog.PrinterSettings;
            printDocument1.DefaultPageSettings = MyPrintDialog.PrinterSettings.DefaultPageSettings;
            printDocument1.DefaultPageSettings.Margins = new Margins(40, 40, 40, 40);

            if (MessageBox.Show("Chcesz eby tytu tabeli by wyrodkowany?", "Pytanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, printDocument1, true, true, "Podatkowa Ksiga Przychodw i Rozchodw", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);
            else
                MyDataGridViewPrinter = new DataGridViewPrinter(ownDataGridView1, printDocument1, false, true, "Podatkowa Ksiga Przychodw i Rozchodw", new Font("Tahoma", 18, FontStyle.Bold, GraphicsUnit.Point), Color.Black, true);

            return true;
        }

        private void eksport_Click(object sender, EventArgs e)
        {
            ExportToExcel(ownDataGridView1);           
        } 
       
        public void ExportToExcel(DataGridView grid)
        {
            Microsoft.Office.Interop.Excel.ApplicationClass excelSheet = new Microsoft.Office.Interop.Excel.ApplicationClass();
            excelSheet.Application.Workbooks.Add(true);
            int columnIndex = 0;
            //Columns Heading of Datagridview     
            foreach (DataGridViewColumn column in grid.Columns)
            {
                columnIndex++;
                if (!column.HeaderText.Equals("WprowadzanieDokumentowID")) // write column which I don't want to see in the excel 
                    excelSheet.Cells[1, columnIndex] = column.HeaderText;
                else
                    columnIndex--;
            }
            int rowIndex = 0;
            //get all rows by column wise 
            foreach (DataGridViewRow row in grid.Rows)
            {
                rowIndex++;
                columnIndex = 0;
                foreach (DataGridViewColumn column in grid.Columns)
                {
                    columnIndex++;
                    if (!column.HeaderText.Equals("WprowadzanieDokumentowID")) // write column which I don't want to see in the excel 
                        excelSheet.Cells[rowIndex + 1, columnIndex] = row.Cells[column.Name].FormattedValue;
                    else
                        columnIndex--;
                }
            }
            excelSheet.Visible = true;
            Microsoft.Office.Interop.Excel.Worksheet workSheet = (Microsoft.Office.Interop.Excel.Worksheet)excelSheet.ActiveSheet;
        }
        
        private void eksportXML_Click(object sender, EventArgs e)
        {
            if (saveExportToXMLDialog.ShowDialog() == DialogResult.OK)
                dataSet1.WriteXml(saveExportToXMLDialog.FileName);
        }

        private void importXML_Click(object sender, EventArgs e)
        {            
            if (openImportToXML.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    dataSet1.Clear();
                    dataSet1.ReadXml(openImportToXML.FileName);
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MessageBox.Show(ex.Message.ToString());
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
            }
        }
    }
}