using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ProgramDB
{
    public partial class StawkiVAT : Form, InterfaceClass.ITakeData 
    {
        private string[] sqlData ={ "Data obowizywania", "PTU A", "PTU B", "PTU C", "PTU D", "PTU E", "PTU F", "PTU G" };
        public StawkiVAT()
        {
            InitializeComponent();
        }

        private int WybranyWiersz
        {
            get
            {
                return dataGridView1.SelectedRows[0].Index; // return selected row
            }
        }

        public void Dodaj(params object[] text)
        {  // add one item
            DataRow myDataRow = dataSet1.Tables["StawkiVATTabela"].NewRow();
            int i = 0;
            myDataRow[sqlData[i]] = text[i];
            i++;
            for (; i < sqlData.Length-2; i++)
            {
                myDataRow[sqlData[i]] = (text[i] == null) ? 0 : text[i];
            }
            myDataRow[sqlData[i]] = text[i];
            i++;
            myDataRow[sqlData[i]] = text[i];
            dataSet1.Tables["StawkiVATTabela"].Rows.Add(myDataRow);
        }

        public void EdytujOK(params object[] text)
        { // zapisujemy zmiany w edytowanych Stawkach VAT 
            int i = 0;
            dataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = text[i];
            i++;
            for (; i < sqlData.Length - 2; i++)
            {
                dataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = (text[i] == null) ? 0 : text[i];
            }
            dataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = text[i];
            i++;
            dataGridView1.Rows[WybranyWiersz].Cells[sqlData[i]].Value = text[i];
        }

        private void StawkiVAT_Load(object sender, EventArgs e)
        {                         
            if (!MethodsClass.DbTableExists("StawkiVATTabela", MethodsClass.sConnectionString))
            {
                string sCreateTable = "CREATE TABLE StawkiVATTabela (StawkiVATID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY," +
"Data DATETIME NULL, PTUA DECIMAL(5, 2) NULL, PTUB DECIMAL(5, 2) NULL, PTUC DECIMAL(5, 2) NULL, PTUD DECIMAL(5, 2) NULL, PTUE DECIMAL(5, 2) NULL, PTUF NVARCHAR(50) NULL, PTUG NVARCHAR(50) NULL" + ")";
                MethodsClass.ExeNonQuery(sCreateTable);
            }

            this.sqlDataAdapter1.Fill(this.dataSet1, "StawkiVATTabela");
            dataGridView1.DataSource = dataSet1.Tables["StawkiVATTabela"];
            dataGridView1.Columns[0].Visible = false;
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[0]);
            for (int i = 1; i < sqlData.Length-2; i++)
                MethodsClass.SetMoneyFormatDataGridView(dataGridView1, sqlData[i]);
            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NoweStawkiVAT noweStawkiVat = new NoweStawkiVAT(this, true);  // set false when we clicked Nowy button
            if (noweStawkiVat.ShowDialog()==DialogResult.OK)
                noweStawkiVat.Close();
        }

        private void Usu_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(dataGridView1))
                {
                    if (dataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        dataGridView1.Rows.Remove(dataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }                
            }
        }

        private void Wyjcie_Click(object sender, EventArgs e)
        {
            if (this.dataSet1 != null && this.dataSet1.HasChanges())
                sqlDataAdapter1.Update(dataSet1);
        }

        private void dataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (dataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    NoweStawkiVAT edytujStawkiVat = new NoweStawkiVAT(this, false); // set false when we clicked Edytuj button wprowNowegoWypos.Text = "Korekta wprowadzonego wyposaenia";
                    edytujStawkiVat.Edytuj(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[0]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[1]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[2]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[3]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[4]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value, dataGridView1.Rows[WybranyWiersz].Cells[sqlData[7]].Value);
                    if (edytujStawkiVat.ShowDialog() == DialogResult.OK)
                        edytujStawkiVat.Close();
                }
            }
            else
            {
                MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
            }
        }
    }
}