using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ProgramDB
{
    public partial class UstawieniaZabezpieczeniaProgramu : Form
    {
        public UstawieniaZabezpieczeniaProgramu()
        {
            InitializeComponent();
        }

        private void UstawieniaZabezpieczeniaProgramu_Load(object sender, EventArgs e)
        {
            if (((MethodsClass.CheckDatabaseExists(MethodsClass.Server, MethodsClass.Database)) && (!MethodsClass.DbTableExists("ZabezpieczenieProgramu", MethodsClass.sConnectionString))))  
            { // if table does not exist
                SqlConnection tmpConn = MethodsClass.SqlConnect();
                string sCreateTable = "CREATE TABLE ZabezpieczenieProgramu (ZabezProgID INTEGER PRIMARY KEY IDENTITY," +
"Haslo NVARCHAR(50) NOT NULL" + ")";
                string squery = "INSERT INTO ZabezpieczenieProgramu (Haslo)"
+ "VALUES( @Passwd )";
                SqlCommand myCommand; 
                SqlTransaction transaction = null; 
                try
                {
                    tmpConn.Open();
                    transaction = tmpConn.BeginTransaction("myTransaction");
                    myCommand = tmpConn.CreateCommand();
                    myCommand.Transaction = transaction;
                    myCommand.CommandText = sCreateTable;
                    myCommand.ExecuteNonQuery();
                    myCommand.CommandText = squery;
                    myCommand.Parameters.AddWithValue("@Passwd", "");
                    myCommand.ExecuteNonQuery();
                    transaction.Commit();
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MethodsClass.SqlExceptionFunction(ex);
                    transaction.Rollback("myTransaction");
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
                finally
                {
                    transaction.Dispose();
                    MethodsClass.FinallyExceptionFunction(tmpConn);
                }
                Close();
            }
        }

        private void OK_Click(object sender, EventArgs e)
        {
            if (MethodsClass.DbTableExists("ZabezpieczenieProgramu", MethodsClass.sConnectionString))  // if table exist
            {
                SqlConnection tmpConn = MethodsClass.SqlConnect(); 
                try
                {
                    string oldPassword = MethodsClass.OldPassword(tmpConn);
                    if (oldPassword == stareHaslo.Text)  
                    {
                        if (((noweHaslo.Text).Equals(powtorzHaslo.Text)))
                        {
                            if ((noweHaslo.Text == "") && (powtorzHaslo.Text == ""))
                            {
                                MessageBox.Show("Haso dostpu do programu zostao wyczone.", "Powiadomienie", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            }
                            else
                            {
                                MessageBox.Show("Haso dostpu do programu zostao zmienione.", "Powiadomienie", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            }
                            string sUpdate = "UPDATE ZabezpieczenieProgramu SET Haslo = @Haslo ";
                            tmpConn.Open();
                            SqlCommand myCommand = new SqlCommand(sUpdate, tmpConn);
                            myCommand.Parameters.AddWithValue("@Haslo", noweHaslo.Text);
                            myCommand.ExecuteNonQuery();
                            Close();
                        }
                        else
                        {
                            MessageBox.Show("Nowe haso nie zgadza si z powtrzonym hasem. Upewnij si, e oba hasa wpisujesz tak samo.", "Niepowodzenie", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        }
                    }
                    else
                    {
                        MessageBox.Show("Zostao le podane stare haso. Upewnij si,  wpisujesz je prawidowo.", "Niepowodzenie", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                }
                catch (System.Exception ex)
                {
                    MethodsClass.MesBoxShowError(ex.ToString(), "Bd przy aktualizacji danych");
                }
                finally
                {
                    tmpConn.Close();
                }
            }
        }
    }
}