using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;
using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;

namespace ProgramDB
{
    public partial class WprowadzanieDokumentow : Form, InterfaceClass.ITakeData
    {
        #region Fields

        private string comboBoxKontoKsiegowe;
        private string comboBoxKontrahent;
        private string comboBoxOpisZdarzeniaGosp;
        private string comboBoxRejestr;
        private object thisobject = null; 
        private static string[] sqlData={ "WprowadzanieDokumentowID", "KontoKsiegoweID", "KontoKsiegowe", "KontrahenciID", "Kontrahent", "NrDokumentu", "DataDokumentu", "DzienWpisu", "OpisZdarzenID",
"Opis zdarzenia gospodarczego", "Uwagi", "Notatki", "RodzajRozliczenia", "FormaPlatnosci", "TerminZaplaty", "Zaplacono", "Rejestr", "Transakcja", "DataKsiegowania", 
"MiesiacZaliczenia", "Stawka22Netto", "Stawka22VAT", "Stawka22Brutto", "Stawka7Netto", "Stawka7VAT", "Stawka7Brutto", "Stawka6Netto", "Stawka6VAT", "Stawka6Brutto", 
"Stawka3Netto", "Stawka3VAT", "Stawka3Brutto", "Stawka0", "Zwolnione", "BezRozliczen", "NiePodlega", "RazemNetto", "RazemVAT", "RazemBrutto", "DowodyWewnetrzneID", "EwidencjaSprzedazyID", "EwidencjaWyposazeniaID" };
        private static string[] dataOnForm ={"KontoKsiegowe", "Kontrahent", "NrDokumentu", "DataDokumentu", "DzienWpisu", "Opis zdarzenia gospodarczego",
"Uwagi", "Notatki", "RodzajRozliczenia", "FormaPlatnosci", "TerminZaplaty", "Zaplacono", "Rejestr", "Transakcja", "DataKsiegowania", "MiesiacZaliczenia", 
"Stawka22Netto", "Stawka22VAT", "Stawka22Brutto", "Stawka7Netto", "Stawka7VAT", "Stawka7Brutto", "Stawka6Netto", "Stawka6VAT", "Stawka6Brutto", "Stawka3Netto",
"Stawka3VAT", "Stawka3Brutto", "Stawka0", "Zwolnione", "BezRozliczen", "NiePodlega", "RazemNetto", "RazemVAT", "RazemBrutto" };
        private static string[] stawki ={"Stawka22Netto", "Stawka22VAT", "Stawka22Brutto", "Stawka7Netto", "Stawka7VAT", "Stawka7Brutto", "Stawka6Netto", "Stawka6VAT", "Stawka6Brutto", "Stawka3Netto",
"Stawka3VAT", "Stawka3Brutto", "Stawka0", "Zwolnione", "BezRozliczen", "NiePodlega", "RazemNetto", "RazemVAT", "RazemBrutto" };
        private static string[] stawkiRyczalt ={"Netto 22%", "VAT 22%", "Brutto 22%", "Netto 7%", "VAT 7%", "Brutto 7%", "StawkaPTUCNetto", "StawkaPTUCVAT", "StawkaPTUCBrutto", "StawkaPTUDNetto",
"StawkaPTUDVAT", "StawkaPTUDBrutto", "Netto 0%", "Netto zwolnione", "Bez odlicze", "Nie podlega" };
        private static string[] dataOnFormRyczalt ={"Konto ksigowe", "Kontrahent", "Nr dokumentu", "Data wystawienia", "Dzie wpisu", "Opis zdarzenia gospodarczego",
"Uwagi", "Notatki", "Rodzaj rozliczenia", "Forma patnoci", "Termin zapaty", "Zapacono", "Rodzaj rejestru", "Transakcja", "Data otrzymania obow. podat.", "Miesic zaliczenia do ewidencji VAT", 
"Netto 22%", "VAT 22%", "Brutto 22%", "Netto 7%", "VAT 7%", "Brutto 7%", "StawkaPTUCNetto", "StawkaPTUCVAT", "StawkaPTUCBrutto", "StawkaPTUDNetto",
"StawkaPTUDVAT", "StawkaPTUDBrutto", "Netto 0%", "Netto zwolnione", "Bez odlicze", "Nie podlega", "Razem netto", "Razem VAT", "Razem brutto" };

        #endregion

        #region Constructors
        public WprowadzanieDokumentow()
        {
            InitializeComponent();
            foreach (Control control in this.groupBox1.Controls)
            {
                if (control is TextBox)
                    ((TextBox)control).Enabled = false;
            }
            foreach (Control control in this.groupBox2.Controls)
            {
                if (control is TextBox)
                    ((TextBox)control).Enabled = false;
            }
            thisobject = this;
        }
        #endregion

        #region Properties
        private int WybranyWiersz
        {
            get
            {
                return dataGridView1.SelectedRows[0].Index; // return selected row
            }
        }


        public static string[] SqlData
        {
            get
            {
                return sqlData;
            }
        }

        public static string[] DataOnForm
        {
            get
            {
                return dataOnForm;
            }
        }

        public static string[] Stawki
        {
            get
            {
                return stawki;
            }
        }

        public static string[] StawkiRyczalt
        {
            get
            {
                return stawkiRyczalt;
            }
        }

        public static string[] DataOnFormRyczalt
        {
            get
            {
                return dataOnFormRyczalt;
            }
        }

        public string ComboBoxKontoKsiegowe
        {
            get
            {
                return comboBoxKontoKsiegowe;
            }
        }

        public string ComboBoxKontrahent
        {
            get
            {
                return comboBoxKontrahent;
            }
        }

        public string ComboBoxOpisZdarzeniaGosp
        {
            get
            {
                return comboBoxOpisZdarzeniaGosp;
            }
        }

        public string ComboBoxRejestr
        {
            get
            {
                return comboBoxRejestr;
            }
        }
        #endregion

        #region Methods
        public void EdytujOK(params object[] text)
        { // We save changed in the edited document             
            int ww = WybranyWiersz;
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                object[] cellInKontoKsiegowe = MethodsClass.GetTwoCellInFromOneWithSign(text[0], '-');
                dataGridView1.Rows[ww].Cells["KontoKsiegoweID"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetKontoKsiegoweID", new string[] { "KontoKsiegowe", "Nazwa" }, cellInKontoKsiegowe);
                dataGridView1.Rows[ww].Cells["KontoKsiegowe"].Value = cellInKontoKsiegowe[0];
                dataGridView1.Rows[ww].Cells["Kolumna ksiki"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetKolumnaKsiazki", new string[] { "KontoKsiegowe", "Nazwa" }, cellInKontoKsiegowe);
                dataGridView1.Rows[ww].Cells["KontrahenciID"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetKontrahenciID", "NazwaSkrocona", text[1]);
                dataGridView1.Rows[ww].Cells["Kontrahent"].Value = text[1];

                for (int i = 2; i < dataOnForm.Length; i++)
                {
                    if (i != 5)
                    {
                        dataGridView1.Rows[ww].Cells[dataOnForm[i]].Value = text[i];
                    }
                    else // if (i == 5)
                    {
                        dataGridView1.Rows[ww].Cells["OpisZdarzenID"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetOpisZdarzenID", "OpisZdarzenGospodarczych", text[i]);
                        dataGridView1.Rows[ww].Cells["Opis zdarzenia gospodarczego"].Value = text[i];
                    }
                }
            }
            else
            {
                object[] cellInKontoKsiegowe = MethodsClass.GetTwoCellInFromOneWithSign(text[0], '-');
                dataGridView1.Rows[ww].Cells["KontoKsiegoweID"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetKontoKsiegoweRyczaltID", new string[] { "Konto_ksigowe", "Nazwa" }, cellInKontoKsiegowe);
                dataGridView1.Rows[ww].Cells["Konto ksigowe"].Value = cellInKontoKsiegowe[0];
                dataGridView1.Rows[ww].Cells["Stawka ryczatu"].Value = MethodsClass.ExeStoredProcedureRetString("uspGetStawkaRyczaltu", new string[] { "Konto_ksigowe", "Nazwa" }, cellInKontoKsiegowe);
                dataGridView1.Rows[ww].Cells["KontrahenciID"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetKontrahenciID", "NazwaSkrocona", text[1]);
                dataGridView1.Rows[ww].Cells["Kontrahent"].Value = text[1];

                for (int i = 2; i < dataOnFormRyczalt.Length; i++)
                {
                    if (i != 5)
                    {
                        dataGridView1.Rows[ww].Cells[dataOnFormRyczalt[i]].Value = text[i];
                    }
                    else // if (i == 5)
                    {
                        dataGridView1.Rows[ww].Cells["OpisZdarzenID"].Value = MethodsClass.ExeStoredProcedureRetInt("uspGetOpisZdarzenID", "OpisZdarzenGospodarczych", text[i]);
                        dataGridView1.Rows[ww].Cells["Opis zdarzenia gospodarczego"].Value = text[i];
                    }
                }
            }
        }

        public void Dodaj(params object[] text)
        {  // Add one document 
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                if (Convert.ToByte(text[dataOnForm.Length]) > 1)
                {
                    this.sqlDataAdapter1.Fill(this.dataSet1, "WprowadzanieDokumentowTabela");
                    dataGridView1.DataSource = dataSet1;
                    dataGridView1.DataMember = "WprowadzanieDokumentowTabela";
                }

                DataRow myDataRow = dataSet1.Tables["WprowadzanieDokumentowTabela"].NewRow();
                int i = 0;
                for (; i < dataOnForm.Length; i++)
                {
                    if ((i != 0) && (i != 1) && (i != 5))
                    {
                        myDataRow[dataOnForm[i]] = text[i];
                    }
                    else if (i == 0)
                    {
                        object[] cellInKontoKsiegowe = MethodsClass.GetTwoCellInFromOneWithSign(text[i], '-');
                        myDataRow["KontoKsiegoweID"] = MethodsClass.ExeStoredProcedureRetInt("uspGetKontoKsiegoweID", new string[] { "KontoKsiegowe", "Nazwa" }, cellInKontoKsiegowe);
                        myDataRow["KontoKsiegowe"] = cellInKontoKsiegowe[0];
                        myDataRow["Kolumna ksiki"] = MethodsClass.ExeStoredProcedureRetInt("uspGetKolumnaKsiazki", new string[] { "KontoKsiegowe", "Nazwa" }, cellInKontoKsiegowe);
                    }
                    else if (i == 1)
                    {
                        myDataRow["KontrahenciID"] = MethodsClass.ExeStoredProcedureRetInt("uspGetKontrahenciID", "NazwaSkrocona", text[i]);
                        myDataRow["Kontrahent"] = text[i];
                    }
                    else if (i == 5)
                    {
                        myDataRow["OpisZdarzenID"] = MethodsClass.ExeStoredProcedureRetInt("uspGetOpisZdarzenID", "OpisZdarzenGospodarczych", text[i]);
                        myDataRow["Opis zdarzenia gospodarczego"] = text[i];
                    }
                }

                if (Convert.ToInt32(text[i]) == 2) // Internal evidence 
                    myDataRow["DowodyWewnetrzneID"] = text[i + 1];
                else if (Convert.ToInt32(text[i]) == 3) // Sales records
                    myDataRow["EwidencjaSprzedazyID"] = text[i + 1];
                else if (Convert.ToInt32(text[i]) == 4) // records of equipment
                    myDataRow["EwidencjaWyposazeniaID"] = text[i + 1];

                dataSet1.Tables["WprowadzanieDokumentowTabela"].Rows.Add(myDataRow);
                if (Convert.ToByte(text[i++]) > 1)
                    sqlDataAdapter1.Update(dataSet1, "WprowadzanieDokumentowTabela");
            }
            else
            {
                if (Convert.ToByte(text[dataOnFormRyczalt.Length]) > 1)
                {
                    this.sqlDataAdapter2.Fill(this.dataSet1, "WprowadzanieDokumentowRyczaltTabela");
                    dataGridView1.DataSource = dataSet1;
                    dataGridView1.DataMember = "WprowadzanieDokumentowRyczaltTabela";
                }
                DataRow myDataRow = dataSet1.Tables["WprowadzanieDokumentowRyczaltTabela"].NewRow();
                int i = 0;
                for (; i < dataOnFormRyczalt.Length; i++)
                {
                    if ((i != 0) && (i != 1) && (i != 5))
                    {
                        myDataRow[dataOnFormRyczalt[i]] = text[i];
                    }
                    else if (i == 0)
                    {
                        object[] cellInKontoKsiegowe = MethodsClass.GetTwoCellInFromOneWithSign(text[i], '-');
                        myDataRow["KontoKsiegoweID"] = MethodsClass.ExeStoredProcedureRetInt("uspGetKontoKsiegoweRyczaltID", new string[] { "Konto_ksigowe", "Nazwa" }, cellInKontoKsiegowe);
                        myDataRow["Konto ksigowe"] = cellInKontoKsiegowe[0];
                        myDataRow["Stawka ryczatu"] = MethodsClass.ExeStoredProcedureRetString("uspGetStawkaRyczaltu", new string[] { "Konto_ksigowe", "Nazwa" }, cellInKontoKsiegowe);
                    }
                    else if (i == 1)
                    {
                        myDataRow["KontrahenciID"] = MethodsClass.ExeStoredProcedureRetInt("uspGetKontrahenciID", "NazwaSkrocona", text[i]);
                        myDataRow["Kontrahent"] = text[i];
                    }
                    else if (i == 5)
                    {
                        myDataRow["OpisZdarzenID"] = MethodsClass.ExeStoredProcedureRetInt("uspGetOpisZdarzenID", "OpisZdarzenGospodarczych", text[i]);
                        myDataRow["Opis zdarzenia gospodarczego"] = text[i];
                    }
                }
                if (Convert.ToInt32(text[i]) == 2) // Internal evidence 
                    myDataRow["DowodyWewnetrzneID"] = text[i + 1];
                else if (Convert.ToInt32(text[i]) == 3) // Sales records
                    myDataRow["EwidencjaSprzedazyID"] = text[i + 1];
                else if (Convert.ToInt32(text[i]) == 4) // records of equipment
                    myDataRow["EwidencjaWyposazeniaID"] = text[i + 1];

                dataSet1.Tables["WprowadzanieDokumentowRyczaltTabela"].Rows.Add(myDataRow);
                if (Convert.ToByte(text[i++]) > 1)
                    sqlDataAdapter2.Update(dataSet1, "WprowadzanieDokumentowRyczaltTabela");
            }
        }

        private void LoadIfIsPKPiR()
        {
            this.sqlDataAdapter1.Fill(this.dataSet1, "WprowadzanieDokumentowTabela");
            dataGridView1.DataSource = dataSet1;
            dataGridView1.DataMember = "WprowadzanieDokumentowTabela";

            dataGridView1.Columns[sqlData[0]].Visible = false;
            dataGridView1.Columns[sqlData[1]].Visible = false;
            dataGridView1.Columns[sqlData[3]].Visible = false;
            dataGridView1.Columns[sqlData[8]].Visible = false;
            for (int i = 19; i < 36; i++)
                dataGridView1.Columns[sqlData[i]].Visible = false;
            for (int i = 39; i < 42; i++)
                dataGridView1.Columns[sqlData[i]].Visible = false;

            dataGridView1.Columns[sqlData[2]].HeaderText = "Konto ksigowe";
            dataGridView1.Columns[sqlData[5]].HeaderText = "Nr dokumentu";
            dataGridView1.Columns[sqlData[6]].HeaderText = "Data dokumentu";
            dataGridView1.Columns[sqlData[7]].HeaderText = "Dzien wpisu";
            dataGridView1.Columns[sqlData[12]].HeaderText = "Rodzaj rozliczenia";
            dataGridView1.Columns[sqlData[13]].HeaderText = "Forma patnosci";
            dataGridView1.Columns[sqlData[14]].HeaderText = "Termin zapaty";
            dataGridView1.Columns[sqlData[18]].HeaderText = "Data ksigowania";
            dataGridView1.Columns[sqlData[36]].HeaderText = "Razem netto";
            dataGridView1.Columns[sqlData[37]].HeaderText = "Razem VAT";
            dataGridView1.Columns[sqlData[38]].HeaderText = "Razem brutto";

            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[6]);
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[7]);
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[14]);
            MethodsClass.SetDateFormatDataGridView(dataGridView1, sqlData[18]);
            MethodsClass.SetMoneyFormatDataGridView(dataGridView1, "Zaplacono");
            for (int i = 36; i < 39; i++)
                MethodsClass.SetMoneyFormatDataGridView(dataGridView1, sqlData[i]);

            if (!MethodsClass.ExeFunctionRetBool("dbo.GetEwidencjaVAT()"))
            {
                dataGridView1.Columns["RazemNetto"].Visible = false;
                dataGridView1.Columns["RazemVAT"].Visible = false;
                dataGridView1.Columns["Rejestr"].Visible = false;
            }

            if (MethodsClass.IsNotEmptyTable("WprowadzanieDokumentowTabela") && (dataGridView1.Rows[0].Cells["DataDokumentu"].Value != null))
            { // load first item in the dataGridView if it's exist
                textBox1.Text = MethodsClass.GetLongMonthFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[7]].Value); //DzienWpisu
                textBox2.Text = dataGridView1.Rows[WybranyWiersz].Cells[sqlData[5]].Value.ToString();
                textBox3.Text = Convert.ToString(MethodsClass.GetShortDayFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value));
                textBox4.Text = Convert.ToString(MethodsClass.GetShortMonthFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value));
                textBox5.Text = Convert.ToString(MethodsClass.GetShortYearFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[6]].Value));
                textBox6.Text = dataGridView1.Rows[WybranyWiersz].Cells[sqlData[9]].Value.ToString();
                textBox7.Text = MethodsClass.KindRegisterDigitToString(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[16]].Value.ToString());
                nettoMoneyTextBox.Text = dataGridView1.Rows[WybranyWiersz].Cells[sqlData[36]].Value.ToString();
                VATMoneyTextBox.Text = dataGridView1.Rows[WybranyWiersz].Cells[sqlData[37]].Value.ToString();
                bruttoMoneyTextBox.Text = dataGridView1.Rows[WybranyWiersz].Cells[sqlData[38]].Value.ToString();
                textBox11.Text = MethodsClass.Miesiac[Convert.ToInt32(dataGridView1.Rows[WybranyWiersz].Cells[sqlData[19]].Value)-1];
            }
        }

        private void MouseClickWprowadzDokumRyczalt()
        {
            textBox1.Text = MethodsClass.GetLongMonthFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells["Dzie wpisu"].Value); //DzienWpisu
            textBox2.Text = dataGridView1.Rows[WybranyWiersz].Cells["Nr dokumentu"].Value.ToString();
            textBox3.Text = Convert.ToString(MethodsClass.GetShortDayFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells["Data wystawienia"].Value));
            textBox4.Text = Convert.ToString(MethodsClass.GetShortMonthFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells["Data wystawienia"].Value));
            textBox5.Text = Convert.ToString(MethodsClass.GetShortYearFromStringDate(dataGridView1.Rows[WybranyWiersz].Cells["Data wystawienia"].Value));
            textBox6.Text = dataGridView1.Rows[WybranyWiersz].Cells["Opis zdarzenia gospodarczego"].Value.ToString();
            textBox7.Text = MethodsClass.KindRegisterDigitToString(dataGridView1.Rows[WybranyWiersz].Cells["Rodzaj rejestru"].Value.ToString());
            nettoMoneyTextBox.Text = dataGridView1.Rows[WybranyWiersz].Cells["Razem netto"].Value.ToString();
            VATMoneyTextBox.Text = dataGridView1.Rows[WybranyWiersz].Cells["Razem VAT"].Value.ToString();
            bruttoMoneyTextBox.Text = dataGridView1.Rows[WybranyWiersz].Cells["Razem brutto"].Value.ToString();
            textBox11.Text = MethodsClass.Miesiac[Convert.ToInt32(dataGridView1.Rows[WybranyWiersz].Cells["Miesic zaliczenia do ewidencji VAT"].Value)];
        }

        private void LoadIfIsRyczalt()
        {
            this.sqlDataAdapter2.Fill(this.dataSet1, "WprowadzanieDokumentowRyczaltTabela");
            dataGridView1.DataSource = dataSet1;
            dataGridView1.DataMember = "WprowadzanieDokumentowRyczaltTabela";

            dataGridView1.Columns["WprowadzanieDokumentowID"].Visible = false;
            dataGridView1.Columns["KontoKsiegoweID"].Visible = false;
            dataGridView1.Columns["KontrahenciID"].Visible = false;
            dataGridView1.Columns["OpisZdarzenID"].Visible = false;
            dataGridView1.Columns["DowodyWewnetrzneID"].Visible = false;
            dataGridView1.Columns["EwidencjaSprzedazyID"].Visible = false;
            dataGridView1.Columns["EwidencjaWyposazeniaID"].Visible = false;
            for (int i=0; i<stawkiRyczalt.Length; i++)
                dataGridView1.Columns[stawkiRyczalt[i]].Visible = false;
            dataGridView1.Columns["Razem netto"].HeaderText = "Netto";
            dataGridView1.Columns["Razem VAT"].HeaderText = "VAT";
            dataGridView1.Columns["Razem brutto"].HeaderText = "Brutto";

            MethodsClass.SetDateFormatDataGridView(dataGridView1, "Data wystawienia");
            MethodsClass.SetDateFormatDataGridView(dataGridView1, "Dzie wpisu");
            MethodsClass.SetDateFormatDataGridView(dataGridView1, "Termin zapaty");
            MethodsClass.SetDateFormatDataGridView(dataGridView1, "Data otrzymania obow. podat.");
            for (int i=0; i<stawkiRyczalt.Length; i++)
                MethodsClass.SetMoneyFormatDataGridView(dataGridView1, stawkiRyczalt[i]);
            MethodsClass.SetMoneyFormatDataGridView(dataGridView1, "Razem netto");
            MethodsClass.SetMoneyFormatDataGridView(dataGridView1, "Razem VAT");
            MethodsClass.SetMoneyFormatDataGridView(dataGridView1, "Razem brutto");

            if (!MethodsClass.ExeFunctionRetBool("dbo.GetEwidencjaVAT()"))
            {
                dataGridView1.Columns["Razem netto"].Visible = false;
                dataGridView1.Columns["Razem VAT"].Visible = false;
                dataGridView1.Columns["Rodzaj rejestru"].Visible = false;
            }

            if (MethodsClass.IsNotEmptyTable("WprowadzanieDokumentowRyczaltTabela") && (dataGridView1.Rows[0].Cells["Data wystawienia"].Value != null)) // load first item in the dataGridView if it's exist
                MouseClickWprowadzDokumRyczalt();
        }
        #endregion

        #region EventHandlers
        private void WprowadzanieDokumentow_Load(object sender, EventArgs e)
        { // create table if it does not exist
            Server server = null;
            if (!MethodsClass.DbTableExists("WprowadzanieDokumentowTabela", MethodsClass.sConnectionString))
            {
                SqlConnection conn = null;                
                try
                {
                    FileInfo file = new FileInfo("../../../SqlServerProject/CreateTableWprowadzanieDokumentow.sql");
                    string script = file.OpenText().ReadToEnd();
                    conn = new SqlConnection(MethodsClass.sConnectionString);
                    server = new Server(new ServerConnection(conn));
                    server.ConnectionContext.ExecuteNonQuery(script);
                }
                catch (System.InvalidOperationException ex)
                {
                    MethodsClass.InvalidOperationExceptionFunction(ex);
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    MethodsClass.SqlExceptionFunction(ex);
                }
                catch (System.Exception ex)
                {
                    MethodsClass.GenericExceptionFunction(ex);
                }
                finally
                {
                    MethodsClass.FinallyExceptionFunction(conn);
                }
            }

            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
                LoadIfIsPKPiR();
            else
                LoadIfIsRyczalt();

            dataGridView1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        }

        private void Nowy_Click(object sender, EventArgs e)
        {
            NowyWprowadzanyDokument nowyWprowDokum = new NowyWprowadzanyDokument((object)this, 1, 0, -1); // set 1 when we clicked Nowy button
            // first value is object from which we call form; second value if equal: 0 - call NowyWprowadzanyDokument previously entered data, 
            // 1 - call empty NowyWprowadzanyDokument Form, 2 - call NowyWprowadzanyDokument from DowodyWewnetrzne form, 3 - call NowyWprowadzanyDokument from EwidencjaSprzeday form, 
            //4 - call NowyWprowadzanyDokument from EwidencjaWyposazenia form; third value set sum of value; four value set selected row

            if (nowyWprowDokum.ShowDialog() == DialogResult.OK) 
                nowyWprowDokum.Close();
        }

        private void Usu_Click(object sender, EventArgs e)
        {
            if (MethodsClass.CzyUsunac())
            {
                if (MethodsClass.ifSelectedRow(dataGridView1))
                {
                    if (dataGridView1.Rows[WybranyWiersz].Cells["Kontrahent"].Value != null) // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                    {
                        dataGridView1.Rows.Remove(dataGridView1.SelectedRows[0]);
                    }
                    else
                    {
                        MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                    }
                }
                else
                {
                    MethodsClass.MesBoxShowError("Wybierz jeden wiersz", "Bd");
                }
            }
        }

        private void ZmieMiesic_Click(object sender, EventArgs e)
        {
            ZmianaMiesiacaKsiegowego zmianaMiesKsieg = new ZmianaMiesiacaKsiegowego();
            if (zmianaMiesKsieg.ShowDialog() == DialogResult.OK)
                zmianaMiesKsieg.Close();
        }
        
        private void Wyjcie_Click(object sender, EventArgs e)
        {
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                if (this.dataSet1 != null && this.dataSet1.HasChanges())
                    sqlDataAdapter1.Update(dataSet1, "WprowadzanieDokumentowTabela");
            }
            else
            {
                if (this.dataSet1 != null && this.dataSet1.HasChanges())
                    sqlDataAdapter2.Update(dataSet1, "WprowadzanieDokumentowRyczaltTabela");
            }
        }

        private void dataGridView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (dataGridView1.Rows[WybranyWiersz].Cells["Kontrahent"].Value.ToString() != "") // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    NowyWprowadzanyDokument edytujWprowDokum = new NowyWprowadzanyDokument((object)this, 0, 0, -1); 
                    // first value is object from which we call form; second value if equal: 0 - call NowyWprowadzanyDokument previously entered data, 
                    // 1 - call empty NowyWprowadzanyDokument Form, 2 - call NowyWprowadzanyDokument from DowodyWewnetrzne form, 3 - call NowyWprowadzanyDokument from EwidencjaSprzeday form, 
                    //4 - call NowyWprowadzanyDokument from EwidencjaWyposazenia form; third value set sum of value; four value set selected row

                    edytujWprowDokum.Text = "Edycja wprowadzonego dokumentu";
                    int ww = WybranyWiersz;

                    comboBoxKontrahent = dataGridView1.Rows[ww].Cells["Kontrahent"].Value.ToString();
                    comboBoxOpisZdarzeniaGosp = dataGridView1.Rows[ww].Cells["Opis zdarzenia gospodarczego"].Value.ToString();
                    
                    if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
                    {
                        comboBoxRejestr = MethodsClass.KindRegisterDigitToString(dataGridView1.Rows[ww].Cells["Rejestr"].Value);
                        comboBoxKontoKsiegowe = dataGridView1.Rows[ww].Cells["KontoKsiegowe"].Value + " - " + MethodsClass.ExeStoredProcedureRetString("uspGetNazwaKontoKsiegowe", "KontoKsiegowe", dataGridView1.Rows[ww].Cells["KontoKsiegowe"].Value);
                        edytujWprowDokum.Edytuj(dataGridView1.Rows[ww].Cells["NrDokumentu"].Value, dataGridView1.Rows[ww].Cells["DataDokumentu"].Value, dataGridView1.Rows[WybranyWiersz].Cells["DzienWpisu"].Value,
    dataGridView1.Rows[ww].Cells["Uwagi"].Value, dataGridView1.Rows[ww].Cells["Notatki"].Value,
    dataGridView1.Rows[ww].Cells["RodzajRozliczenia"].Value, dataGridView1.Rows[ww].Cells["FormaPlatnosci"].Value,
    dataGridView1.Rows[ww].Cells["TerminZaplaty"].Value, dataGridView1.Rows[ww].Cells["Zaplacono"].Value,
    dataGridView1.Rows[ww].Cells["Transakcja"].Value, dataGridView1.Rows[ww].Cells["DataKsiegowania"].Value,
    dataGridView1.Rows[ww].Cells["MiesiacZaliczenia"].Value, dataGridView1.Rows[ww].Cells[stawki[0]].Value, dataGridView1.Rows[ww].Cells[stawki[1]].Value,
    dataGridView1.Rows[ww].Cells[stawki[2]].Value, dataGridView1.Rows[ww].Cells[stawki[3]].Value, dataGridView1.Rows[ww].Cells[stawki[4]].Value,
    dataGridView1.Rows[ww].Cells[stawki[5]].Value, dataGridView1.Rows[ww].Cells[stawki[6]].Value, dataGridView1.Rows[ww].Cells[stawki[7]].Value,
    dataGridView1.Rows[ww].Cells[stawki[8]].Value, dataGridView1.Rows[ww].Cells[stawki[9]].Value, dataGridView1.Rows[ww].Cells[stawki[10]].Value,
    dataGridView1.Rows[ww].Cells[stawki[11]].Value, dataGridView1.Rows[ww].Cells[stawki[12]].Value, dataGridView1.Rows[ww].Cells[stawki[13]].Value,
    dataGridView1.Rows[ww].Cells[stawki[14]].Value, dataGridView1.Rows[ww].Cells[stawki[15]].Value, dataGridView1.Rows[ww].Cells[stawki[16]].Value,
    dataGridView1.Rows[ww].Cells[stawki[17]].Value, dataGridView1.Rows[ww].Cells[stawki[18]].Value, dataGridView1.Rows[ww].Cells[sqlData[19]].Value);
                    }
                    else
                    {
                        comboBoxRejestr = MethodsClass.KindRegisterDigitToString(dataGridView1.Rows[ww].Cells["Rodzaj rejestru"].Value);
                        comboBoxKontoKsiegowe = dataGridView1.Rows[ww].Cells["Konto ksigowe"].Value + " - " + MethodsClass.ExeStoredProcedureRetString("uspGetNazwaKontoKsiegoweRyczalt", "KontoKsiegoweID", dataGridView1.Rows[ww].Cells["KontoKsiegoweID"].Value);
                        edytujWprowDokum.Edytuj(dataGridView1.Rows[ww].Cells["Nr dokumentu"].Value, dataGridView1.Rows[ww].Cells["Data wystawienia"].Value, dataGridView1.Rows[WybranyWiersz].Cells["Dzie wpisu"].Value,
    dataGridView1.Rows[ww].Cells["Uwagi"].Value, dataGridView1.Rows[ww].Cells["Notatki"].Value,
    dataGridView1.Rows[ww].Cells["Rodzaj rozliczenia"].Value, dataGridView1.Rows[ww].Cells["Forma patnoci"].Value,
    dataGridView1.Rows[ww].Cells["Termin zapaty"].Value, dataGridView1.Rows[ww].Cells["Zapacono"].Value,
    dataGridView1.Rows[ww].Cells["Transakcja"].Value, dataGridView1.Rows[ww].Cells["Data otrzymania obow. podat."].Value,
    dataGridView1.Rows[ww].Cells["Miesic zaliczenia do ewidencji VAT"].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[0]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[1]].Value,
    dataGridView1.Rows[ww].Cells[stawkiRyczalt[2]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[3]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[4]].Value,
    dataGridView1.Rows[ww].Cells[stawkiRyczalt[5]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[6]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[7]].Value,
    dataGridView1.Rows[ww].Cells[stawkiRyczalt[8]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[9]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[10]].Value,
    dataGridView1.Rows[ww].Cells[stawkiRyczalt[11]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[12]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[13]].Value,
    dataGridView1.Rows[ww].Cells[stawkiRyczalt[14]].Value, dataGridView1.Rows[ww].Cells[stawkiRyczalt[15]].Value, dataGridView1.Rows[ww].Cells["Razem netto"].Value,
    dataGridView1.Rows[ww].Cells["Razem VAT"].Value, dataGridView1.Rows[ww].Cells["Razem brutto"].Value);
                    }
                    if (edytujWprowDokum.ShowDialog() == DialogResult.OK)
                        edytujWprowDokum.Close();
                }
                else
                {
                    MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                }
            }
            else
            {
                MethodsClass.MesBoxShowError("Wybierz jeden wiersz", "Bd");
            }
        }

        private void dataGridView1_MouseClick(object sender, MouseEventArgs e)
        {
            if (MethodsClass.ifSelectedRow(dataGridView1))
            {
                if (dataGridView1.Rows[WybranyWiersz].Cells["Kontrahent"].Value.ToString() != "") // check if cell DataNabycia isn' t equal null (this is the last row in the DataGridView)
                {
                    if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
                    {
                        int ww = WybranyWiersz;
                        textBox1.Text = MethodsClass.GetLongMonthFromStringDate(dataGridView1.Rows[ww].Cells[sqlData[7]].Value); //DzienWpisu
                        textBox2.Text = dataGridView1.Rows[ww].Cells[sqlData[5]].Value.ToString();
                        textBox3.Text = Convert.ToString(MethodsClass.GetShortDayFromStringDate(dataGridView1.Rows[ww].Cells[sqlData[6]].Value));
                        textBox4.Text = Convert.ToString(MethodsClass.GetShortMonthFromStringDate(dataGridView1.Rows[ww].Cells[sqlData[6]].Value));
                        textBox5.Text = Convert.ToString(MethodsClass.GetShortYearFromStringDate(dataGridView1.Rows[ww].Cells[sqlData[6]].Value));
                        textBox6.Text = dataGridView1.Rows[ww].Cells[sqlData[9]].Value.ToString();
                        textBox7.Text = MethodsClass.KindRegisterDigitToString(dataGridView1.Rows[ww].Cells[sqlData[16]].Value.ToString());
                        nettoMoneyTextBox.Text = dataGridView1.Rows[ww].Cells[sqlData[36]].Value.ToString();
                        VATMoneyTextBox.Text = dataGridView1.Rows[ww].Cells[sqlData[37]].Value.ToString();
                        bruttoMoneyTextBox.Text = dataGridView1.Rows[ww].Cells[sqlData[38]].Value.ToString();
                        textBox11.Text = MethodsClass.Miesiac[Convert.ToInt32(dataGridView1.Rows[ww].Cells[sqlData[19]].Value)-1];
                    }
                    else
                    {
                        MouseClickWprowadzDokumRyczalt();
                    }
                }
                else
                {
                    MethodsClass.MesBoxShowInformation("Wybierz jeden z powyszych wierszy", "Nieprawidowy wiersz");
                }
            }
            else
            {
                MethodsClass.MesBoxShowError("Wybierz jeden wiersz", "Bd");
            }
        }

        private void ksieguj_Click(object sender, EventArgs e)
        {
            Wyjcie_Click(sender, e); 

            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                MethodsClass.ExeUspUpdateBooked("uspUpdateBookedCellInWprowadzanieDokumentow", "id", dataGridView1.Rows[WybranyWiersz].Cells["WprowadzanieDokumentowID"].Value, "boolValue", true);
            }
            else
            {
                MethodsClass.ExeUspUpdateBooked("uspUpdateBookedCellInWprowadzanieDokumentowRyczalt", "id", dataGridView1.Rows[WybranyWiersz].Cells["WprowadzanieDokumentowID"].Value, "boolValue", true);
            }

            MethodsClass.MesBoxShowInformation("Dokument zosta zaksigowany", "Informacja");
            Wyjcie_Click(sender, e);
            dataSet1.Clear();
            if (MethodsClass.ExeFunctionRetBool("dbo.IfPKPiR()"))
            {
                this.sqlDataAdapter1.Fill(this.dataSet1, "WprowadzanieDokumentowTabela");
                dataGridView1.DataSource = dataSet1;
                dataGridView1.DataMember = "WprowadzanieDokumentowTabela";
            }
            else
            {
                this.sqlDataAdapter2.Fill(this.dataSet1, "WprowadzanieDokumentowRyczaltTabela");
                dataGridView1.DataSource = dataSet1;
                dataGridView1.DataMember = "WprowadzanieDokumentowRyczaltTabela";
            }
        }

        private void dataGridView1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.RowIndex % 2 == 1)   // odd rows have blue background   
                e.CellStyle.BackColor = Color.Lavender;
        }
        #endregion
    }
}