using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ProgramDB
{
    public partial class WybierzFiltrEwidenPojazdow : Form
    {
        private EwidencjaKosztowPojazdow ekp;
        private EwidencjaPrzebieguPojazdow epp;
        private object thisObject = null;
        public WybierzFiltrEwidenPojazdow(object ew)
        {
            InitializeComponent();
            thisObject = ew;
            if (ew is EwidencjaKosztowPojazdow)
                ekp = (EwidencjaKosztowPojazdow)ew;
            else // if (ew is EwidencjaPrzebieguPojazdow)
                epp = (EwidencjaPrzebieguPojazdow)ew; 
        }

        private void WybierzFiltrEwidenPrzebPojazdu_Load(object sender, EventArgs e)
        {
            MethodsClass.ExeReaderComboBox(pojazdComboBox, "SELECT NazwaPojazdu, NrRejestracyjny FROM PojazdyPrywatneTabela", '-');
        }

        private void UstawFiltr_Click(object sender, EventArgs e)
        {
            if ((miesiacCheckBox.Checked && (miesiacComboBox.Text == "")) || (pojazdCheckBox.Checked && (pojazdComboBox.Text == "")))
            {
                MethodsClass.MesBoxShowInformation("Wybierz warto w zaznaczonej pozycji", "Niepowodzenie");
                Close();
                return;
            }
            if (thisObject is EwidencjaKosztowPojazdow)
                ekp.FiltrEwidenKosztPojazd(miesiacCheckBox.Checked, miesiacComboBox.Text, pojazdCheckBox.Checked, pojazdComboBox.Text);
            else // if (thisObject is EwidencjaPrzebieguPojazdow)
                epp.FiltrEwidenPrzebiegPojazd(miesiacCheckBox.Checked, miesiacComboBox.Text, pojazdCheckBox.Checked, pojazdComboBox.Text);                
        }
    }
}