USE BazaDanychFileStream
GO

CREATE TABLE WprowadzanieDokumentowTabela (WprowadzanieDokumentowID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY, 
KontoKsiegoweID INT NOT NULL CONSTRAINT ForeignRefsKontoKsiegowe FOREIGN KEY(KontoKsiegoweID) REFERENCES KontoKsiegoweTabela (KontoKsiegoweID),
[Kolumna ksiki] INT NULL, 
KontrahenciID INT NOT NULL CONSTRAINT ForeignRefsKontrahent FOREIGN KEY(KontrahenciID) REFERENCES KontrahenciTabela (KontrahenciID), 
NrDokumentu NVARCHAR(50) NULL, DataDokumentu DATETIME NOT NULL, DzienWpisu DATETIME NOT NULL, 
OpisZdarzenID INT NOT NULL CONSTRAINT ForeignRefsOpisZdarzenGosp
FOREIGN KEY(OpisZdarzenID) REFERENCES OpisZdarzenGospTabela (OpisZdarzenID), 
Uwagi NVARCHAR(50) NULL, Notatki NVARCHAR(50) NULL, 
RodzajRozliczenia NVARCHAR(50) NULL, FormaPlatnosci NVARCHAR(50) NULL,
TerminZaplaty DATETIME NOT NULL, Zaplacono MONEY NULL, Rejestr NVARCHAR(50) NULL, 
Transakcja NVARCHAR(50) NULL, DataKsiegowania DATETIME NOT NULL, 
MiesiacZaliczenia INT NOT NULL,
Stawka22Netto MONEY NULL, Stawka22VAT MONEY NULL, Stawka22Brutto MONEY NULL, 
Stawka7Netto MONEY NULL, Stawka7VAT MONEY NULL, Stawka7Brutto MONEY NULL, 
Stawka6Netto MONEY NULL, Stawka6VAT MONEY NULL, Stawka6Brutto MONEY NULL, 
Stawka3Netto MONEY NULL, Stawka3VAT MONEY NULL, Stawka3Brutto MONEY NULL, 
Stawka0 MONEY NULL, Zwolnione MONEY NULL, BezRozliczen MONEY NULL, NiePodlega MONEY NULL,
RazemNetto MONEY NULL, RazemVAT MONEY NULL, RazemBrutto MONEY NULL,  
DowodyWewnetrzneID INT NULL CONSTRAINT ForeignRefsDowodyWewnetrzne FOREIGN KEY(DowodyWewnetrzneID) REFERENCES DowodyWewnetrzneTabela (DowodyWewnetrzneID), 
EwidencjaSprzedazyID INT NULL, EwidencjaWyposazeniaID INT NULL, 
CONSTRAINT conMiesiacZaliczenia CHECK (MiesiacZaliczenia > 0 AND MiesiacZaliczenia < 13),
CONSTRAINT conKolumnaKsiazki CHECK (KolumnaKsiazki > 6 AND KolumnaKsiazki < 16)
)
GO

ALTER TABLE WprowadzanieDokumentowTabela
ADD CONSTRAINT ForeignRefsEwidencjaSprzedazy FOREIGN KEY(EwidencjaSprzedazyID) REFERENCES EwidencjaSprzedazyTabela (EwidencjaSprzedazyID), 
CONSTRAINT ForeignRefsEwidencjaWyposazenia FOREIGN KEY(EwidencjaWyposazeniaID) REFERENCES EwidencjaWyposazeniaTabela (EwidencjaWyposazeniaID)
GO




